/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the M68k target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::PredicateBitsetImpl<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(M68kInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(M68kInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ISelInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ISelInfo;
  static M68kInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static M68kInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const int64_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const std::array<const MachineOperand *, 3> &Operands) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ISelInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_IsPICBit = 0,
  Feature_IsNotPICBit = 1,
  Feature_AtLeastM68020Bit = 2,
};

PredicateBitset M68kInstructionSelector::
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const {
  PredicateBitset Features;
  if (TM.isPositionIndependent())
    Features.set(Feature_IsPICBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->atLeastM68020())
    Features.set(Feature_AtLeastM68020Bit);
  return Features;
}

void M68kInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const M68kSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset M68kInstructionSelector::
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features;
  return Features;
}

// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 3;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
};

// Feature bitsets.
enum {
  GIFBS_Invalid,
};
const static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

// PatFrag predicates.
enum {
  GIPFP_I64_Predicate_Mximm16_1to8 = GIPFP_I64_Invalid + 1,
  GIPFP_I64_Predicate_Mximm32_1to8,
  GIPFP_I64_Predicate_Mximm8_1to8,
};
bool M68kInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GIPFP_I64_Predicate_Mximm16_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  case GIPFP_I64_Predicate_Mximm32_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  case GIPFP_I64_Predicate_Mximm8_1to8: {
     return Imm >= 1 && Imm <= 8; 
    llvm_unreachable("ImmediateCode should have returned");
    return false;
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool M68kInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const std::array<const MachineOperand *, 3> &Operands) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}

M68kInstructionSelector::ComplexMatcherMemFn
M68kInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// Custom renderers.
enum {
  GICR_Invalid,
};
M68kInstructionSelector::CustomRendererFn
M68kInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool M68kInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  MachineFunction &MF = *I.getParent()->getParent();
  MachineRegisterInfo &MRI = MF.getRegInfo();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  NewMIVector OutMIs;
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, OutMIs, State, ISelInfo, getMatchTable(), TII, MRI, TRI, RBI, AvailableFeatures, CoverageInfo)) {
    return true;
  }

  return false;
}

const int64_t *M68kInstructionSelector::getMatchTable() const {
  constexpr static int64_t MatchTable0[] = {
    GIM_SwitchOpcode, /*MI*/0, /*[*/46, 128, /*)*//*default:*//*Label 15*/ 2386,
    /*TargetOpcode::G_ADD*//*Label 0*/ 87,
    /*TargetOpcode::G_SUB*//*Label 1*/ 271, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_AND*//*Label 2*/ 521,
    /*TargetOpcode::G_OR*//*Label 3*/ 705,
    /*TargetOpcode::G_XOR*//*Label 4*/ 889, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
    /*TargetOpcode::G_ANYEXT*//*Label 5*/ 1073,
    /*TargetOpcode::G_TRUNC*//*Label 6*/ 1123,
    /*TargetOpcode::G_CONSTANT*//*Label 7*/ 1161, 0, 0, 0,
    /*TargetOpcode::G_SEXT*//*Label 8*/ 1321, 0,
    /*TargetOpcode::G_ZEXT*//*Label 9*/ 1371,
    /*TargetOpcode::G_SHL*//*Label 10*/ 1421,
    /*TargetOpcode::G_LSHR*//*Label 11*/ 1614,
    /*TargetOpcode::G_ASHR*//*Label 12*/ 1807, 0, 0,
    /*TargetOpcode::G_ROTR*//*Label 13*/ 2000,
    /*TargetOpcode::G_ROTL*//*Label 14*/ 2193,
    // Label 0: @87
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 19*/ 270,
    /*GILLT_s8*//*Label 16*/ 96,
    /*GILLT_s16*//*Label 17*/ 154,
    /*GILLT_s32*//*Label 18*/ 212,
    // Label 16: @96
    GIM_Try, /*On fail goto*//*Label 20*/ 153,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 21*/ 140, // Rule ID 677 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (ADD8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 677,
        GIR_Done,
      // Label 21: @140
      GIM_Try, /*On fail goto*//*Label 22*/ 152, // Rule ID 665 //
        // (add:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ADD8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 665,
        GIR_Done,
      // Label 22: @152
      GIM_Reject,
    // Label 20: @153
    GIM_Reject,
    // Label 17: @154
    GIM_Try, /*On fail goto*//*Label 23*/ 211,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 24*/ 198, // Rule ID 678 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (ADD16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 678,
        GIR_Done,
      // Label 24: @198
      GIM_Try, /*On fail goto*//*Label 25*/ 210, // Rule ID 666 //
        // (add:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ADD16dr:{ *:[i16] }:{ *:[i8] } MxXRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD16dr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 666,
        GIR_Done,
      // Label 25: @210
      GIM_Reject,
    // Label 23: @211
    GIM_Reject,
    // Label 18: @212
    GIM_Try, /*On fail goto*//*Label 26*/ 269,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 27*/ 256, // Rule ID 679 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (ADD32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ADD32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 679,
        GIR_Done,
      // Label 27: @256
      GIM_Try, /*On fail goto*//*Label 28*/ 268, // Rule ID 667 //
        // (add:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ADD32dr:{ *:[i32] }:{ *:[i8] } MxXRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ADD32dr,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 667,
        GIR_Done,
      // Label 28: @268
      GIM_Reject,
    // Label 26: @269
    GIM_Reject,
    // Label 19: @270
    GIM_Reject,
    // Label 1: @271
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 32*/ 520,
    /*GILLT_s8*//*Label 29*/ 280,
    /*GILLT_s16*//*Label 30*/ 360,
    /*GILLT_s32*//*Label 31*/ 440,
    // Label 29: @280
    GIM_Try, /*On fail goto*//*Label 33*/ 359,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 34*/ 316, // Rule ID 529 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i8] } 0:{ *:[i8] }, i8:{ *:[i8] }:$src)  =>  (NEG8d:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG8d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 529,
        GIR_Done,
      // Label 34: @316
      GIM_Try, /*On fail goto*//*Label 35*/ 346, // Rule ID 716 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (SUB8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 716,
        GIR_Done,
      // Label 35: @346
      GIM_Try, /*On fail goto*//*Label 36*/ 358, // Rule ID 704 //
        // (sub:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SUB8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 704,
        GIR_Done,
      // Label 36: @358
      GIM_Reject,
    // Label 33: @359
    GIM_Reject,
    // Label 30: @360
    GIM_Try, /*On fail goto*//*Label 37*/ 439,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 38*/ 396, // Rule ID 531 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i16] } 0:{ *:[i16] }, i16:{ *:[i16] }:$src)  =>  (NEG16d:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG16d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 531,
        GIR_Done,
      // Label 38: @396
      GIM_Try, /*On fail goto*//*Label 39*/ 426, // Rule ID 717 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (SUB16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 717,
        GIR_Done,
      // Label 39: @426
      GIM_Try, /*On fail goto*//*Label 40*/ 438, // Rule ID 705 //
        // (sub:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SUB16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 705,
        GIR_Done,
      // Label 40: @438
      GIM_Reject,
    // Label 37: @439
    GIM_Reject,
    // Label 31: @440
    GIM_Try, /*On fail goto*//*Label 41*/ 519,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 42*/ 476, // Rule ID 533 //
        GIM_CheckConstantInt, /*MI*/0, /*Op*/1, 0,
        // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG32d:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::NEG32d,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/2, // src
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 533,
        GIR_Done,
      // Label 42: @476
      GIM_Try, /*On fail goto*//*Label 43*/ 506, // Rule ID 718 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (SUB32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SUB32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 718,
        GIR_Done,
      // Label 43: @506
      GIM_Try, /*On fail goto*//*Label 44*/ 518, // Rule ID 706 //
        // (sub:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SUB32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SUB32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 706,
        GIR_Done,
      // Label 44: @518
      GIM_Reject,
    // Label 41: @519
    GIM_Reject,
    // Label 32: @520
    GIM_Reject,
    // Label 2: @521
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 48*/ 704,
    /*GILLT_s8*//*Label 45*/ 530,
    /*GILLT_s16*//*Label 46*/ 588,
    /*GILLT_s32*//*Label 47*/ 646,
    // Label 45: @530
    GIM_Try, /*On fail goto*//*Label 49*/ 587,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 50*/ 574, // Rule ID 746 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (AND8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 746,
        GIR_Done,
      // Label 50: @574
      GIM_Try, /*On fail goto*//*Label 51*/ 586, // Rule ID 743 //
        // (and:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (AND8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 743,
        GIR_Done,
      // Label 51: @586
      GIM_Reject,
    // Label 49: @587
    GIM_Reject,
    // Label 46: @588
    GIM_Try, /*On fail goto*//*Label 52*/ 645,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 53*/ 632, // Rule ID 747 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (AND16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 747,
        GIR_Done,
      // Label 53: @632
      GIM_Try, /*On fail goto*//*Label 54*/ 644, // Rule ID 744 //
        // (and:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (AND16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 744,
        GIR_Done,
      // Label 54: @644
      GIM_Reject,
    // Label 52: @645
    GIM_Reject,
    // Label 47: @646
    GIM_Try, /*On fail goto*//*Label 55*/ 703,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 56*/ 690, // Rule ID 748 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (AND32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::AND32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 748,
        GIR_Done,
      // Label 56: @690
      GIM_Try, /*On fail goto*//*Label 57*/ 702, // Rule ID 745 //
        // (and:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (AND32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::AND32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 745,
        GIR_Done,
      // Label 57: @702
      GIM_Reject,
    // Label 55: @703
    GIM_Reject,
    // Label 48: @704
    GIM_Reject,
    // Label 3: @705
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 61*/ 888,
    /*GILLT_s8*//*Label 58*/ 714,
    /*GILLT_s16*//*Label 59*/ 772,
    /*GILLT_s32*//*Label 60*/ 830,
    // Label 58: @714
    GIM_Try, /*On fail goto*//*Label 62*/ 771,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 63*/ 758, // Rule ID 752 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (OR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 752,
        GIR_Done,
      // Label 63: @758
      GIM_Try, /*On fail goto*//*Label 64*/ 770, // Rule ID 749 //
        // (or:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (OR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 749,
        GIR_Done,
      // Label 64: @770
      GIM_Reject,
    // Label 62: @771
    GIM_Reject,
    // Label 59: @772
    GIM_Try, /*On fail goto*//*Label 65*/ 829,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 66*/ 816, // Rule ID 753 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (OR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 753,
        GIR_Done,
      // Label 66: @816
      GIM_Try, /*On fail goto*//*Label 67*/ 828, // Rule ID 750 //
        // (or:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (OR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 750,
        GIR_Done,
      // Label 67: @828
      GIM_Reject,
    // Label 65: @829
    GIM_Reject,
    // Label 60: @830
    GIM_Try, /*On fail goto*//*Label 68*/ 887,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 69*/ 874, // Rule ID 754 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (OR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::OR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 754,
        GIR_Done,
      // Label 69: @874
      GIM_Try, /*On fail goto*//*Label 70*/ 886, // Rule ID 751 //
        // (or:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (OR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::OR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 751,
        GIR_Done,
      // Label 70: @886
      GIM_Reject,
    // Label 68: @887
    GIM_Reject,
    // Label 61: @888
    GIM_Reject,
    // Label 4: @889
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 74*/ 1072,
    /*GILLT_s8*//*Label 71*/ 898,
    /*GILLT_s16*//*Label 72*/ 956,
    /*GILLT_s32*//*Label 73*/ 1014,
    // Label 71: @898
    GIM_Try, /*On fail goto*//*Label 75*/ 955,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 76*/ 942, // Rule ID 758 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)  =>  (XOR8di:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 758,
        GIR_Done,
      // Label 76: @942
      GIM_Try, /*On fail goto*//*Label 77*/ 954, // Rule ID 755 //
        // (xor:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (XOR8dd:{ *:[i8] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src, MxDRD8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 755,
        GIR_Done,
      // Label 77: @954
      GIM_Reject,
    // Label 75: @955
    GIM_Reject,
    // Label 72: @956
    GIM_Try, /*On fail goto*//*Label 78*/ 1013,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 79*/ 1000, // Rule ID 759 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)  =>  (XOR16di:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 759,
        GIR_Done,
      // Label 79: @1000
      GIM_Try, /*On fail goto*//*Label 80*/ 1012, // Rule ID 756 //
        // (xor:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (XOR16dd:{ *:[i16] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src, MxDRD16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 756,
        GIR_Done,
      // Label 80: @1012
      GIM_Reject,
    // Label 78: @1013
    GIM_Reject,
    // Label 73: @1014
    GIM_Try, /*On fail goto*//*Label 81*/ 1071,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 82*/ 1058, // Rule ID 760 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)  =>  (XOR32di:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::XOR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 760,
        GIR_Done,
      // Label 82: @1058
      GIM_Try, /*On fail goto*//*Label 83*/ 1070, // Rule ID 757 //
        // (xor:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (XOR32dd:{ *:[i32] }:{ *:[i8] } MxDRD32:{ *:[i32] }:$src, MxDRD32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::XOR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 757,
        GIR_Done,
      // Label 83: @1070
      GIM_Reject,
    // Label 81: @1071
    GIM_Reject,
    // Label 74: @1072
    GIM_Reject,
    // Label 5: @1073
    GIM_Try, /*On fail goto*//*Label 84*/ 1122,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 87*/ 1121,
      /*GILLT_s8*//*Label 85*/ 1087,
      /*GILLT_s16*//*Label 86*/ 1104,
      // Label 85: @1087
      GIM_Try, /*On fail goto*//*Label 88*/ 1103, // Rule ID 626 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (anyext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 626,
        GIR_Done,
      // Label 88: @1103
      GIM_Reject,
      // Label 86: @1104
      GIM_Try, /*On fail goto*//*Label 89*/ 1120, // Rule ID 630 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (anyext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 630,
        GIR_Done,
      // Label 89: @1120
      GIM_Reject,
      // Label 87: @1121
      GIM_Reject,
    // Label 84: @1122
    GIM_Reject,
    // Label 6: @1123
    GIM_Try, /*On fail goto*//*Label 90*/ 1160, // Rule ID 634 //
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // (trunc:{ *:[i16] } i32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } MxXRD32:{ *:[i32] }:$src, MxSubRegIndex16Lo:{ *:[i32] })
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/TargetOpcode::COPY,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/2, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, M68k::XR16RegClassID,
      GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, M68k::XR32RegClassID,
      // GIR_Coverage, 634,
      GIR_Done,
    // Label 90: @1160
    GIM_Reject,
    // Label 7: @1161
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 94*/ 1320,
    /*GILLT_s8*//*Label 91*/ 1170,
    /*GILLT_s16*//*Label 92*/ 1192,
    /*GILLT_s32*//*Label 93*/ 1256,
    // Label 91: @1170
    GIM_Try, /*On fail goto*//*Label 95*/ 1191, // Rule ID 84 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i8] }):$src  =>  (MOV8di:{ *:[i8] }:{ *:[i8] } (imm:{ *:[i8] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV8di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 84,
      GIR_Done,
    // Label 95: @1191
    GIM_Reject,
    // Label 92: @1192
    GIM_Try, /*On fail goto*//*Label 96*/ 1213, // Rule ID 80 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 80,
      GIR_Done,
    // Label 96: @1213
    GIM_Try, /*On fail goto*//*Label 97*/ 1234, // Rule ID 82 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16ai:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 82,
      GIR_Done,
    // Label 97: @1234
    GIM_Try, /*On fail goto*//*Label 98*/ 1255, // Rule ID 85 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i16] }):$src  =>  (MOV16di:{ *:[i16] }:{ *:[i8] } (imm:{ *:[i16] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV16di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 85,
      GIR_Done,
    // Label 98: @1255
    GIM_Reject,
    // Label 93: @1256
    GIM_Try, /*On fail goto*//*Label 99*/ 1277, // Rule ID 81 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ri,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 81,
      GIR_Done,
    // Label 99: @1277
    GIM_Try, /*On fail goto*//*Label 100*/ 1298, // Rule ID 83 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::AR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32ai:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32ai,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 83,
      GIR_Done,
    // Label 100: @1298
    GIM_Try, /*On fail goto*//*Label 101*/ 1319, // Rule ID 86 //
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      // MIs[0] Operand 1
      // No operand predicates
      // (imm:{ *:[i32] }):$src  =>  (MOV32di:{ *:[i32] }:{ *:[i8] } (imm:{ *:[i32] }):$src)
      GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::MOV32di,
      GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
      GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
      GIR_EraseFromParent, /*InsnID*/0,
      GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
      // GIR_Coverage, 86,
      GIR_Done,
    // Label 101: @1319
    GIM_Reject,
    // Label 94: @1320
    GIM_Reject,
    // Label 8: @1321
    GIM_Try, /*On fail goto*//*Label 102*/ 1370,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 105*/ 1369,
      /*GILLT_s8*//*Label 103*/ 1335,
      /*GILLT_s16*//*Label 104*/ 1352,
      // Label 103: @1335
      GIM_Try, /*On fail goto*//*Label 106*/ 1351, // Rule ID 602 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (sext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVSXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 602,
        GIR_Done,
      // Label 106: @1351
      GIM_Reject,
      // Label 104: @1352
      GIM_Try, /*On fail goto*//*Label 107*/ 1368, // Rule ID 606 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (sext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVSXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVSXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 606,
        GIR_Done,
      // Label 107: @1368
      GIM_Reject,
      // Label 105: @1369
      GIM_Reject,
    // Label 102: @1370
    GIM_Reject,
    // Label 9: @1371
    GIM_Try, /*On fail goto*//*Label 108*/ 1420,
      GIM_CheckType, /*MI*/0, /*Op*/0, /*Type*/GILLT_s32,
      GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/0, 2, /*)*//*default:*//*Label 111*/ 1419,
      /*GILLT_s8*//*Label 109*/ 1385,
      /*GILLT_s16*//*Label 110*/ 1402,
      // Label 109: @1385
      GIM_Try, /*On fail goto*//*Label 112*/ 1401, // Rule ID 614 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
        // (zext:{ *:[i32] } i8:{ *:[i8] }:$src)  =>  (MOVZXd32d8:{ *:[i32] }:{ *:[i8] } MxDRD8:{ *:[i8] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d8,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 614,
        GIR_Done,
      // Label 112: @1401
      GIM_Reject,
      // Label 110: @1402
      GIM_Try, /*On fail goto*//*Label 113*/ 1418, // Rule ID 618 //
        GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::XR32RegClassID,
        // (zext:{ *:[i32] } i16:{ *:[i16] }:$src)  =>  (MOVZXd32d16:{ *:[i32] }:{ *:[i8] } MxDRD16:{ *:[i16] }:$src)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::MOVZXd32d16,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 618,
        GIR_Done,
      // Label 113: @1418
      GIM_Reject,
      // Label 111: @1419
      GIM_Reject,
    // Label 108: @1420
    GIM_Reject,
    // Label 10: @1421
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 117*/ 1613,
    /*GILLT_s8*//*Label 114*/ 1430,
    /*GILLT_s16*//*Label 115*/ 1491,
    /*GILLT_s32*//*Label 116*/ 1552,
    // Label 114: @1430
    GIM_Try, /*On fail goto*//*Label 118*/ 1490,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 119*/ 1477, // Rule ID 343 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (SHL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 343,
        GIR_Done,
      // Label 119: @1477
      GIM_Try, /*On fail goto*//*Label 120*/ 1489, // Rule ID 340 //
        // (shl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (SHL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 340,
        GIR_Done,
      // Label 120: @1489
      GIM_Reject,
    // Label 118: @1490
    GIM_Reject,
    // Label 115: @1491
    GIM_Try, /*On fail goto*//*Label 121*/ 1551,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 122*/ 1538, // Rule ID 344 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (SHL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 344,
        GIR_Done,
      // Label 122: @1538
      GIM_Try, /*On fail goto*//*Label 123*/ 1550, // Rule ID 341 //
        // (shl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (SHL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 341,
        GIR_Done,
      // Label 123: @1550
      GIM_Reject,
    // Label 121: @1551
    GIM_Reject,
    // Label 116: @1552
    GIM_Try, /*On fail goto*//*Label 124*/ 1612,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 125*/ 1599, // Rule ID 345 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (SHL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::SHL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 345,
        GIR_Done,
      // Label 125: @1599
      GIM_Try, /*On fail goto*//*Label 126*/ 1611, // Rule ID 342 //
        // (shl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (SHL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::SHL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 342,
        GIR_Done,
      // Label 126: @1611
      GIM_Reject,
    // Label 124: @1612
    GIM_Reject,
    // Label 117: @1613
    GIM_Reject,
    // Label 11: @1614
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 130*/ 1806,
    /*GILLT_s8*//*Label 127*/ 1623,
    /*GILLT_s16*//*Label 128*/ 1684,
    /*GILLT_s32*//*Label 129*/ 1745,
    // Label 127: @1623
    GIM_Try, /*On fail goto*//*Label 131*/ 1683,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 132*/ 1670, // Rule ID 349 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (LSR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 349,
        GIR_Done,
      // Label 132: @1670
      GIM_Try, /*On fail goto*//*Label 133*/ 1682, // Rule ID 346 //
        // (srl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (LSR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 346,
        GIR_Done,
      // Label 133: @1682
      GIM_Reject,
    // Label 131: @1683
    GIM_Reject,
    // Label 128: @1684
    GIM_Try, /*On fail goto*//*Label 134*/ 1744,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 135*/ 1731, // Rule ID 350 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (LSR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 350,
        GIR_Done,
      // Label 135: @1731
      GIM_Try, /*On fail goto*//*Label 136*/ 1743, // Rule ID 347 //
        // (srl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (LSR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 347,
        GIR_Done,
      // Label 136: @1743
      GIM_Reject,
    // Label 134: @1744
    GIM_Reject,
    // Label 129: @1745
    GIM_Try, /*On fail goto*//*Label 137*/ 1805,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 138*/ 1792, // Rule ID 351 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (LSR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::LSR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 351,
        GIR_Done,
      // Label 138: @1792
      GIM_Try, /*On fail goto*//*Label 139*/ 1804, // Rule ID 348 //
        // (srl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (LSR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::LSR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 348,
        GIR_Done,
      // Label 139: @1804
      GIM_Reject,
    // Label 137: @1805
    GIM_Reject,
    // Label 130: @1806
    GIM_Reject,
    // Label 12: @1807
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 143*/ 1999,
    /*GILLT_s8*//*Label 140*/ 1816,
    /*GILLT_s16*//*Label 141*/ 1877,
    /*GILLT_s32*//*Label 142*/ 1938,
    // Label 140: @1816
    GIM_Try, /*On fail goto*//*Label 144*/ 1876,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 145*/ 1863, // Rule ID 355 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ASR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 355,
        GIR_Done,
      // Label 145: @1863
      GIM_Try, /*On fail goto*//*Label 146*/ 1875, // Rule ID 352 //
        // (sra:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ASR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 352,
        GIR_Done,
      // Label 146: @1875
      GIM_Reject,
    // Label 144: @1876
    GIM_Reject,
    // Label 141: @1877
    GIM_Try, /*On fail goto*//*Label 147*/ 1937,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 148*/ 1924, // Rule ID 356 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ASR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 356,
        GIR_Done,
      // Label 148: @1924
      GIM_Try, /*On fail goto*//*Label 149*/ 1936, // Rule ID 353 //
        // (sra:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ASR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 353,
        GIR_Done,
      // Label 149: @1936
      GIM_Reject,
    // Label 147: @1937
    GIM_Reject,
    // Label 142: @1938
    GIM_Try, /*On fail goto*//*Label 150*/ 1998,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 151*/ 1985, // Rule ID 357 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ASR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ASR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 357,
        GIR_Done,
      // Label 151: @1985
      GIM_Try, /*On fail goto*//*Label 152*/ 1997, // Rule ID 354 //
        // (sra:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ASR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ASR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 354,
        GIR_Done,
      // Label 152: @1997
      GIM_Reject,
    // Label 150: @1998
    GIM_Reject,
    // Label 143: @1999
    GIM_Reject,
    // Label 13: @2000
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 156*/ 2192,
    /*GILLT_s8*//*Label 153*/ 2009,
    /*GILLT_s16*//*Label 154*/ 2070,
    /*GILLT_s32*//*Label 155*/ 2131,
    // Label 153: @2009
    GIM_Try, /*On fail goto*//*Label 157*/ 2069,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 158*/ 2056, // Rule ID 367 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROR8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 367,
        GIR_Done,
      // Label 158: @2056
      GIM_Try, /*On fail goto*//*Label 159*/ 2068, // Rule ID 364 //
        // (rotr:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROR8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 364,
        GIR_Done,
      // Label 159: @2068
      GIM_Reject,
    // Label 157: @2069
    GIM_Reject,
    // Label 154: @2070
    GIM_Try, /*On fail goto*//*Label 160*/ 2130,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 161*/ 2117, // Rule ID 368 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROR16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 368,
        GIR_Done,
      // Label 161: @2117
      GIM_Try, /*On fail goto*//*Label 162*/ 2129, // Rule ID 365 //
        // (rotr:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROR16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 365,
        GIR_Done,
      // Label 162: @2129
      GIM_Reject,
    // Label 160: @2130
    GIM_Reject,
    // Label 155: @2131
    GIM_Try, /*On fail goto*//*Label 163*/ 2191,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 164*/ 2178, // Rule ID 369 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROR32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROR32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 369,
        GIR_Done,
      // Label 164: @2178
      GIM_Try, /*On fail goto*//*Label 165*/ 2190, // Rule ID 366 //
        // (rotr:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROR32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROR32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 366,
        GIR_Done,
      // Label 165: @2190
      GIM_Reject,
    // Label 163: @2191
    GIM_Reject,
    // Label 156: @2192
    GIM_Reject,
    // Label 14: @2193
    GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/0, 3, /*)*//*default:*//*Label 169*/ 2385,
    /*GILLT_s8*//*Label 166*/ 2202,
    /*GILLT_s16*//*Label 167*/ 2263,
    /*GILLT_s32*//*Label 168*/ 2324,
    // Label 166: @2202
    GIM_Try, /*On fail goto*//*Label 170*/ 2262,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s8,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s8,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR8RegClassID,
      GIM_Try, /*On fail goto*//*Label 171*/ 2249, // Rule ID 361 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm8_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] })<<P:Predicate_Mximm8_1to8>>:$opd)  =>  (ROL8di:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, (imm:{ *:[i8] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL8di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 361,
        GIR_Done,
      // Label 171: @2249
      GIM_Try, /*On fail goto*//*Label 172*/ 2261, // Rule ID 358 //
        // (rotl:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)  =>  (ROL8dd:{ *:[i8] }:{ *:[i8] } i8:{ *:[i8] }:$src, i8:{ *:[i8] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL8dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 358,
        GIR_Done,
      // Label 172: @2261
      GIM_Reject,
    // Label 170: @2262
    GIM_Reject,
    // Label 167: @2263
    GIM_Try, /*On fail goto*//*Label 173*/ 2323,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s16,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s16,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR16RegClassID,
      GIM_Try, /*On fail goto*//*Label 174*/ 2310, // Rule ID 362 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm16_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] })<<P:Predicate_Mximm16_1to8>>:$opd)  =>  (ROL16di:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, (imm:{ *:[i16] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL16di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 362,
        GIR_Done,
      // Label 174: @2310
      GIM_Try, /*On fail goto*//*Label 175*/ 2322, // Rule ID 359 //
        // (rotl:{ *:[i16] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)  =>  (ROL16dd:{ *:[i16] }:{ *:[i8] } i16:{ *:[i16] }:$src, i16:{ *:[i16] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL16dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 359,
        GIR_Done,
      // Label 175: @2322
      GIM_Reject,
    // Label 173: @2323
    GIM_Reject,
    // Label 168: @2324
    GIM_Try, /*On fail goto*//*Label 176*/ 2384,
      GIM_CheckType, /*MI*/0, /*Op*/1, /*Type*/GILLT_s32,
      GIM_CheckType, /*MI*/0, /*Op*/2, /*Type*/GILLT_s32,
      GIM_CheckRegBankForClass, /*MI*/0, /*Op*/0, /*RC*/M68k::DR32RegClassID,
      GIM_Try, /*On fail goto*//*Label 177*/ 2371, // Rule ID 363 //
        GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
        GIM_CheckOpcode, /*MI*/1, TargetOpcode::G_CONSTANT,
        GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIPFP_I64_Predicate_Mximm32_1to8,
        // MIs[1] Operand 1
        // No operand predicates
        GIM_CheckIsSafeToFold, /*InsnID*/1,
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_Mximm32_1to8>>:$opd)  =>  (ROL32di:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, (imm:{ *:[i32] }):$opd)
        GIR_BuildMI, /*InsnID*/0, /*Opcode*/M68k::ROL32di,
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, // dst
        GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, // src
        GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opd
        GIR_EraseFromParent, /*InsnID*/0,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 363,
        GIR_Done,
      // Label 177: @2371
      GIM_Try, /*On fail goto*//*Label 178*/ 2383, // Rule ID 360 //
        // (rotl:{ *:[i32] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)  =>  (ROL32dd:{ *:[i32] }:{ *:[i8] } i32:{ *:[i32] }:$src, i32:{ *:[i32] }:$opd)
        GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/M68k::ROL32dd,
        GIR_AddImplicitDef, /*InsnID*/0, M68k::CCR,
        GIR_ConstrainSelectedInstOperands, /*InsnID*/0,
        // GIR_Coverage, 360,
        GIR_Done,
      // Label 178: @2383
      GIM_Reject,
    // Label 176: @2384
    GIM_Reject,
    // Label 169: @2385
    GIM_Reject,
    // Label 15: @2386
    GIM_Reject,
    };
  return MatchTable0;
}
#endif // ifdef GET_GLOBALISEL_IMPL
#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const M68kSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const M68kSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
