/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * M68k Disassembler                                                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/MC/SubtargetFeature.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static std::enable_if_t<std::is_integral<InsnType>::value>
insertBits(InsnType &field, InsnType bits, unsigned startBit, unsigned numBits) {
  assert(startBit + numBits <= sizeof field * 8);
  field |= (InsnType)bits << startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value>
insertBits(InsnType &field, uint64_t bits, unsigned startBit, unsigned numBits) {
  field.insertBits(bits, startBit, numBits);
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable80[] = {
/* 0 */       MCD::OPC_ExtractField, 12, 4,  // Inst{15-12} ...
/* 3 */       MCD::OPC_FilterValue, 0, 143, 6, 0, // Skip to: 1687
/* 8 */       MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11 */      MCD::OPC_FilterValue, 0, 65, 0, 0, // Skip to: 81
/* 16 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 19 */      MCD::OPC_FilterValue, 4, 11, 0, 0, // Skip to: 35
/* 24 */      MCD::OPC_CheckField, 24, 8, 0, 23, 49, 0, // Skip to: 12598
/* 31 */      MCD::OPC_Decode, 173, 3, 0, // Opcode: BTST32di
/* 35 */      MCD::OPC_FilterValue, 5, 18, 0, 0, // Skip to: 58
/* 40 */      MCD::OPC_CheckField, 24, 8, 0, 7, 49, 0, // Skip to: 12598
/* 47 */      MCD::OPC_CheckField, 3, 1, 0, 0, 49, 0, // Skip to: 12598
/* 54 */      MCD::OPC_Decode, 246, 8, 1, // Opcode: XOR8di
/* 58 */      MCD::OPC_FilterValue, 6, 247, 48, 0, // Skip to: 12598
/* 63 */      MCD::OPC_CheckField, 24, 8, 0, 240, 48, 0, // Skip to: 12598
/* 70 */      MCD::OPC_CheckField, 3, 1, 0, 233, 48, 0, // Skip to: 12598
/* 77 */      MCD::OPC_Decode, 252, 3, 2, // Opcode: CMP8di
/* 81 */      MCD::OPC_FilterValue, 1, 158, 0, 0, // Skip to: 244
/* 86 */      MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 89 */      MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 112
/* 94 */      MCD::OPC_CheckField, 24, 8, 0, 209, 48, 0, // Skip to: 12598
/* 101 */     MCD::OPC_CheckField, 3, 1, 0, 202, 48, 0, // Skip to: 12598
/* 108 */     MCD::OPC_Decode, 239, 7, 3, // Opcode: OR8ji
/* 112 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 135
/* 117 */     MCD::OPC_CheckField, 24, 8, 0, 186, 48, 0, // Skip to: 12598
/* 124 */     MCD::OPC_CheckField, 3, 1, 0, 179, 48, 0, // Skip to: 12598
/* 131 */     MCD::OPC_Decode, 161, 3, 3, // Opcode: AND8ji
/* 135 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 158
/* 140 */     MCD::OPC_CheckField, 24, 8, 0, 163, 48, 0, // Skip to: 12598
/* 147 */     MCD::OPC_CheckField, 3, 1, 0, 156, 48, 0, // Skip to: 12598
/* 154 */     MCD::OPC_Decode, 230, 8, 3, // Opcode: SUB8ji
/* 158 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 181
/* 163 */     MCD::OPC_CheckField, 24, 8, 0, 140, 48, 0, // Skip to: 12598
/* 170 */     MCD::OPC_CheckField, 3, 1, 0, 133, 48, 0, // Skip to: 12598
/* 177 */     MCD::OPC_Decode, 245, 2, 3, // Opcode: ADD8ji
/* 181 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 221
/* 186 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 189 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 205
/* 194 */     MCD::OPC_CheckField, 24, 8, 0, 109, 48, 0, // Skip to: 12598
/* 201 */     MCD::OPC_Decode, 179, 3, 3, // Opcode: BTST8ji
/* 205 */     MCD::OPC_FilterValue, 1, 100, 48, 0, // Skip to: 12598
/* 210 */     MCD::OPC_CheckField, 24, 8, 0, 93, 48, 0, // Skip to: 12598
/* 217 */     MCD::OPC_Decode, 183, 3, 3, // Opcode: BTST8oi
/* 221 */     MCD::OPC_FilterValue, 6, 84, 48, 0, // Skip to: 12598
/* 226 */     MCD::OPC_CheckField, 24, 8, 0, 77, 48, 0, // Skip to: 12598
/* 233 */     MCD::OPC_CheckField, 3, 1, 0, 70, 48, 0, // Skip to: 12598
/* 240 */     MCD::OPC_Decode, 130, 4, 4, // Opcode: CMP8ji
/* 244 */     MCD::OPC_FilterValue, 2, 158, 0, 0, // Skip to: 407
/* 249 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 252 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 275
/* 257 */     MCD::OPC_CheckField, 24, 8, 0, 46, 48, 0, // Skip to: 12598
/* 264 */     MCD::OPC_CheckField, 3, 1, 1, 39, 48, 0, // Skip to: 12598
/* 271 */     MCD::OPC_Decode, 241, 7, 5, // Opcode: OR8pi
/* 275 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 298
/* 280 */     MCD::OPC_CheckField, 24, 8, 0, 23, 48, 0, // Skip to: 12598
/* 287 */     MCD::OPC_CheckField, 3, 1, 1, 16, 48, 0, // Skip to: 12598
/* 294 */     MCD::OPC_Decode, 163, 3, 5, // Opcode: AND8pi
/* 298 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 321
/* 303 */     MCD::OPC_CheckField, 24, 8, 0, 0, 48, 0, // Skip to: 12598
/* 310 */     MCD::OPC_CheckField, 3, 1, 1, 249, 47, 0, // Skip to: 12598
/* 317 */     MCD::OPC_Decode, 232, 8, 5, // Opcode: SUB8pi
/* 321 */     MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 344
/* 326 */     MCD::OPC_CheckField, 24, 8, 0, 233, 47, 0, // Skip to: 12598
/* 333 */     MCD::OPC_CheckField, 3, 1, 1, 226, 47, 0, // Skip to: 12598
/* 340 */     MCD::OPC_Decode, 247, 2, 5, // Opcode: ADD8pi
/* 344 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 384
/* 349 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 352 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 368
/* 357 */     MCD::OPC_CheckField, 24, 8, 0, 202, 47, 0, // Skip to: 12598
/* 364 */     MCD::OPC_Decode, 175, 3, 3, // Opcode: BTST8ei
/* 368 */     MCD::OPC_FilterValue, 1, 193, 47, 0, // Skip to: 12598
/* 373 */     MCD::OPC_CheckField, 24, 8, 0, 186, 47, 0, // Skip to: 12598
/* 380 */     MCD::OPC_Decode, 185, 3, 5, // Opcode: BTST8pi
/* 384 */     MCD::OPC_FilterValue, 6, 177, 47, 0, // Skip to: 12598
/* 389 */     MCD::OPC_CheckField, 24, 8, 0, 170, 47, 0, // Skip to: 12598
/* 396 */     MCD::OPC_CheckField, 3, 1, 1, 163, 47, 0, // Skip to: 12598
/* 403 */     MCD::OPC_Decode, 132, 4, 6, // Opcode: CMP8pi
/* 407 */     MCD::OPC_FilterValue, 3, 39, 1, 0, // Skip to: 707
/* 412 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 415 */     MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 445
/* 420 */     MCD::OPC_CheckField, 40, 4, 8, 139, 47, 0, // Skip to: 12598
/* 427 */     MCD::OPC_CheckField, 24, 8, 0, 132, 47, 0, // Skip to: 12598
/* 434 */     MCD::OPC_CheckField, 3, 1, 0, 125, 47, 0, // Skip to: 12598
/* 441 */     MCD::OPC_Decode, 237, 7, 7, // Opcode: OR8fi
/* 445 */     MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 475
/* 450 */     MCD::OPC_CheckField, 40, 4, 8, 109, 47, 0, // Skip to: 12598
/* 457 */     MCD::OPC_CheckField, 24, 8, 0, 102, 47, 0, // Skip to: 12598
/* 464 */     MCD::OPC_CheckField, 3, 1, 0, 95, 47, 0, // Skip to: 12598
/* 471 */     MCD::OPC_Decode, 159, 3, 7, // Opcode: AND8fi
/* 475 */     MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 505
/* 480 */     MCD::OPC_CheckField, 40, 4, 8, 79, 47, 0, // Skip to: 12598
/* 487 */     MCD::OPC_CheckField, 24, 8, 0, 72, 47, 0, // Skip to: 12598
/* 494 */     MCD::OPC_CheckField, 3, 1, 0, 65, 47, 0, // Skip to: 12598
/* 501 */     MCD::OPC_Decode, 228, 8, 7, // Opcode: SUB8fi
/* 505 */     MCD::OPC_FilterValue, 3, 25, 0, 0, // Skip to: 535
/* 510 */     MCD::OPC_CheckField, 40, 4, 8, 49, 47, 0, // Skip to: 12598
/* 517 */     MCD::OPC_CheckField, 24, 8, 0, 42, 47, 0, // Skip to: 12598
/* 524 */     MCD::OPC_CheckField, 3, 1, 0, 35, 47, 0, // Skip to: 12598
/* 531 */     MCD::OPC_Decode, 243, 2, 7, // Opcode: ADD8fi
/* 535 */     MCD::OPC_FilterValue, 4, 73, 0, 0, // Skip to: 613
/* 540 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 543 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 566
/* 548 */     MCD::OPC_CheckField, 40, 4, 8, 11, 47, 0, // Skip to: 12598
/* 555 */     MCD::OPC_CheckField, 24, 8, 0, 4, 47, 0, // Skip to: 12598
/* 562 */     MCD::OPC_Decode, 177, 3, 7, // Opcode: BTST8fi
/* 566 */     MCD::OPC_FilterValue, 1, 251, 46, 0, // Skip to: 12598
/* 571 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 574 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 590
/* 579 */     MCD::OPC_CheckField, 24, 8, 0, 236, 46, 0, // Skip to: 12598
/* 586 */     MCD::OPC_Decode, 187, 3, 8, // Opcode: BTST8qi
/* 590 */     MCD::OPC_FilterValue, 3, 227, 46, 0, // Skip to: 12598
/* 595 */     MCD::OPC_CheckField, 40, 4, 8, 220, 46, 0, // Skip to: 12598
/* 602 */     MCD::OPC_CheckField, 24, 8, 0, 213, 46, 0, // Skip to: 12598
/* 609 */     MCD::OPC_Decode, 181, 3, 9, // Opcode: BTST8ki
/* 613 */     MCD::OPC_FilterValue, 6, 204, 46, 0, // Skip to: 12598
/* 618 */     MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 621 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 644
/* 626 */     MCD::OPC_CheckField, 40, 4, 8, 189, 46, 0, // Skip to: 12598
/* 633 */     MCD::OPC_CheckField, 24, 8, 0, 182, 46, 0, // Skip to: 12598
/* 640 */     MCD::OPC_Decode, 129, 4, 10, // Opcode: CMP8fi
/* 644 */     MCD::OPC_FilterValue, 1, 173, 46, 0, // Skip to: 12598
/* 649 */     MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 652 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 668
/* 657 */     MCD::OPC_CheckField, 24, 8, 0, 158, 46, 0, // Skip to: 12598
/* 664 */     MCD::OPC_Decode, 249, 3, 11, // Opcode: CMP8bi
/* 668 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 684
/* 673 */     MCD::OPC_CheckField, 24, 8, 0, 142, 46, 0, // Skip to: 12598
/* 680 */     MCD::OPC_Decode, 133, 4, 12, // Opcode: CMP8qi
/* 684 */     MCD::OPC_FilterValue, 3, 133, 46, 0, // Skip to: 12598
/* 689 */     MCD::OPC_CheckField, 40, 4, 8, 126, 46, 0, // Skip to: 12598
/* 696 */     MCD::OPC_CheckField, 24, 8, 0, 119, 46, 0, // Skip to: 12598
/* 703 */     MCD::OPC_Decode, 131, 4, 13, // Opcode: CMP8ki
/* 707 */     MCD::OPC_FilterValue, 4, 35, 0, 0, // Skip to: 747
/* 712 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 715 */     MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 731
/* 720 */     MCD::OPC_CheckField, 3, 1, 0, 95, 46, 0, // Skip to: 12598
/* 727 */     MCD::OPC_Decode, 242, 8, 14, // Opcode: XOR16di
/* 731 */     MCD::OPC_FilterValue, 6, 86, 46, 0, // Skip to: 12598
/* 736 */     MCD::OPC_CheckField, 3, 1, 0, 79, 46, 0, // Skip to: 12598
/* 743 */     MCD::OPC_Decode, 225, 3, 15, // Opcode: CMP16di
/* 747 */     MCD::OPC_FilterValue, 5, 83, 0, 0, // Skip to: 835
/* 752 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 755 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 771
/* 760 */     MCD::OPC_CheckField, 3, 1, 0, 55, 46, 0, // Skip to: 12598
/* 767 */     MCD::OPC_Decode, 212, 7, 16, // Opcode: OR16ji
/* 771 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 787
/* 776 */     MCD::OPC_CheckField, 3, 1, 0, 39, 46, 0, // Skip to: 12598
/* 783 */     MCD::OPC_Decode, 134, 3, 16, // Opcode: AND16ji
/* 787 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 803
/* 792 */     MCD::OPC_CheckField, 3, 1, 0, 23, 46, 0, // Skip to: 12598
/* 799 */     MCD::OPC_Decode, 196, 8, 16, // Opcode: SUB16ji
/* 803 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 819
/* 808 */     MCD::OPC_CheckField, 3, 1, 0, 7, 46, 0, // Skip to: 12598
/* 815 */     MCD::OPC_Decode, 211, 2, 16, // Opcode: ADD16ji
/* 819 */     MCD::OPC_FilterValue, 6, 254, 45, 0, // Skip to: 12598
/* 824 */     MCD::OPC_CheckField, 3, 1, 0, 247, 45, 0, // Skip to: 12598
/* 831 */     MCD::OPC_Decode, 232, 3, 17, // Opcode: CMP16ji
/* 835 */     MCD::OPC_FilterValue, 6, 83, 0, 0, // Skip to: 923
/* 840 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 843 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 859
/* 848 */     MCD::OPC_CheckField, 3, 1, 1, 223, 45, 0, // Skip to: 12598
/* 855 */     MCD::OPC_Decode, 214, 7, 18, // Opcode: OR16pi
/* 859 */     MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 875
/* 864 */     MCD::OPC_CheckField, 3, 1, 1, 207, 45, 0, // Skip to: 12598
/* 871 */     MCD::OPC_Decode, 136, 3, 18, // Opcode: AND16pi
/* 875 */     MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 891
/* 880 */     MCD::OPC_CheckField, 3, 1, 1, 191, 45, 0, // Skip to: 12598
/* 887 */     MCD::OPC_Decode, 198, 8, 18, // Opcode: SUB16pi
/* 891 */     MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 907
/* 896 */     MCD::OPC_CheckField, 3, 1, 1, 175, 45, 0, // Skip to: 12598
/* 903 */     MCD::OPC_Decode, 213, 2, 18, // Opcode: ADD16pi
/* 907 */     MCD::OPC_FilterValue, 6, 166, 45, 0, // Skip to: 12598
/* 912 */     MCD::OPC_CheckField, 3, 1, 1, 159, 45, 0, // Skip to: 12598
/* 919 */     MCD::OPC_Decode, 234, 3, 19, // Opcode: CMP16pi
/* 923 */     MCD::OPC_FilterValue, 7, 161, 0, 0, // Skip to: 1089
/* 928 */     MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 931 */     MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 954
/* 936 */     MCD::OPC_CheckField, 40, 4, 8, 135, 45, 0, // Skip to: 12598
/* 943 */     MCD::OPC_CheckField, 3, 1, 0, 128, 45, 0, // Skip to: 12598
/* 950 */     MCD::OPC_Decode, 210, 7, 20, // Opcode: OR16fi
/* 954 */     MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 977
/* 959 */     MCD::OPC_CheckField, 40, 4, 8, 112, 45, 0, // Skip to: 12598
/* 966 */     MCD::OPC_CheckField, 3, 1, 0, 105, 45, 0, // Skip to: 12598
/* 973 */     MCD::OPC_Decode, 132, 3, 20, // Opcode: AND16fi
/* 977 */     MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1000
/* 982 */     MCD::OPC_CheckField, 40, 4, 8, 89, 45, 0, // Skip to: 12598
/* 989 */     MCD::OPC_CheckField, 3, 1, 0, 82, 45, 0, // Skip to: 12598
/* 996 */     MCD::OPC_Decode, 194, 8, 20, // Opcode: SUB16fi
/* 1000 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1023
/* 1005 */    MCD::OPC_CheckField, 40, 4, 8, 66, 45, 0, // Skip to: 12598
/* 1012 */    MCD::OPC_CheckField, 3, 1, 0, 59, 45, 0, // Skip to: 12598
/* 1019 */    MCD::OPC_Decode, 209, 2, 20, // Opcode: ADD16fi
/* 1023 */    MCD::OPC_FilterValue, 6, 50, 45, 0, // Skip to: 12598
/* 1028 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1031 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1047
/* 1036 */    MCD::OPC_CheckField, 40, 4, 8, 35, 45, 0, // Skip to: 12598
/* 1043 */    MCD::OPC_Decode, 231, 3, 21, // Opcode: CMP16fi
/* 1047 */    MCD::OPC_FilterValue, 1, 26, 45, 0, // Skip to: 12598
/* 1052 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1055 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1064
/* 1060 */    MCD::OPC_Decode, 223, 3, 22, // Opcode: CMP16bi
/* 1064 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1073
/* 1069 */    MCD::OPC_Decode, 235, 3, 23, // Opcode: CMP16qi
/* 1073 */    MCD::OPC_FilterValue, 3, 0, 45, 0, // Skip to: 12598
/* 1078 */    MCD::OPC_CheckField, 40, 4, 8, 249, 44, 0, // Skip to: 12598
/* 1085 */    MCD::OPC_Decode, 233, 3, 24, // Opcode: CMP16ki
/* 1089 */    MCD::OPC_FilterValue, 8, 35, 0, 0, // Skip to: 1129
/* 1094 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1097 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 1113
/* 1102 */    MCD::OPC_CheckField, 3, 1, 0, 225, 44, 0, // Skip to: 12598
/* 1109 */    MCD::OPC_Decode, 244, 8, 25, // Opcode: XOR32di
/* 1113 */    MCD::OPC_FilterValue, 6, 216, 44, 0, // Skip to: 12598
/* 1118 */    MCD::OPC_CheckField, 3, 1, 0, 209, 44, 0, // Skip to: 12598
/* 1125 */    MCD::OPC_Decode, 238, 3, 26, // Opcode: CMP32di
/* 1129 */    MCD::OPC_FilterValue, 9, 83, 0, 0, // Skip to: 1217
/* 1134 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1137 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1153
/* 1142 */    MCD::OPC_CheckField, 3, 1, 0, 185, 44, 0, // Skip to: 12598
/* 1149 */    MCD::OPC_Decode, 226, 7, 27, // Opcode: OR32ji
/* 1153 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1169
/* 1158 */    MCD::OPC_CheckField, 3, 1, 0, 169, 44, 0, // Skip to: 12598
/* 1165 */    MCD::OPC_Decode, 148, 3, 27, // Opcode: AND32ji
/* 1169 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1185
/* 1174 */    MCD::OPC_CheckField, 3, 1, 0, 153, 44, 0, // Skip to: 12598
/* 1181 */    MCD::OPC_Decode, 217, 8, 27, // Opcode: SUB32ji
/* 1185 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1201
/* 1190 */    MCD::OPC_CheckField, 3, 1, 0, 137, 44, 0, // Skip to: 12598
/* 1197 */    MCD::OPC_Decode, 232, 2, 27, // Opcode: ADD32ji
/* 1201 */    MCD::OPC_FilterValue, 6, 128, 44, 0, // Skip to: 12598
/* 1206 */    MCD::OPC_CheckField, 3, 1, 0, 121, 44, 0, // Skip to: 12598
/* 1213 */    MCD::OPC_Decode, 245, 3, 28, // Opcode: CMP32ji
/* 1217 */    MCD::OPC_FilterValue, 10, 83, 0, 0, // Skip to: 1305
/* 1222 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1225 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1241
/* 1230 */    MCD::OPC_CheckField, 3, 1, 1, 97, 44, 0, // Skip to: 12598
/* 1237 */    MCD::OPC_Decode, 228, 7, 29, // Opcode: OR32pi
/* 1241 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 1257
/* 1246 */    MCD::OPC_CheckField, 3, 1, 1, 81, 44, 0, // Skip to: 12598
/* 1253 */    MCD::OPC_Decode, 150, 3, 29, // Opcode: AND32pi
/* 1257 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 1273
/* 1262 */    MCD::OPC_CheckField, 3, 1, 1, 65, 44, 0, // Skip to: 12598
/* 1269 */    MCD::OPC_Decode, 219, 8, 29, // Opcode: SUB32pi
/* 1273 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1289
/* 1278 */    MCD::OPC_CheckField, 3, 1, 1, 49, 44, 0, // Skip to: 12598
/* 1285 */    MCD::OPC_Decode, 234, 2, 29, // Opcode: ADD32pi
/* 1289 */    MCD::OPC_FilterValue, 6, 40, 44, 0, // Skip to: 12598
/* 1294 */    MCD::OPC_CheckField, 3, 1, 1, 33, 44, 0, // Skip to: 12598
/* 1301 */    MCD::OPC_Decode, 247, 3, 30, // Opcode: CMP32pi
/* 1305 */    MCD::OPC_FilterValue, 11, 161, 0, 0, // Skip to: 1471
/* 1310 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1313 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 1336
/* 1318 */    MCD::OPC_CheckField, 56, 4, 8, 9, 44, 0, // Skip to: 12598
/* 1325 */    MCD::OPC_CheckField, 3, 1, 0, 2, 44, 0, // Skip to: 12598
/* 1332 */    MCD::OPC_Decode, 224, 7, 31, // Opcode: OR32fi
/* 1336 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 1359
/* 1341 */    MCD::OPC_CheckField, 56, 4, 8, 242, 43, 0, // Skip to: 12598
/* 1348 */    MCD::OPC_CheckField, 3, 1, 0, 235, 43, 0, // Skip to: 12598
/* 1355 */    MCD::OPC_Decode, 146, 3, 31, // Opcode: AND32fi
/* 1359 */    MCD::OPC_FilterValue, 2, 18, 0, 0, // Skip to: 1382
/* 1364 */    MCD::OPC_CheckField, 56, 4, 8, 219, 43, 0, // Skip to: 12598
/* 1371 */    MCD::OPC_CheckField, 3, 1, 0, 212, 43, 0, // Skip to: 12598
/* 1378 */    MCD::OPC_Decode, 215, 8, 31, // Opcode: SUB32fi
/* 1382 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 1405
/* 1387 */    MCD::OPC_CheckField, 56, 4, 8, 196, 43, 0, // Skip to: 12598
/* 1394 */    MCD::OPC_CheckField, 3, 1, 0, 189, 43, 0, // Skip to: 12598
/* 1401 */    MCD::OPC_Decode, 230, 2, 31, // Opcode: ADD32fi
/* 1405 */    MCD::OPC_FilterValue, 6, 180, 43, 0, // Skip to: 12598
/* 1410 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1413 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1429
/* 1418 */    MCD::OPC_CheckField, 56, 4, 8, 165, 43, 0, // Skip to: 12598
/* 1425 */    MCD::OPC_Decode, 244, 3, 32, // Opcode: CMP32fi
/* 1429 */    MCD::OPC_FilterValue, 1, 156, 43, 0, // Skip to: 12598
/* 1434 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1437 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1446
/* 1442 */    MCD::OPC_Decode, 236, 3, 33, // Opcode: CMP32bi
/* 1446 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1455
/* 1451 */    MCD::OPC_Decode, 248, 3, 34, // Opcode: CMP32qi
/* 1455 */    MCD::OPC_FilterValue, 3, 130, 43, 0, // Skip to: 12598
/* 1460 */    MCD::OPC_CheckField, 56, 4, 8, 123, 43, 0, // Skip to: 12598
/* 1467 */    MCD::OPC_Decode, 246, 3, 35, // Opcode: CMP32ki
/* 1471 */    MCD::OPC_FilterValue, 13, 93, 0, 0, // Skip to: 1569
/* 1476 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 1479 */    MCD::OPC_FilterValue, 5, 25, 0, 0, // Skip to: 1509
/* 1484 */    MCD::OPC_CheckField, 25, 7, 0, 99, 43, 0, // Skip to: 12598
/* 1491 */    MCD::OPC_CheckField, 19, 3, 0, 92, 43, 0, // Skip to: 12598
/* 1498 */    MCD::OPC_CheckField, 3, 1, 0, 85, 43, 0, // Skip to: 12598
/* 1505 */    MCD::OPC_Decode, 222, 3, 36, // Opcode: CAS8
/* 1509 */    MCD::OPC_FilterValue, 6, 25, 0, 0, // Skip to: 1539
/* 1514 */    MCD::OPC_CheckField, 25, 7, 0, 69, 43, 0, // Skip to: 12598
/* 1521 */    MCD::OPC_CheckField, 19, 3, 0, 62, 43, 0, // Skip to: 12598
/* 1528 */    MCD::OPC_CheckField, 3, 1, 0, 55, 43, 0, // Skip to: 12598
/* 1535 */    MCD::OPC_Decode, 220, 3, 37, // Opcode: CAS16
/* 1539 */    MCD::OPC_FilterValue, 7, 46, 43, 0, // Skip to: 12598
/* 1544 */    MCD::OPC_CheckField, 25, 7, 0, 39, 43, 0, // Skip to: 12598
/* 1551 */    MCD::OPC_CheckField, 19, 3, 0, 32, 43, 0, // Skip to: 12598
/* 1558 */    MCD::OPC_CheckField, 3, 1, 0, 25, 43, 0, // Skip to: 12598
/* 1565 */    MCD::OPC_Decode, 221, 3, 38, // Opcode: CAS32
/* 1569 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1578
/* 1574 */    MCD::OPC_Decode, 172, 3, 39, // Opcode: BTST32dd
/* 1578 */    MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 1604
/* 1583 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1586 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1595
/* 1591 */    MCD::OPC_Decode, 178, 3, 40, // Opcode: BTST8jd
/* 1595 */    MCD::OPC_FilterValue, 1, 246, 42, 0, // Skip to: 12598
/* 1600 */    MCD::OPC_Decode, 182, 3, 40, // Opcode: BTST8od
/* 1604 */    MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 1630
/* 1609 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1612 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1621
/* 1617 */    MCD::OPC_Decode, 174, 3, 40, // Opcode: BTST8ed
/* 1621 */    MCD::OPC_FilterValue, 1, 220, 42, 0, // Skip to: 12598
/* 1626 */    MCD::OPC_Decode, 184, 3, 41, // Opcode: BTST8pd
/* 1630 */    MCD::OPC_FilterValue, 19, 211, 42, 0, // Skip to: 12598
/* 1635 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 1638 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1654
/* 1643 */    MCD::OPC_CheckField, 24, 4, 8, 196, 42, 0, // Skip to: 12598
/* 1650 */    MCD::OPC_Decode, 176, 3, 42, // Opcode: BTST8fd
/* 1654 */    MCD::OPC_FilterValue, 1, 187, 42, 0, // Skip to: 12598
/* 1659 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1662 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1671
/* 1667 */    MCD::OPC_Decode, 186, 3, 43, // Opcode: BTST8qd
/* 1671 */    MCD::OPC_FilterValue, 3, 170, 42, 0, // Skip to: 12598
/* 1676 */    MCD::OPC_CheckField, 24, 4, 8, 163, 42, 0, // Skip to: 12598
/* 1683 */    MCD::OPC_Decode, 180, 3, 44, // Opcode: BTST8kd
/* 1687 */    MCD::OPC_FilterValue, 1, 254, 4, 0, // Skip to: 2970
/* 1692 */    MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 1695 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 1704
/* 1700 */    MCD::OPC_Decode, 211, 6, 45, // Opcode: MOV8dd
/* 1704 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1713
/* 1709 */    MCD::OPC_Decode, 215, 6, 46, // Opcode: MOV8dj
/* 1713 */    MCD::OPC_FilterValue, 3, 4, 0, 0, // Skip to: 1722
/* 1718 */    MCD::OPC_Decode, 217, 6, 46, // Opcode: MOV8do
/* 1722 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 1731
/* 1727 */    MCD::OPC_Decode, 212, 6, 46, // Opcode: MOV8de
/* 1731 */    MCD::OPC_FilterValue, 5, 4, 0, 0, // Skip to: 1740
/* 1736 */    MCD::OPC_Decode, 218, 6, 47, // Opcode: MOV8dp
/* 1740 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 1756
/* 1745 */    MCD::OPC_CheckField, 24, 4, 8, 94, 42, 0, // Skip to: 12598
/* 1752 */    MCD::OPC_Decode, 213, 6, 48, // Opcode: MOV8df
/* 1756 */    MCD::OPC_FilterValue, 7, 53, 0, 0, // Skip to: 1814
/* 1761 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1764 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1773
/* 1769 */    MCD::OPC_Decode, 210, 6, 49, // Opcode: MOV8db
/* 1773 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1782
/* 1778 */    MCD::OPC_Decode, 219, 6, 50, // Opcode: MOV8dq
/* 1782 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1798
/* 1787 */    MCD::OPC_CheckField, 24, 4, 8, 52, 42, 0, // Skip to: 12598
/* 1794 */    MCD::OPC_Decode, 216, 6, 51, // Opcode: MOV8dk
/* 1798 */    MCD::OPC_FilterValue, 4, 43, 42, 0, // Skip to: 12598
/* 1803 */    MCD::OPC_CheckField, 24, 8, 0, 36, 42, 0, // Skip to: 12598
/* 1810 */    MCD::OPC_Decode, 214, 6, 52, // Opcode: MOV8di
/* 1814 */    MCD::OPC_FilterValue, 16, 4, 0, 0, // Skip to: 1823
/* 1819 */    MCD::OPC_Decode, 241, 6, 53, // Opcode: MOV8jd
/* 1823 */    MCD::OPC_FilterValue, 18, 4, 0, 0, // Skip to: 1832
/* 1828 */    MCD::OPC_Decode, 245, 6, 54, // Opcode: MOV8jj
/* 1832 */    MCD::OPC_FilterValue, 19, 4, 0, 0, // Skip to: 1841
/* 1837 */    MCD::OPC_Decode, 247, 6, 54, // Opcode: MOV8jo
/* 1841 */    MCD::OPC_FilterValue, 20, 4, 0, 0, // Skip to: 1850
/* 1846 */    MCD::OPC_Decode, 242, 6, 54, // Opcode: MOV8je
/* 1850 */    MCD::OPC_FilterValue, 21, 4, 0, 0, // Skip to: 1859
/* 1855 */    MCD::OPC_Decode, 248, 6, 55, // Opcode: MOV8jp
/* 1859 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 1875
/* 1864 */    MCD::OPC_CheckField, 24, 4, 8, 231, 41, 0, // Skip to: 12598
/* 1871 */    MCD::OPC_Decode, 243, 6, 56, // Opcode: MOV8jf
/* 1875 */    MCD::OPC_FilterValue, 23, 53, 0, 0, // Skip to: 1933
/* 1880 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1883 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 1892
/* 1888 */    MCD::OPC_Decode, 240, 6, 57, // Opcode: MOV8jb
/* 1892 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 1901
/* 1897 */    MCD::OPC_Decode, 249, 6, 58, // Opcode: MOV8jq
/* 1901 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 1917
/* 1906 */    MCD::OPC_CheckField, 24, 4, 8, 189, 41, 0, // Skip to: 12598
/* 1913 */    MCD::OPC_Decode, 246, 6, 59, // Opcode: MOV8jk
/* 1917 */    MCD::OPC_FilterValue, 4, 180, 41, 0, // Skip to: 12598
/* 1922 */    MCD::OPC_CheckField, 24, 8, 0, 173, 41, 0, // Skip to: 12598
/* 1929 */    MCD::OPC_Decode, 244, 6, 60, // Opcode: MOV8ji
/* 1933 */    MCD::OPC_FilterValue, 24, 4, 0, 0, // Skip to: 1942
/* 1938 */    MCD::OPC_Decode, 133, 7, 53, // Opcode: MOV8od
/* 1942 */    MCD::OPC_FilterValue, 26, 4, 0, 0, // Skip to: 1951
/* 1947 */    MCD::OPC_Decode, 137, 7, 54, // Opcode: MOV8oj
/* 1951 */    MCD::OPC_FilterValue, 27, 4, 0, 0, // Skip to: 1960
/* 1956 */    MCD::OPC_Decode, 139, 7, 54, // Opcode: MOV8oo
/* 1960 */    MCD::OPC_FilterValue, 28, 4, 0, 0, // Skip to: 1969
/* 1965 */    MCD::OPC_Decode, 134, 7, 54, // Opcode: MOV8oe
/* 1969 */    MCD::OPC_FilterValue, 29, 4, 0, 0, // Skip to: 1978
/* 1974 */    MCD::OPC_Decode, 140, 7, 55, // Opcode: MOV8op
/* 1978 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 1994
/* 1983 */    MCD::OPC_CheckField, 24, 4, 8, 112, 41, 0, // Skip to: 12598
/* 1990 */    MCD::OPC_Decode, 135, 7, 56, // Opcode: MOV8of
/* 1994 */    MCD::OPC_FilterValue, 31, 53, 0, 0, // Skip to: 2052
/* 1999 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2002 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2011
/* 2007 */    MCD::OPC_Decode, 132, 7, 57, // Opcode: MOV8ob
/* 2011 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2020
/* 2016 */    MCD::OPC_Decode, 141, 7, 58, // Opcode: MOV8oq
/* 2020 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2036
/* 2025 */    MCD::OPC_CheckField, 24, 4, 8, 70, 41, 0, // Skip to: 12598
/* 2032 */    MCD::OPC_Decode, 138, 7, 59, // Opcode: MOV8ok
/* 2036 */    MCD::OPC_FilterValue, 4, 61, 41, 0, // Skip to: 12598
/* 2041 */    MCD::OPC_CheckField, 24, 8, 0, 54, 41, 0, // Skip to: 12598
/* 2048 */    MCD::OPC_Decode, 136, 7, 60, // Opcode: MOV8oi
/* 2052 */    MCD::OPC_FilterValue, 32, 4, 0, 0, // Skip to: 2061
/* 2057 */    MCD::OPC_Decode, 221, 6, 53, // Opcode: MOV8ed
/* 2061 */    MCD::OPC_FilterValue, 34, 4, 0, 0, // Skip to: 2070
/* 2066 */    MCD::OPC_Decode, 225, 6, 54, // Opcode: MOV8ej
/* 2070 */    MCD::OPC_FilterValue, 35, 4, 0, 0, // Skip to: 2079
/* 2075 */    MCD::OPC_Decode, 227, 6, 54, // Opcode: MOV8eo
/* 2079 */    MCD::OPC_FilterValue, 36, 4, 0, 0, // Skip to: 2088
/* 2084 */    MCD::OPC_Decode, 222, 6, 54, // Opcode: MOV8ee
/* 2088 */    MCD::OPC_FilterValue, 37, 4, 0, 0, // Skip to: 2097
/* 2093 */    MCD::OPC_Decode, 228, 6, 55, // Opcode: MOV8ep
/* 2097 */    MCD::OPC_FilterValue, 38, 11, 0, 0, // Skip to: 2113
/* 2102 */    MCD::OPC_CheckField, 24, 4, 8, 249, 40, 0, // Skip to: 12598
/* 2109 */    MCD::OPC_Decode, 223, 6, 56, // Opcode: MOV8ef
/* 2113 */    MCD::OPC_FilterValue, 39, 53, 0, 0, // Skip to: 2171
/* 2118 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2121 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2130
/* 2126 */    MCD::OPC_Decode, 220, 6, 57, // Opcode: MOV8eb
/* 2130 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2139
/* 2135 */    MCD::OPC_Decode, 229, 6, 58, // Opcode: MOV8eq
/* 2139 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2155
/* 2144 */    MCD::OPC_CheckField, 24, 4, 8, 207, 40, 0, // Skip to: 12598
/* 2151 */    MCD::OPC_Decode, 226, 6, 59, // Opcode: MOV8ek
/* 2155 */    MCD::OPC_FilterValue, 4, 198, 40, 0, // Skip to: 12598
/* 2160 */    MCD::OPC_CheckField, 24, 8, 0, 191, 40, 0, // Skip to: 12598
/* 2167 */    MCD::OPC_Decode, 224, 6, 60, // Opcode: MOV8ei
/* 2171 */    MCD::OPC_FilterValue, 40, 4, 0, 0, // Skip to: 2180
/* 2176 */    MCD::OPC_Decode, 143, 7, 61, // Opcode: MOV8pd
/* 2180 */    MCD::OPC_FilterValue, 42, 4, 0, 0, // Skip to: 2189
/* 2185 */    MCD::OPC_Decode, 147, 7, 62, // Opcode: MOV8pj
/* 2189 */    MCD::OPC_FilterValue, 43, 4, 0, 0, // Skip to: 2198
/* 2194 */    MCD::OPC_Decode, 149, 7, 62, // Opcode: MOV8po
/* 2198 */    MCD::OPC_FilterValue, 44, 4, 0, 0, // Skip to: 2207
/* 2203 */    MCD::OPC_Decode, 144, 7, 62, // Opcode: MOV8pe
/* 2207 */    MCD::OPC_FilterValue, 45, 4, 0, 0, // Skip to: 2216
/* 2212 */    MCD::OPC_Decode, 150, 7, 63, // Opcode: MOV8pp
/* 2216 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 2232
/* 2221 */    MCD::OPC_CheckField, 24, 4, 8, 130, 40, 0, // Skip to: 12598
/* 2228 */    MCD::OPC_Decode, 145, 7, 64, // Opcode: MOV8pf
/* 2232 */    MCD::OPC_FilterValue, 47, 53, 0, 0, // Skip to: 2290
/* 2237 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2240 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2249
/* 2245 */    MCD::OPC_Decode, 142, 7, 65, // Opcode: MOV8pb
/* 2249 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2258
/* 2254 */    MCD::OPC_Decode, 151, 7, 66, // Opcode: MOV8pq
/* 2258 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2274
/* 2263 */    MCD::OPC_CheckField, 24, 4, 8, 88, 40, 0, // Skip to: 12598
/* 2270 */    MCD::OPC_Decode, 148, 7, 67, // Opcode: MOV8pk
/* 2274 */    MCD::OPC_FilterValue, 4, 79, 40, 0, // Skip to: 12598
/* 2279 */    MCD::OPC_CheckField, 24, 8, 0, 72, 40, 0, // Skip to: 12598
/* 2286 */    MCD::OPC_Decode, 146, 7, 68, // Opcode: MOV8pi
/* 2290 */    MCD::OPC_FilterValue, 48, 11, 0, 0, // Skip to: 2306
/* 2295 */    MCD::OPC_CheckField, 24, 4, 8, 56, 40, 0, // Skip to: 12598
/* 2302 */    MCD::OPC_Decode, 231, 6, 69, // Opcode: MOV8fd
/* 2306 */    MCD::OPC_FilterValue, 50, 11, 0, 0, // Skip to: 2322
/* 2311 */    MCD::OPC_CheckField, 24, 4, 8, 40, 40, 0, // Skip to: 12598
/* 2318 */    MCD::OPC_Decode, 235, 6, 70, // Opcode: MOV8fj
/* 2322 */    MCD::OPC_FilterValue, 51, 11, 0, 0, // Skip to: 2338
/* 2327 */    MCD::OPC_CheckField, 24, 4, 8, 24, 40, 0, // Skip to: 12598
/* 2334 */    MCD::OPC_Decode, 237, 6, 70, // Opcode: MOV8fo
/* 2338 */    MCD::OPC_FilterValue, 52, 11, 0, 0, // Skip to: 2354
/* 2343 */    MCD::OPC_CheckField, 24, 4, 8, 8, 40, 0, // Skip to: 12598
/* 2350 */    MCD::OPC_Decode, 232, 6, 70, // Opcode: MOV8fe
/* 2354 */    MCD::OPC_FilterValue, 53, 11, 0, 0, // Skip to: 2370
/* 2359 */    MCD::OPC_CheckField, 40, 4, 8, 248, 39, 0, // Skip to: 12598
/* 2366 */    MCD::OPC_Decode, 238, 6, 71, // Opcode: MOV8fp
/* 2370 */    MCD::OPC_FilterValue, 54, 18, 0, 0, // Skip to: 2393
/* 2375 */    MCD::OPC_CheckField, 40, 4, 8, 232, 39, 0, // Skip to: 12598
/* 2382 */    MCD::OPC_CheckField, 24, 4, 8, 225, 39, 0, // Skip to: 12598
/* 2389 */    MCD::OPC_Decode, 233, 6, 72, // Opcode: MOV8ff
/* 2393 */    MCD::OPC_FilterValue, 55, 81, 0, 0, // Skip to: 2479
/* 2398 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2401 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2417
/* 2406 */    MCD::OPC_CheckField, 56, 4, 8, 201, 39, 0, // Skip to: 12598
/* 2413 */    MCD::OPC_Decode, 230, 6, 73, // Opcode: MOV8fb
/* 2417 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2433
/* 2422 */    MCD::OPC_CheckField, 40, 4, 8, 185, 39, 0, // Skip to: 12598
/* 2429 */    MCD::OPC_Decode, 239, 6, 74, // Opcode: MOV8fq
/* 2433 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 2456
/* 2438 */    MCD::OPC_CheckField, 40, 4, 8, 169, 39, 0, // Skip to: 12598
/* 2445 */    MCD::OPC_CheckField, 24, 4, 8, 162, 39, 0, // Skip to: 12598
/* 2452 */    MCD::OPC_Decode, 236, 6, 75, // Opcode: MOV8fk
/* 2456 */    MCD::OPC_FilterValue, 4, 153, 39, 0, // Skip to: 12598
/* 2461 */    MCD::OPC_CheckField, 40, 4, 8, 146, 39, 0, // Skip to: 12598
/* 2468 */    MCD::OPC_CheckField, 24, 8, 0, 139, 39, 0, // Skip to: 12598
/* 2475 */    MCD::OPC_Decode, 234, 6, 76, // Opcode: MOV8fi
/* 2479 */    MCD::OPC_FilterValue, 56, 37, 0, 0, // Skip to: 2521
/* 2484 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2487 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2496
/* 2492 */    MCD::OPC_Decode, 201, 6, 77, // Opcode: MOV8bd
/* 2496 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2505
/* 2501 */    MCD::OPC_Decode, 153, 7, 78, // Opcode: MOV8qd
/* 2505 */    MCD::OPC_FilterValue, 3, 104, 39, 0, // Skip to: 12598
/* 2510 */    MCD::OPC_CheckField, 24, 4, 8, 97, 39, 0, // Skip to: 12598
/* 2517 */    MCD::OPC_Decode, 251, 6, 79, // Opcode: MOV8kd
/* 2521 */    MCD::OPC_FilterValue, 58, 37, 0, 0, // Skip to: 2563
/* 2526 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2529 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2538
/* 2534 */    MCD::OPC_Decode, 205, 6, 28, // Opcode: MOV8bj
/* 2538 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2547
/* 2543 */    MCD::OPC_Decode, 157, 7, 17, // Opcode: MOV8qj
/* 2547 */    MCD::OPC_FilterValue, 3, 62, 39, 0, // Skip to: 12598
/* 2552 */    MCD::OPC_CheckField, 24, 4, 8, 55, 39, 0, // Skip to: 12598
/* 2559 */    MCD::OPC_Decode, 255, 6, 80, // Opcode: MOV8kj
/* 2563 */    MCD::OPC_FilterValue, 59, 37, 0, 0, // Skip to: 2605
/* 2568 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2571 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2580
/* 2576 */    MCD::OPC_Decode, 207, 6, 28, // Opcode: MOV8bo
/* 2580 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2589
/* 2585 */    MCD::OPC_Decode, 159, 7, 17, // Opcode: MOV8qo
/* 2589 */    MCD::OPC_FilterValue, 3, 20, 39, 0, // Skip to: 12598
/* 2594 */    MCD::OPC_CheckField, 24, 4, 8, 13, 39, 0, // Skip to: 12598
/* 2601 */    MCD::OPC_Decode, 129, 7, 80, // Opcode: MOV8ko
/* 2605 */    MCD::OPC_FilterValue, 60, 37, 0, 0, // Skip to: 2647
/* 2610 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2613 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2622
/* 2618 */    MCD::OPC_Decode, 202, 6, 28, // Opcode: MOV8be
/* 2622 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2631
/* 2627 */    MCD::OPC_Decode, 154, 7, 17, // Opcode: MOV8qe
/* 2631 */    MCD::OPC_FilterValue, 3, 234, 38, 0, // Skip to: 12598
/* 2636 */    MCD::OPC_CheckField, 24, 4, 8, 227, 38, 0, // Skip to: 12598
/* 2643 */    MCD::OPC_Decode, 252, 6, 80, // Opcode: MOV8ke
/* 2647 */    MCD::OPC_FilterValue, 61, 37, 0, 0, // Skip to: 2689
/* 2652 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2655 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2664
/* 2660 */    MCD::OPC_Decode, 208, 6, 81, // Opcode: MOV8bp
/* 2664 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2673
/* 2669 */    MCD::OPC_Decode, 160, 7, 82, // Opcode: MOV8qp
/* 2673 */    MCD::OPC_FilterValue, 3, 192, 38, 0, // Skip to: 12598
/* 2678 */    MCD::OPC_CheckField, 40, 4, 8, 185, 38, 0, // Skip to: 12598
/* 2685 */    MCD::OPC_Decode, 130, 7, 83, // Opcode: MOV8kp
/* 2689 */    MCD::OPC_FilterValue, 62, 58, 0, 0, // Skip to: 2752
/* 2694 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2697 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2713
/* 2702 */    MCD::OPC_CheckField, 24, 4, 8, 161, 38, 0, // Skip to: 12598
/* 2709 */    MCD::OPC_Decode, 203, 6, 84, // Opcode: MOV8bf
/* 2713 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2729
/* 2718 */    MCD::OPC_CheckField, 24, 4, 8, 145, 38, 0, // Skip to: 12598
/* 2725 */    MCD::OPC_Decode, 155, 7, 85, // Opcode: MOV8qf
/* 2729 */    MCD::OPC_FilterValue, 3, 136, 38, 0, // Skip to: 12598
/* 2734 */    MCD::OPC_CheckField, 40, 4, 8, 129, 38, 0, // Skip to: 12598
/* 2741 */    MCD::OPC_CheckField, 24, 4, 8, 122, 38, 0, // Skip to: 12598
/* 2748 */    MCD::OPC_Decode, 253, 6, 86, // Opcode: MOV8kf
/* 2752 */    MCD::OPC_FilterValue, 63, 113, 38, 0, // Skip to: 12598
/* 2757 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 2760 */    MCD::OPC_FilterValue, 1, 37, 0, 0, // Skip to: 2802
/* 2765 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2768 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2777
/* 2773 */    MCD::OPC_Decode, 200, 6, 87, // Opcode: MOV8bb
/* 2777 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2786
/* 2782 */    MCD::OPC_Decode, 152, 7, 88, // Opcode: MOV8qb
/* 2786 */    MCD::OPC_FilterValue, 3, 79, 38, 0, // Skip to: 12598
/* 2791 */    MCD::OPC_CheckField, 56, 4, 8, 72, 38, 0, // Skip to: 12598
/* 2798 */    MCD::OPC_Decode, 250, 6, 89, // Opcode: MOV8kb
/* 2802 */    MCD::OPC_FilterValue, 2, 37, 0, 0, // Skip to: 2844
/* 2807 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2810 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 2819
/* 2815 */    MCD::OPC_Decode, 209, 6, 90, // Opcode: MOV8bq
/* 2819 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 2828
/* 2824 */    MCD::OPC_Decode, 161, 7, 91, // Opcode: MOV8qq
/* 2828 */    MCD::OPC_FilterValue, 3, 37, 38, 0, // Skip to: 12598
/* 2833 */    MCD::OPC_CheckField, 40, 4, 8, 30, 38, 0, // Skip to: 12598
/* 2840 */    MCD::OPC_Decode, 131, 7, 92, // Opcode: MOV8kq
/* 2844 */    MCD::OPC_FilterValue, 3, 58, 0, 0, // Skip to: 2907
/* 2849 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2852 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2868
/* 2857 */    MCD::OPC_CheckField, 24, 4, 8, 6, 38, 0, // Skip to: 12598
/* 2864 */    MCD::OPC_Decode, 206, 6, 93, // Opcode: MOV8bk
/* 2868 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2884
/* 2873 */    MCD::OPC_CheckField, 24, 4, 8, 246, 37, 0, // Skip to: 12598
/* 2880 */    MCD::OPC_Decode, 158, 7, 94, // Opcode: MOV8qk
/* 2884 */    MCD::OPC_FilterValue, 3, 237, 37, 0, // Skip to: 12598
/* 2889 */    MCD::OPC_CheckField, 40, 4, 8, 230, 37, 0, // Skip to: 12598
/* 2896 */    MCD::OPC_CheckField, 24, 4, 8, 223, 37, 0, // Skip to: 12598
/* 2903 */    MCD::OPC_Decode, 128, 7, 95, // Opcode: MOV8kk
/* 2907 */    MCD::OPC_FilterValue, 4, 214, 37, 0, // Skip to: 12598
/* 2912 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 2915 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2931
/* 2920 */    MCD::OPC_CheckField, 24, 8, 0, 199, 37, 0, // Skip to: 12598
/* 2927 */    MCD::OPC_Decode, 204, 6, 96, // Opcode: MOV8bi
/* 2931 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2947
/* 2936 */    MCD::OPC_CheckField, 24, 8, 0, 183, 37, 0, // Skip to: 12598
/* 2943 */    MCD::OPC_Decode, 156, 7, 8, // Opcode: MOV8qi
/* 2947 */    MCD::OPC_FilterValue, 3, 174, 37, 0, // Skip to: 12598
/* 2952 */    MCD::OPC_CheckField, 40, 4, 8, 167, 37, 0, // Skip to: 12598
/* 2959 */    MCD::OPC_CheckField, 24, 8, 0, 160, 37, 0, // Skip to: 12598
/* 2966 */    MCD::OPC_Decode, 254, 6, 9, // Opcode: MOV8ki
/* 2970 */    MCD::OPC_FilterValue, 2, 178, 7, 0, // Skip to: 4945
/* 2975 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 2978 */    MCD::OPC_FilterValue, 0, 94, 1, 0, // Skip to: 3333
/* 2983 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 2986 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 3045
/* 2991 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 2994 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3010
/* 2999 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 3030
/* 3006 */    MCD::OPC_Decode, 216, 5, 97, // Opcode: MOV32dd
/* 3010 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 3030
/* 3015 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3026
/* 3022 */    MCD::OPC_Decode, 184, 5, 54, // Opcode: MOV32aa
/* 3026 */    MCD::OPC_Decode, 181, 6, 98, // Opcode: MOV32ra
/* 3030 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 3041
/* 3037 */    MCD::OPC_Decode, 202, 5, 99, // Opcode: MOV32ar
/* 3041 */    MCD::OPC_Decode, 199, 6, 100, // Opcode: MOV32rr
/* 3045 */    MCD::OPC_FilterValue, 1, 63, 0, 0, // Skip to: 3113
/* 3050 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3053 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3083
/* 3058 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3061 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3070
/* 3066 */    MCD::OPC_Decode, 251, 5, 101, // Opcode: MOV32jd
/* 3070 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3079
/* 3075 */    MCD::OPC_Decode, 249, 5, 54, // Opcode: MOV32ja
/* 3079 */    MCD::OPC_Decode, 132, 6, 99, // Opcode: MOV32jr
/* 3083 */    MCD::OPC_FilterValue, 1, 38, 37, 0, // Skip to: 12598
/* 3088 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3091 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3100
/* 3096 */    MCD::OPC_Decode, 147, 6, 101, // Opcode: MOV32od
/* 3100 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3109
/* 3105 */    MCD::OPC_Decode, 145, 6, 54, // Opcode: MOV32oa
/* 3109 */    MCD::OPC_Decode, 156, 6, 99, // Opcode: MOV32or
/* 3113 */    MCD::OPC_FilterValue, 2, 63, 0, 0, // Skip to: 3181
/* 3118 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3121 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3151
/* 3126 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3129 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3138
/* 3134 */    MCD::OPC_Decode, 227, 5, 101, // Opcode: MOV32ed
/* 3138 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3147
/* 3143 */    MCD::OPC_Decode, 225, 5, 54, // Opcode: MOV32ea
/* 3147 */    MCD::OPC_Decode, 236, 5, 99, // Opcode: MOV32er
/* 3151 */    MCD::OPC_FilterValue, 1, 226, 36, 0, // Skip to: 12598
/* 3156 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3159 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3168
/* 3164 */    MCD::OPC_Decode, 159, 6, 102, // Opcode: MOV32pd
/* 3168 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3177
/* 3173 */    MCD::OPC_Decode, 157, 6, 62, // Opcode: MOV32pa
/* 3177 */    MCD::OPC_Decode, 168, 6, 103, // Opcode: MOV32pr
/* 3181 */    MCD::OPC_FilterValue, 3, 196, 36, 0, // Skip to: 12598
/* 3186 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3189 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3227
/* 3194 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3197 */    MCD::OPC_FilterValue, 8, 180, 36, 0, // Skip to: 12598
/* 3202 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3205 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3214
/* 3210 */    MCD::OPC_Decode, 239, 5, 104, // Opcode: MOV32fd
/* 3214 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3223
/* 3219 */    MCD::OPC_Decode, 237, 5, 70, // Opcode: MOV32fa
/* 3223 */    MCD::OPC_Decode, 248, 5, 105, // Opcode: MOV32fr
/* 3227 */    MCD::OPC_FilterValue, 1, 150, 36, 0, // Skip to: 12598
/* 3232 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3235 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 3265
/* 3240 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3243 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3252
/* 3248 */    MCD::OPC_Decode, 205, 5, 26, // Opcode: MOV32bd
/* 3252 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3261
/* 3257 */    MCD::OPC_Decode, 203, 5, 28, // Opcode: MOV32ba
/* 3261 */    MCD::OPC_Decode, 214, 5, 106, // Opcode: MOV32br
/* 3265 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 3295
/* 3270 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3273 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3282
/* 3278 */    MCD::OPC_Decode, 171, 6, 107, // Opcode: MOV32qd
/* 3282 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3291
/* 3287 */    MCD::OPC_Decode, 169, 6, 17, // Opcode: MOV32qa
/* 3291 */    MCD::OPC_Decode, 180, 6, 108, // Opcode: MOV32qr
/* 3295 */    MCD::OPC_FilterValue, 3, 82, 36, 0, // Skip to: 12598
/* 3300 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 3303 */    MCD::OPC_FilterValue, 8, 74, 36, 0, // Skip to: 12598
/* 3308 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3311 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3320
/* 3316 */    MCD::OPC_Decode, 135, 6, 109, // Opcode: MOV32kd
/* 3320 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3329
/* 3325 */    MCD::OPC_Decode, 133, 6, 80, // Opcode: MOV32ka
/* 3329 */    MCD::OPC_Decode, 144, 6, 110, // Opcode: MOV32kr
/* 3333 */    MCD::OPC_FilterValue, 1, 75, 1, 0, // Skip to: 3669
/* 3338 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3341 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 3409
/* 3346 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3349 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3379
/* 3354 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3357 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3366
/* 3362 */    MCD::OPC_Decode, 220, 5, 111, // Opcode: MOV32dj
/* 3366 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3375
/* 3371 */    MCD::OPC_Decode, 192, 5, 54, // Opcode: MOV32aj
/* 3375 */    MCD::OPC_Decode, 189, 6, 98, // Opcode: MOV32rj
/* 3379 */    MCD::OPC_FilterValue, 1, 254, 35, 0, // Skip to: 12598
/* 3384 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3387 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3396
/* 3392 */    MCD::OPC_Decode, 222, 5, 111, // Opcode: MOV32do
/* 3396 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3405
/* 3401 */    MCD::OPC_Decode, 196, 5, 54, // Opcode: MOV32ao
/* 3405 */    MCD::OPC_Decode, 193, 6, 98, // Opcode: MOV32ro
/* 3409 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 3469
/* 3414 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3417 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3443
/* 3422 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3425 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3434
/* 3430 */    MCD::OPC_Decode, 255, 5, 54, // Opcode: MOV32jj
/* 3434 */    MCD::OPC_FilterValue, 1, 199, 35, 0, // Skip to: 12598
/* 3439 */    MCD::OPC_Decode, 151, 6, 54, // Opcode: MOV32oj
/* 3443 */    MCD::OPC_FilterValue, 1, 190, 35, 0, // Skip to: 12598
/* 3448 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3451 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3460
/* 3456 */    MCD::OPC_Decode, 129, 6, 54, // Opcode: MOV32jo
/* 3460 */    MCD::OPC_FilterValue, 1, 173, 35, 0, // Skip to: 12598
/* 3465 */    MCD::OPC_Decode, 153, 6, 54, // Opcode: MOV32oo
/* 3469 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 3529
/* 3474 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3477 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3503
/* 3482 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3485 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3494
/* 3490 */    MCD::OPC_Decode, 231, 5, 54, // Opcode: MOV32ej
/* 3494 */    MCD::OPC_FilterValue, 1, 139, 35, 0, // Skip to: 12598
/* 3499 */    MCD::OPC_Decode, 163, 6, 62, // Opcode: MOV32pj
/* 3503 */    MCD::OPC_FilterValue, 1, 130, 35, 0, // Skip to: 12598
/* 3508 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3511 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3520
/* 3516 */    MCD::OPC_Decode, 233, 5, 54, // Opcode: MOV32eo
/* 3520 */    MCD::OPC_FilterValue, 1, 113, 35, 0, // Skip to: 12598
/* 3525 */    MCD::OPC_Decode, 165, 6, 62, // Opcode: MOV32po
/* 3529 */    MCD::OPC_FilterValue, 3, 104, 35, 0, // Skip to: 12598
/* 3534 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3537 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 3603
/* 3542 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3545 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3561
/* 3550 */    MCD::OPC_CheckField, 24, 4, 8, 81, 35, 0, // Skip to: 12598
/* 3557 */    MCD::OPC_Decode, 243, 5, 70, // Opcode: MOV32fj
/* 3561 */    MCD::OPC_FilterValue, 1, 72, 35, 0, // Skip to: 12598
/* 3566 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3569 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3578
/* 3574 */    MCD::OPC_Decode, 209, 5, 28, // Opcode: MOV32bj
/* 3578 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3587
/* 3583 */    MCD::OPC_Decode, 175, 6, 17, // Opcode: MOV32qj
/* 3587 */    MCD::OPC_FilterValue, 3, 46, 35, 0, // Skip to: 12598
/* 3592 */    MCD::OPC_CheckField, 24, 4, 8, 39, 35, 0, // Skip to: 12598
/* 3599 */    MCD::OPC_Decode, 139, 6, 80, // Opcode: MOV32kj
/* 3603 */    MCD::OPC_FilterValue, 1, 30, 35, 0, // Skip to: 12598
/* 3608 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3611 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3627
/* 3616 */    MCD::OPC_CheckField, 24, 4, 8, 15, 35, 0, // Skip to: 12598
/* 3623 */    MCD::OPC_Decode, 245, 5, 70, // Opcode: MOV32fo
/* 3627 */    MCD::OPC_FilterValue, 1, 6, 35, 0, // Skip to: 12598
/* 3632 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3635 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3644
/* 3640 */    MCD::OPC_Decode, 211, 5, 28, // Opcode: MOV32bo
/* 3644 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3653
/* 3649 */    MCD::OPC_Decode, 177, 6, 17, // Opcode: MOV32qo
/* 3653 */    MCD::OPC_FilterValue, 3, 236, 34, 0, // Skip to: 12598
/* 3658 */    MCD::OPC_CheckField, 24, 4, 8, 229, 34, 0, // Skip to: 12598
/* 3665 */    MCD::OPC_Decode, 141, 6, 80, // Opcode: MOV32ko
/* 3669 */    MCD::OPC_FilterValue, 2, 75, 1, 0, // Skip to: 4005
/* 3674 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 3677 */    MCD::OPC_FilterValue, 0, 63, 0, 0, // Skip to: 3745
/* 3682 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3685 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 3715
/* 3690 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3693 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3702
/* 3698 */    MCD::OPC_Decode, 217, 5, 111, // Opcode: MOV32de
/* 3702 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3711
/* 3707 */    MCD::OPC_Decode, 187, 5, 54, // Opcode: MOV32ae
/* 3711 */    MCD::OPC_Decode, 184, 6, 98, // Opcode: MOV32re
/* 3715 */    MCD::OPC_FilterValue, 1, 174, 34, 0, // Skip to: 12598
/* 3720 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3723 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3732
/* 3728 */    MCD::OPC_Decode, 223, 5, 112, // Opcode: MOV32dp
/* 3732 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3741
/* 3737 */    MCD::OPC_Decode, 198, 5, 55, // Opcode: MOV32ap
/* 3741 */    MCD::OPC_Decode, 195, 6, 113, // Opcode: MOV32rp
/* 3745 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 3805
/* 3750 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3753 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3779
/* 3758 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3761 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3770
/* 3766 */    MCD::OPC_Decode, 252, 5, 54, // Opcode: MOV32je
/* 3770 */    MCD::OPC_FilterValue, 1, 119, 34, 0, // Skip to: 12598
/* 3775 */    MCD::OPC_Decode, 148, 6, 54, // Opcode: MOV32oe
/* 3779 */    MCD::OPC_FilterValue, 1, 110, 34, 0, // Skip to: 12598
/* 3784 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3787 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3796
/* 3792 */    MCD::OPC_Decode, 130, 6, 55, // Opcode: MOV32jp
/* 3796 */    MCD::OPC_FilterValue, 1, 93, 34, 0, // Skip to: 12598
/* 3801 */    MCD::OPC_Decode, 154, 6, 55, // Opcode: MOV32op
/* 3805 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 3865
/* 3810 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3813 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 3839
/* 3818 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3821 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3830
/* 3826 */    MCD::OPC_Decode, 228, 5, 54, // Opcode: MOV32ee
/* 3830 */    MCD::OPC_FilterValue, 1, 59, 34, 0, // Skip to: 12598
/* 3835 */    MCD::OPC_Decode, 160, 6, 62, // Opcode: MOV32pe
/* 3839 */    MCD::OPC_FilterValue, 1, 50, 34, 0, // Skip to: 12598
/* 3844 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3847 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 3856
/* 3852 */    MCD::OPC_Decode, 234, 5, 55, // Opcode: MOV32ep
/* 3856 */    MCD::OPC_FilterValue, 1, 33, 34, 0, // Skip to: 12598
/* 3861 */    MCD::OPC_Decode, 166, 6, 63, // Opcode: MOV32pp
/* 3865 */    MCD::OPC_FilterValue, 3, 24, 34, 0, // Skip to: 12598
/* 3870 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 3873 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 3939
/* 3878 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3881 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3897
/* 3886 */    MCD::OPC_CheckField, 24, 4, 8, 1, 34, 0, // Skip to: 12598
/* 3893 */    MCD::OPC_Decode, 240, 5, 70, // Opcode: MOV32fe
/* 3897 */    MCD::OPC_FilterValue, 1, 248, 33, 0, // Skip to: 12598
/* 3902 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3905 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3914
/* 3910 */    MCD::OPC_Decode, 206, 5, 28, // Opcode: MOV32be
/* 3914 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3923
/* 3919 */    MCD::OPC_Decode, 172, 6, 17, // Opcode: MOV32qe
/* 3923 */    MCD::OPC_FilterValue, 3, 222, 33, 0, // Skip to: 12598
/* 3928 */    MCD::OPC_CheckField, 24, 4, 8, 215, 33, 0, // Skip to: 12598
/* 3935 */    MCD::OPC_Decode, 136, 6, 80, // Opcode: MOV32ke
/* 3939 */    MCD::OPC_FilterValue, 1, 206, 33, 0, // Skip to: 12598
/* 3944 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 3947 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 3963
/* 3952 */    MCD::OPC_CheckField, 40, 4, 8, 191, 33, 0, // Skip to: 12598
/* 3959 */    MCD::OPC_Decode, 246, 5, 71, // Opcode: MOV32fp
/* 3963 */    MCD::OPC_FilterValue, 1, 182, 33, 0, // Skip to: 12598
/* 3968 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 3971 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 3980
/* 3976 */    MCD::OPC_Decode, 212, 5, 81, // Opcode: MOV32bp
/* 3980 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 3989
/* 3985 */    MCD::OPC_Decode, 178, 6, 82, // Opcode: MOV32qp
/* 3989 */    MCD::OPC_FilterValue, 3, 156, 33, 0, // Skip to: 12598
/* 3994 */    MCD::OPC_CheckField, 40, 4, 8, 149, 33, 0, // Skip to: 12598
/* 4001 */    MCD::OPC_Decode, 142, 6, 83, // Opcode: MOV32kp
/* 4005 */    MCD::OPC_FilterValue, 3, 140, 33, 0, // Skip to: 12598
/* 4010 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4013 */    MCD::OPC_FilterValue, 0, 177, 0, 0, // Skip to: 4195
/* 4018 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4021 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 4059
/* 4026 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4029 */    MCD::OPC_FilterValue, 8, 116, 33, 0, // Skip to: 12598
/* 4034 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4037 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4046
/* 4042 */    MCD::OPC_Decode, 218, 5, 114, // Opcode: MOV32df
/* 4046 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4055
/* 4051 */    MCD::OPC_Decode, 189, 5, 56, // Opcode: MOV32af
/* 4055 */    MCD::OPC_Decode, 186, 6, 115, // Opcode: MOV32rf
/* 4059 */    MCD::OPC_FilterValue, 1, 86, 33, 0, // Skip to: 12598
/* 4064 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4067 */    MCD::OPC_FilterValue, 1, 25, 0, 0, // Skip to: 4097
/* 4072 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4075 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4084
/* 4080 */    MCD::OPC_Decode, 215, 5, 116, // Opcode: MOV32db
/* 4084 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4093
/* 4089 */    MCD::OPC_Decode, 185, 5, 57, // Opcode: MOV32ab
/* 4093 */    MCD::OPC_Decode, 182, 6, 117, // Opcode: MOV32rb
/* 4097 */    MCD::OPC_FilterValue, 2, 25, 0, 0, // Skip to: 4127
/* 4102 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4105 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4114
/* 4110 */    MCD::OPC_Decode, 224, 5, 118, // Opcode: MOV32dq
/* 4114 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4123
/* 4119 */    MCD::OPC_Decode, 200, 5, 58, // Opcode: MOV32aq
/* 4123 */    MCD::OPC_Decode, 197, 6, 119, // Opcode: MOV32rq
/* 4127 */    MCD::OPC_FilterValue, 3, 33, 0, 0, // Skip to: 4165
/* 4132 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 4135 */    MCD::OPC_FilterValue, 8, 10, 33, 0, // Skip to: 12598
/* 4140 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4143 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4152
/* 4148 */    MCD::OPC_Decode, 221, 5, 120, // Opcode: MOV32dk
/* 4152 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4161
/* 4157 */    MCD::OPC_Decode, 194, 5, 59, // Opcode: MOV32ak
/* 4161 */    MCD::OPC_Decode, 191, 6, 121, // Opcode: MOV32rk
/* 4165 */    MCD::OPC_FilterValue, 4, 236, 32, 0, // Skip to: 12598
/* 4170 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4173 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4182
/* 4178 */    MCD::OPC_Decode, 219, 5, 116, // Opcode: MOV32di
/* 4182 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4191
/* 4187 */    MCD::OPC_Decode, 191, 5, 57, // Opcode: MOV32ai
/* 4191 */    MCD::OPC_Decode, 188, 6, 117, // Opcode: MOV32ri
/* 4195 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 4369
/* 4200 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4203 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4243
/* 4208 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4211 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4227
/* 4216 */    MCD::OPC_CheckField, 24, 4, 8, 183, 32, 0, // Skip to: 12598
/* 4223 */    MCD::OPC_Decode, 253, 5, 56, // Opcode: MOV32jf
/* 4227 */    MCD::OPC_FilterValue, 1, 174, 32, 0, // Skip to: 12598
/* 4232 */    MCD::OPC_CheckField, 24, 4, 8, 167, 32, 0, // Skip to: 12598
/* 4239 */    MCD::OPC_Decode, 149, 6, 56, // Opcode: MOV32of
/* 4243 */    MCD::OPC_FilterValue, 1, 158, 32, 0, // Skip to: 12598
/* 4248 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4251 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4277
/* 4256 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4259 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4268
/* 4264 */    MCD::OPC_Decode, 250, 5, 57, // Opcode: MOV32jb
/* 4268 */    MCD::OPC_FilterValue, 1, 133, 32, 0, // Skip to: 12598
/* 4273 */    MCD::OPC_Decode, 146, 6, 57, // Opcode: MOV32ob
/* 4277 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4303
/* 4282 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4285 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4294
/* 4290 */    MCD::OPC_Decode, 131, 6, 58, // Opcode: MOV32jq
/* 4294 */    MCD::OPC_FilterValue, 1, 107, 32, 0, // Skip to: 12598
/* 4299 */    MCD::OPC_Decode, 155, 6, 58, // Opcode: MOV32oq
/* 4303 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 4343
/* 4308 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4311 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4327
/* 4316 */    MCD::OPC_CheckField, 24, 4, 8, 83, 32, 0, // Skip to: 12598
/* 4323 */    MCD::OPC_Decode, 128, 6, 59, // Opcode: MOV32jk
/* 4327 */    MCD::OPC_FilterValue, 1, 74, 32, 0, // Skip to: 12598
/* 4332 */    MCD::OPC_CheckField, 24, 4, 8, 67, 32, 0, // Skip to: 12598
/* 4339 */    MCD::OPC_Decode, 152, 6, 59, // Opcode: MOV32ok
/* 4343 */    MCD::OPC_FilterValue, 4, 58, 32, 0, // Skip to: 12598
/* 4348 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4351 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4360
/* 4356 */    MCD::OPC_Decode, 254, 5, 57, // Opcode: MOV32ji
/* 4360 */    MCD::OPC_FilterValue, 1, 41, 32, 0, // Skip to: 12598
/* 4365 */    MCD::OPC_Decode, 150, 6, 57, // Opcode: MOV32oi
/* 4369 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 4543
/* 4374 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4377 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 4417
/* 4382 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4385 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4401
/* 4390 */    MCD::OPC_CheckField, 24, 4, 8, 9, 32, 0, // Skip to: 12598
/* 4397 */    MCD::OPC_Decode, 229, 5, 56, // Opcode: MOV32ef
/* 4401 */    MCD::OPC_FilterValue, 1, 0, 32, 0, // Skip to: 12598
/* 4406 */    MCD::OPC_CheckField, 24, 4, 8, 249, 31, 0, // Skip to: 12598
/* 4413 */    MCD::OPC_Decode, 161, 6, 64, // Opcode: MOV32pf
/* 4417 */    MCD::OPC_FilterValue, 1, 240, 31, 0, // Skip to: 12598
/* 4422 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4425 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 4451
/* 4430 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4433 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4442
/* 4438 */    MCD::OPC_Decode, 226, 5, 57, // Opcode: MOV32eb
/* 4442 */    MCD::OPC_FilterValue, 1, 215, 31, 0, // Skip to: 12598
/* 4447 */    MCD::OPC_Decode, 158, 6, 65, // Opcode: MOV32pb
/* 4451 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 4477
/* 4456 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4459 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4468
/* 4464 */    MCD::OPC_Decode, 235, 5, 58, // Opcode: MOV32eq
/* 4468 */    MCD::OPC_FilterValue, 1, 189, 31, 0, // Skip to: 12598
/* 4473 */    MCD::OPC_Decode, 167, 6, 66, // Opcode: MOV32pq
/* 4477 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 4517
/* 4482 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4485 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4501
/* 4490 */    MCD::OPC_CheckField, 24, 4, 8, 165, 31, 0, // Skip to: 12598
/* 4497 */    MCD::OPC_Decode, 232, 5, 59, // Opcode: MOV32ek
/* 4501 */    MCD::OPC_FilterValue, 1, 156, 31, 0, // Skip to: 12598
/* 4506 */    MCD::OPC_CheckField, 24, 4, 8, 149, 31, 0, // Skip to: 12598
/* 4513 */    MCD::OPC_Decode, 164, 6, 67, // Opcode: MOV32pk
/* 4517 */    MCD::OPC_FilterValue, 4, 140, 31, 0, // Skip to: 12598
/* 4522 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4525 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 4534
/* 4530 */    MCD::OPC_Decode, 230, 5, 57, // Opcode: MOV32ei
/* 4534 */    MCD::OPC_FilterValue, 1, 123, 31, 0, // Skip to: 12598
/* 4539 */    MCD::OPC_Decode, 162, 6, 65, // Opcode: MOV32pi
/* 4543 */    MCD::OPC_FilterValue, 3, 114, 31, 0, // Skip to: 12598
/* 4548 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4551 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 4645
/* 4556 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4559 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 4582
/* 4564 */    MCD::OPC_CheckField, 40, 4, 8, 91, 31, 0, // Skip to: 12598
/* 4571 */    MCD::OPC_CheckField, 24, 4, 8, 84, 31, 0, // Skip to: 12598
/* 4578 */    MCD::OPC_Decode, 241, 5, 72, // Opcode: MOV32ff
/* 4582 */    MCD::OPC_FilterValue, 1, 75, 31, 0, // Skip to: 12598
/* 4587 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4590 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4606
/* 4595 */    MCD::OPC_CheckField, 24, 4, 8, 60, 31, 0, // Skip to: 12598
/* 4602 */    MCD::OPC_Decode, 207, 5, 84, // Opcode: MOV32bf
/* 4606 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 4622
/* 4611 */    MCD::OPC_CheckField, 24, 4, 8, 44, 31, 0, // Skip to: 12598
/* 4618 */    MCD::OPC_Decode, 173, 6, 85, // Opcode: MOV32qf
/* 4622 */    MCD::OPC_FilterValue, 3, 35, 31, 0, // Skip to: 12598
/* 4627 */    MCD::OPC_CheckField, 40, 4, 8, 28, 31, 0, // Skip to: 12598
/* 4634 */    MCD::OPC_CheckField, 24, 4, 8, 21, 31, 0, // Skip to: 12598
/* 4641 */    MCD::OPC_Decode, 137, 6, 86, // Opcode: MOV32kf
/* 4645 */    MCD::OPC_FilterValue, 1, 12, 31, 0, // Skip to: 12598
/* 4650 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 4653 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 4719
/* 4658 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4661 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4677
/* 4666 */    MCD::OPC_CheckField, 56, 4, 8, 245, 30, 0, // Skip to: 12598
/* 4673 */    MCD::OPC_Decode, 238, 5, 73, // Opcode: MOV32fb
/* 4677 */    MCD::OPC_FilterValue, 1, 236, 30, 0, // Skip to: 12598
/* 4682 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4685 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4694
/* 4690 */    MCD::OPC_Decode, 204, 5, 87, // Opcode: MOV32bb
/* 4694 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4703
/* 4699 */    MCD::OPC_Decode, 170, 6, 88, // Opcode: MOV32qb
/* 4703 */    MCD::OPC_FilterValue, 3, 210, 30, 0, // Skip to: 12598
/* 4708 */    MCD::OPC_CheckField, 56, 4, 8, 203, 30, 0, // Skip to: 12598
/* 4715 */    MCD::OPC_Decode, 134, 6, 89, // Opcode: MOV32kb
/* 4719 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 4785
/* 4724 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4727 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4743
/* 4732 */    MCD::OPC_CheckField, 40, 4, 8, 179, 30, 0, // Skip to: 12598
/* 4739 */    MCD::OPC_Decode, 247, 5, 74, // Opcode: MOV32fq
/* 4743 */    MCD::OPC_FilterValue, 1, 170, 30, 0, // Skip to: 12598
/* 4748 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4751 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4760
/* 4756 */    MCD::OPC_Decode, 213, 5, 90, // Opcode: MOV32bq
/* 4760 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4769
/* 4765 */    MCD::OPC_Decode, 179, 6, 91, // Opcode: MOV32qq
/* 4769 */    MCD::OPC_FilterValue, 3, 144, 30, 0, // Skip to: 12598
/* 4774 */    MCD::OPC_CheckField, 40, 4, 8, 137, 30, 0, // Skip to: 12598
/* 4781 */    MCD::OPC_Decode, 143, 6, 92, // Opcode: MOV32kq
/* 4785 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 4879
/* 4790 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4793 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 4816
/* 4798 */    MCD::OPC_CheckField, 40, 4, 8, 113, 30, 0, // Skip to: 12598
/* 4805 */    MCD::OPC_CheckField, 24, 4, 8, 106, 30, 0, // Skip to: 12598
/* 4812 */    MCD::OPC_Decode, 244, 5, 75, // Opcode: MOV32fk
/* 4816 */    MCD::OPC_FilterValue, 1, 97, 30, 0, // Skip to: 12598
/* 4821 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4824 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 4840
/* 4829 */    MCD::OPC_CheckField, 24, 4, 8, 82, 30, 0, // Skip to: 12598
/* 4836 */    MCD::OPC_Decode, 210, 5, 93, // Opcode: MOV32bk
/* 4840 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 4856
/* 4845 */    MCD::OPC_CheckField, 24, 4, 8, 66, 30, 0, // Skip to: 12598
/* 4852 */    MCD::OPC_Decode, 176, 6, 94, // Opcode: MOV32qk
/* 4856 */    MCD::OPC_FilterValue, 3, 57, 30, 0, // Skip to: 12598
/* 4861 */    MCD::OPC_CheckField, 40, 4, 8, 50, 30, 0, // Skip to: 12598
/* 4868 */    MCD::OPC_CheckField, 24, 4, 8, 43, 30, 0, // Skip to: 12598
/* 4875 */    MCD::OPC_Decode, 140, 6, 95, // Opcode: MOV32kk
/* 4879 */    MCD::OPC_FilterValue, 4, 34, 30, 0, // Skip to: 12598
/* 4884 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 4887 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4903
/* 4892 */    MCD::OPC_CheckField, 56, 4, 8, 19, 30, 0, // Skip to: 12598
/* 4899 */    MCD::OPC_Decode, 242, 5, 73, // Opcode: MOV32fi
/* 4903 */    MCD::OPC_FilterValue, 1, 10, 30, 0, // Skip to: 12598
/* 4908 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 4911 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 4920
/* 4916 */    MCD::OPC_Decode, 208, 5, 87, // Opcode: MOV32bi
/* 4920 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 4929
/* 4925 */    MCD::OPC_Decode, 174, 6, 88, // Opcode: MOV32qi
/* 4929 */    MCD::OPC_FilterValue, 3, 240, 29, 0, // Skip to: 12598
/* 4934 */    MCD::OPC_CheckField, 56, 4, 8, 233, 29, 0, // Skip to: 12598
/* 4941 */    MCD::OPC_Decode, 138, 6, 89, // Opcode: MOV32ki
/* 4945 */    MCD::OPC_FilterValue, 3, 225, 7, 0, // Skip to: 6967
/* 4950 */    MCD::OPC_ExtractField, 4, 2,  // Inst{5-4} ...
/* 4953 */    MCD::OPC_FilterValue, 0, 114, 1, 0, // Skip to: 5328
/* 4958 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 4961 */    MCD::OPC_FilterValue, 0, 54, 0, 0, // Skip to: 5020
/* 4966 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 4969 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 4985
/* 4974 */    MCD::OPC_CheckField, 6, 1, 0, 24, 0, 0, // Skip to: 5005
/* 4981 */    MCD::OPC_Decode, 193, 4, 122, // Opcode: MOV16dd
/* 4985 */    MCD::OPC_FilterValue, 1, 15, 0, 0, // Skip to: 5005
/* 4990 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5001
/* 4997 */    MCD::OPC_Decode, 150, 4, 123, // Opcode: MOV16aa
/* 5001 */    MCD::OPC_Decode, 165, 5, 124, // Opcode: MOV16ra
/* 5005 */    MCD::OPC_CheckField, 6, 1, 1, 4, 0, 0, // Skip to: 5016
/* 5012 */    MCD::OPC_Decode, 168, 4, 125, // Opcode: MOV16ar
/* 5016 */    MCD::OPC_Decode, 183, 5, 126, // Opcode: MOV16rr
/* 5020 */    MCD::OPC_FilterValue, 1, 67, 0, 0, // Skip to: 5092
/* 5025 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5028 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5060
/* 5033 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5036 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5045
/* 5041 */    MCD::OPC_Decode, 231, 4, 127, // Opcode: MOV16jd
/* 5045 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5055
/* 5050 */    MCD::OPC_Decode, 228, 4, 128, 1, // Opcode: MOV16ja
/* 5055 */    MCD::OPC_Decode, 240, 4, 129, 1, // Opcode: MOV16jr
/* 5060 */    MCD::OPC_FilterValue, 1, 109, 29, 0, // Skip to: 12598
/* 5065 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5068 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5077
/* 5073 */    MCD::OPC_Decode, 129, 5, 127, // Opcode: MOV16od
/* 5077 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5087
/* 5082 */    MCD::OPC_Decode, 254, 4, 128, 1, // Opcode: MOV16oa
/* 5087 */    MCD::OPC_Decode, 138, 5, 129, 1, // Opcode: MOV16or
/* 5092 */    MCD::OPC_FilterValue, 2, 68, 0, 0, // Skip to: 5165
/* 5097 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5100 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 5132
/* 5105 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5108 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5117
/* 5113 */    MCD::OPC_Decode, 205, 4, 127, // Opcode: MOV16ed
/* 5117 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5127
/* 5122 */    MCD::OPC_Decode, 202, 4, 128, 1, // Opcode: MOV16ea
/* 5127 */    MCD::OPC_Decode, 214, 4, 129, 1, // Opcode: MOV16er
/* 5132 */    MCD::OPC_FilterValue, 1, 37, 29, 0, // Skip to: 12598
/* 5137 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5140 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5150
/* 5145 */    MCD::OPC_Decode, 142, 5, 130, 1, // Opcode: MOV16pd
/* 5150 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5160
/* 5155 */    MCD::OPC_Decode, 139, 5, 131, 1, // Opcode: MOV16pa
/* 5160 */    MCD::OPC_Decode, 151, 5, 132, 1, // Opcode: MOV16pr
/* 5165 */    MCD::OPC_FilterValue, 3, 4, 29, 0, // Skip to: 12598
/* 5170 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5173 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 5214
/* 5178 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5181 */    MCD::OPC_FilterValue, 8, 244, 28, 0, // Skip to: 12598
/* 5186 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5189 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5199
/* 5194 */    MCD::OPC_Decode, 218, 4, 133, 1, // Opcode: MOV16fd
/* 5199 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5209
/* 5204 */    MCD::OPC_Decode, 215, 4, 134, 1, // Opcode: MOV16fa
/* 5209 */    MCD::OPC_Decode, 227, 4, 135, 1, // Opcode: MOV16fr
/* 5214 */    MCD::OPC_FilterValue, 1, 211, 28, 0, // Skip to: 12598
/* 5219 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5222 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 5255
/* 5227 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5230 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5240
/* 5235 */    MCD::OPC_Decode, 172, 4, 136, 1, // Opcode: MOV16bd
/* 5240 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5250
/* 5245 */    MCD::OPC_Decode, 169, 4, 137, 1, // Opcode: MOV16ba
/* 5250 */    MCD::OPC_Decode, 181, 4, 138, 1, // Opcode: MOV16br
/* 5255 */    MCD::OPC_FilterValue, 2, 27, 0, 0, // Skip to: 5287
/* 5260 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5263 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5272
/* 5268 */    MCD::OPC_Decode, 155, 5, 15, // Opcode: MOV16qd
/* 5272 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5282
/* 5277 */    MCD::OPC_Decode, 152, 5, 139, 1, // Opcode: MOV16qa
/* 5282 */    MCD::OPC_Decode, 164, 5, 140, 1, // Opcode: MOV16qr
/* 5287 */    MCD::OPC_FilterValue, 3, 138, 28, 0, // Skip to: 12598
/* 5292 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 5295 */    MCD::OPC_FilterValue, 8, 130, 28, 0, // Skip to: 12598
/* 5300 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5303 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5313
/* 5308 */    MCD::OPC_Decode, 244, 4, 141, 1, // Opcode: MOV16kd
/* 5313 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5323
/* 5318 */    MCD::OPC_Decode, 241, 4, 142, 1, // Opcode: MOV16ka
/* 5323 */    MCD::OPC_Decode, 253, 4, 143, 1, // Opcode: MOV16kr
/* 5328 */    MCD::OPC_FilterValue, 1, 81, 1, 0, // Skip to: 5670
/* 5333 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5336 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 5410
/* 5341 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5344 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5377
/* 5349 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5352 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5362
/* 5357 */    MCD::OPC_Decode, 197, 4, 144, 1, // Opcode: MOV16dj
/* 5362 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5372
/* 5367 */    MCD::OPC_Decode, 158, 4, 145, 1, // Opcode: MOV16aj
/* 5372 */    MCD::OPC_Decode, 173, 5, 146, 1, // Opcode: MOV16rj
/* 5377 */    MCD::OPC_FilterValue, 1, 48, 28, 0, // Skip to: 12598
/* 5382 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5385 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5395
/* 5390 */    MCD::OPC_Decode, 199, 4, 144, 1, // Opcode: MOV16do
/* 5395 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5405
/* 5400 */    MCD::OPC_Decode, 162, 4, 145, 1, // Opcode: MOV16ao
/* 5405 */    MCD::OPC_Decode, 177, 5, 146, 1, // Opcode: MOV16ro
/* 5410 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 5470
/* 5415 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5418 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5444
/* 5423 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5426 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5435
/* 5431 */    MCD::OPC_Decode, 235, 4, 54, // Opcode: MOV16jj
/* 5435 */    MCD::OPC_FilterValue, 1, 246, 27, 0, // Skip to: 12598
/* 5440 */    MCD::OPC_Decode, 133, 5, 54, // Opcode: MOV16oj
/* 5444 */    MCD::OPC_FilterValue, 1, 237, 27, 0, // Skip to: 12598
/* 5449 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5452 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5461
/* 5457 */    MCD::OPC_Decode, 237, 4, 54, // Opcode: MOV16jo
/* 5461 */    MCD::OPC_FilterValue, 1, 220, 27, 0, // Skip to: 12598
/* 5466 */    MCD::OPC_Decode, 135, 5, 54, // Opcode: MOV16oo
/* 5470 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 5530
/* 5475 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5478 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5504
/* 5483 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5486 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5495
/* 5491 */    MCD::OPC_Decode, 209, 4, 54, // Opcode: MOV16ej
/* 5495 */    MCD::OPC_FilterValue, 1, 186, 27, 0, // Skip to: 12598
/* 5500 */    MCD::OPC_Decode, 146, 5, 62, // Opcode: MOV16pj
/* 5504 */    MCD::OPC_FilterValue, 1, 177, 27, 0, // Skip to: 12598
/* 5509 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5512 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5521
/* 5517 */    MCD::OPC_Decode, 211, 4, 54, // Opcode: MOV16eo
/* 5521 */    MCD::OPC_FilterValue, 1, 160, 27, 0, // Skip to: 12598
/* 5526 */    MCD::OPC_Decode, 148, 5, 62, // Opcode: MOV16po
/* 5530 */    MCD::OPC_FilterValue, 3, 151, 27, 0, // Skip to: 12598
/* 5535 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5538 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 5604
/* 5543 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5546 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5562
/* 5551 */    MCD::OPC_CheckField, 24, 4, 8, 128, 27, 0, // Skip to: 12598
/* 5558 */    MCD::OPC_Decode, 222, 4, 70, // Opcode: MOV16fj
/* 5562 */    MCD::OPC_FilterValue, 1, 119, 27, 0, // Skip to: 12598
/* 5567 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5570 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5579
/* 5575 */    MCD::OPC_Decode, 176, 4, 28, // Opcode: MOV16bj
/* 5579 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5588
/* 5584 */    MCD::OPC_Decode, 159, 5, 17, // Opcode: MOV16qj
/* 5588 */    MCD::OPC_FilterValue, 3, 93, 27, 0, // Skip to: 12598
/* 5593 */    MCD::OPC_CheckField, 24, 4, 8, 86, 27, 0, // Skip to: 12598
/* 5600 */    MCD::OPC_Decode, 248, 4, 80, // Opcode: MOV16kj
/* 5604 */    MCD::OPC_FilterValue, 1, 77, 27, 0, // Skip to: 12598
/* 5609 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5612 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5628
/* 5617 */    MCD::OPC_CheckField, 24, 4, 8, 62, 27, 0, // Skip to: 12598
/* 5624 */    MCD::OPC_Decode, 224, 4, 70, // Opcode: MOV16fo
/* 5628 */    MCD::OPC_FilterValue, 1, 53, 27, 0, // Skip to: 12598
/* 5633 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5636 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5645
/* 5641 */    MCD::OPC_Decode, 178, 4, 28, // Opcode: MOV16bo
/* 5645 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5654
/* 5650 */    MCD::OPC_Decode, 161, 5, 17, // Opcode: MOV16qo
/* 5654 */    MCD::OPC_FilterValue, 3, 27, 27, 0, // Skip to: 12598
/* 5659 */    MCD::OPC_CheckField, 24, 4, 8, 20, 27, 0, // Skip to: 12598
/* 5666 */    MCD::OPC_Decode, 250, 4, 80, // Opcode: MOV16ko
/* 5670 */    MCD::OPC_FilterValue, 2, 81, 1, 0, // Skip to: 6012
/* 5675 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 5678 */    MCD::OPC_FilterValue, 0, 69, 0, 0, // Skip to: 5752
/* 5683 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5686 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 5719
/* 5691 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5694 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5704
/* 5699 */    MCD::OPC_Decode, 194, 4, 144, 1, // Opcode: MOV16de
/* 5704 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5714
/* 5709 */    MCD::OPC_Decode, 153, 4, 145, 1, // Opcode: MOV16ae
/* 5714 */    MCD::OPC_Decode, 168, 5, 146, 1, // Opcode: MOV16re
/* 5719 */    MCD::OPC_FilterValue, 1, 218, 26, 0, // Skip to: 12598
/* 5724 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5727 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 5737
/* 5732 */    MCD::OPC_Decode, 200, 4, 147, 1, // Opcode: MOV16dp
/* 5737 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 5747
/* 5742 */    MCD::OPC_Decode, 164, 4, 148, 1, // Opcode: MOV16ap
/* 5747 */    MCD::OPC_Decode, 179, 5, 149, 1, // Opcode: MOV16rp
/* 5752 */    MCD::OPC_FilterValue, 1, 55, 0, 0, // Skip to: 5812
/* 5757 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5760 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5786
/* 5765 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5768 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5777
/* 5773 */    MCD::OPC_Decode, 232, 4, 54, // Opcode: MOV16je
/* 5777 */    MCD::OPC_FilterValue, 1, 160, 26, 0, // Skip to: 12598
/* 5782 */    MCD::OPC_Decode, 130, 5, 54, // Opcode: MOV16oe
/* 5786 */    MCD::OPC_FilterValue, 1, 151, 26, 0, // Skip to: 12598
/* 5791 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5794 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5803
/* 5799 */    MCD::OPC_Decode, 238, 4, 55, // Opcode: MOV16jp
/* 5803 */    MCD::OPC_FilterValue, 1, 134, 26, 0, // Skip to: 12598
/* 5808 */    MCD::OPC_Decode, 136, 5, 55, // Opcode: MOV16op
/* 5812 */    MCD::OPC_FilterValue, 2, 55, 0, 0, // Skip to: 5872
/* 5817 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5820 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 5846
/* 5825 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5828 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5837
/* 5833 */    MCD::OPC_Decode, 206, 4, 54, // Opcode: MOV16ee
/* 5837 */    MCD::OPC_FilterValue, 1, 100, 26, 0, // Skip to: 12598
/* 5842 */    MCD::OPC_Decode, 143, 5, 62, // Opcode: MOV16pe
/* 5846 */    MCD::OPC_FilterValue, 1, 91, 26, 0, // Skip to: 12598
/* 5851 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5854 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 5863
/* 5859 */    MCD::OPC_Decode, 212, 4, 55, // Opcode: MOV16ep
/* 5863 */    MCD::OPC_FilterValue, 1, 74, 26, 0, // Skip to: 12598
/* 5868 */    MCD::OPC_Decode, 149, 5, 63, // Opcode: MOV16pp
/* 5872 */    MCD::OPC_FilterValue, 3, 65, 26, 0, // Skip to: 12598
/* 5877 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 5880 */    MCD::OPC_FilterValue, 0, 61, 0, 0, // Skip to: 5946
/* 5885 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5888 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5904
/* 5893 */    MCD::OPC_CheckField, 24, 4, 8, 42, 26, 0, // Skip to: 12598
/* 5900 */    MCD::OPC_Decode, 219, 4, 70, // Opcode: MOV16fe
/* 5904 */    MCD::OPC_FilterValue, 1, 33, 26, 0, // Skip to: 12598
/* 5909 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5912 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5921
/* 5917 */    MCD::OPC_Decode, 173, 4, 28, // Opcode: MOV16be
/* 5921 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5930
/* 5926 */    MCD::OPC_Decode, 156, 5, 17, // Opcode: MOV16qe
/* 5930 */    MCD::OPC_FilterValue, 3, 7, 26, 0, // Skip to: 12598
/* 5935 */    MCD::OPC_CheckField, 24, 4, 8, 0, 26, 0, // Skip to: 12598
/* 5942 */    MCD::OPC_Decode, 245, 4, 80, // Opcode: MOV16ke
/* 5946 */    MCD::OPC_FilterValue, 1, 247, 25, 0, // Skip to: 12598
/* 5951 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 5954 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 5970
/* 5959 */    MCD::OPC_CheckField, 40, 4, 8, 232, 25, 0, // Skip to: 12598
/* 5966 */    MCD::OPC_Decode, 225, 4, 71, // Opcode: MOV16fp
/* 5970 */    MCD::OPC_FilterValue, 1, 223, 25, 0, // Skip to: 12598
/* 5975 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 5978 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 5987
/* 5983 */    MCD::OPC_Decode, 179, 4, 81, // Opcode: MOV16bp
/* 5987 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 5996
/* 5992 */    MCD::OPC_Decode, 162, 5, 82, // Opcode: MOV16qp
/* 5996 */    MCD::OPC_FilterValue, 3, 197, 25, 0, // Skip to: 12598
/* 6001 */    MCD::OPC_CheckField, 40, 4, 8, 190, 25, 0, // Skip to: 12598
/* 6008 */    MCD::OPC_Decode, 251, 4, 83, // Opcode: MOV16kp
/* 6012 */    MCD::OPC_FilterValue, 3, 181, 25, 0, // Skip to: 12598
/* 6017 */    MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 6020 */    MCD::OPC_FilterValue, 0, 192, 0, 0, // Skip to: 6217
/* 6025 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6028 */    MCD::OPC_FilterValue, 0, 36, 0, 0, // Skip to: 6069
/* 6033 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6036 */    MCD::OPC_FilterValue, 8, 157, 25, 0, // Skip to: 12598
/* 6041 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6044 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6054
/* 6049 */    MCD::OPC_Decode, 195, 4, 150, 1, // Opcode: MOV16df
/* 6054 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6064
/* 6059 */    MCD::OPC_Decode, 155, 4, 151, 1, // Opcode: MOV16af
/* 6064 */    MCD::OPC_Decode, 170, 5, 152, 1, // Opcode: MOV16rf
/* 6069 */    MCD::OPC_FilterValue, 1, 124, 25, 0, // Skip to: 12598
/* 6074 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6077 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6110
/* 6082 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6085 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6095
/* 6090 */    MCD::OPC_Decode, 191, 4, 153, 1, // Opcode: MOV16db
/* 6095 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6105
/* 6100 */    MCD::OPC_Decode, 151, 4, 154, 1, // Opcode: MOV16ab
/* 6105 */    MCD::OPC_Decode, 166, 5, 155, 1, // Opcode: MOV16rb
/* 6110 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6143
/* 6115 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6118 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6128
/* 6123 */    MCD::OPC_Decode, 201, 4, 156, 1, // Opcode: MOV16dq
/* 6128 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6138
/* 6133 */    MCD::OPC_Decode, 166, 4, 157, 1, // Opcode: MOV16aq
/* 6138 */    MCD::OPC_Decode, 181, 5, 158, 1, // Opcode: MOV16rq
/* 6143 */    MCD::OPC_FilterValue, 3, 36, 0, 0, // Skip to: 6184
/* 6148 */    MCD::OPC_ExtractField, 24, 4,  // Inst{27-24} ...
/* 6151 */    MCD::OPC_FilterValue, 8, 42, 25, 0, // Skip to: 12598
/* 6156 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6159 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6169
/* 6164 */    MCD::OPC_Decode, 198, 4, 159, 1, // Opcode: MOV16dk
/* 6169 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6179
/* 6174 */    MCD::OPC_Decode, 160, 4, 160, 1, // Opcode: MOV16ak
/* 6179 */    MCD::OPC_Decode, 175, 5, 161, 1, // Opcode: MOV16rk
/* 6184 */    MCD::OPC_FilterValue, 4, 9, 25, 0, // Skip to: 12598
/* 6189 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6192 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6202
/* 6197 */    MCD::OPC_Decode, 196, 4, 156, 1, // Opcode: MOV16di
/* 6202 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 6212
/* 6207 */    MCD::OPC_Decode, 157, 4, 157, 1, // Opcode: MOV16ai
/* 6212 */    MCD::OPC_Decode, 172, 5, 158, 1, // Opcode: MOV16ri
/* 6217 */    MCD::OPC_FilterValue, 1, 169, 0, 0, // Skip to: 6391
/* 6222 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6225 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6265
/* 6230 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6233 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6249
/* 6238 */    MCD::OPC_CheckField, 24, 4, 8, 209, 24, 0, // Skip to: 12598
/* 6245 */    MCD::OPC_Decode, 233, 4, 56, // Opcode: MOV16jf
/* 6249 */    MCD::OPC_FilterValue, 1, 200, 24, 0, // Skip to: 12598
/* 6254 */    MCD::OPC_CheckField, 24, 4, 8, 193, 24, 0, // Skip to: 12598
/* 6261 */    MCD::OPC_Decode, 131, 5, 56, // Opcode: MOV16of
/* 6265 */    MCD::OPC_FilterValue, 1, 184, 24, 0, // Skip to: 12598
/* 6270 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6273 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6299
/* 6278 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6281 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6290
/* 6286 */    MCD::OPC_Decode, 229, 4, 57, // Opcode: MOV16jb
/* 6290 */    MCD::OPC_FilterValue, 1, 159, 24, 0, // Skip to: 12598
/* 6295 */    MCD::OPC_Decode, 255, 4, 57, // Opcode: MOV16ob
/* 6299 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6325
/* 6304 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6307 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6316
/* 6312 */    MCD::OPC_Decode, 239, 4, 58, // Opcode: MOV16jq
/* 6316 */    MCD::OPC_FilterValue, 1, 133, 24, 0, // Skip to: 12598
/* 6321 */    MCD::OPC_Decode, 137, 5, 58, // Opcode: MOV16oq
/* 6325 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 6365
/* 6330 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6333 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6349
/* 6338 */    MCD::OPC_CheckField, 24, 4, 8, 109, 24, 0, // Skip to: 12598
/* 6345 */    MCD::OPC_Decode, 236, 4, 59, // Opcode: MOV16jk
/* 6349 */    MCD::OPC_FilterValue, 1, 100, 24, 0, // Skip to: 12598
/* 6354 */    MCD::OPC_CheckField, 24, 4, 8, 93, 24, 0, // Skip to: 12598
/* 6361 */    MCD::OPC_Decode, 134, 5, 59, // Opcode: MOV16ok
/* 6365 */    MCD::OPC_FilterValue, 4, 84, 24, 0, // Skip to: 12598
/* 6370 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6373 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6382
/* 6378 */    MCD::OPC_Decode, 234, 4, 58, // Opcode: MOV16ji
/* 6382 */    MCD::OPC_FilterValue, 1, 67, 24, 0, // Skip to: 12598
/* 6387 */    MCD::OPC_Decode, 132, 5, 58, // Opcode: MOV16oi
/* 6391 */    MCD::OPC_FilterValue, 2, 169, 0, 0, // Skip to: 6565
/* 6396 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6399 */    MCD::OPC_FilterValue, 0, 35, 0, 0, // Skip to: 6439
/* 6404 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6407 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6423
/* 6412 */    MCD::OPC_CheckField, 24, 4, 8, 35, 24, 0, // Skip to: 12598
/* 6419 */    MCD::OPC_Decode, 207, 4, 56, // Opcode: MOV16ef
/* 6423 */    MCD::OPC_FilterValue, 1, 26, 24, 0, // Skip to: 12598
/* 6428 */    MCD::OPC_CheckField, 24, 4, 8, 19, 24, 0, // Skip to: 12598
/* 6435 */    MCD::OPC_Decode, 144, 5, 64, // Opcode: MOV16pf
/* 6439 */    MCD::OPC_FilterValue, 1, 10, 24, 0, // Skip to: 12598
/* 6444 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6447 */    MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 6473
/* 6452 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6455 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6464
/* 6460 */    MCD::OPC_Decode, 203, 4, 57, // Opcode: MOV16eb
/* 6464 */    MCD::OPC_FilterValue, 1, 241, 23, 0, // Skip to: 12598
/* 6469 */    MCD::OPC_Decode, 140, 5, 65, // Opcode: MOV16pb
/* 6473 */    MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 6499
/* 6478 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6481 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6490
/* 6486 */    MCD::OPC_Decode, 213, 4, 58, // Opcode: MOV16eq
/* 6490 */    MCD::OPC_FilterValue, 1, 215, 23, 0, // Skip to: 12598
/* 6495 */    MCD::OPC_Decode, 150, 5, 66, // Opcode: MOV16pq
/* 6499 */    MCD::OPC_FilterValue, 3, 35, 0, 0, // Skip to: 6539
/* 6504 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6507 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6523
/* 6512 */    MCD::OPC_CheckField, 24, 4, 8, 191, 23, 0, // Skip to: 12598
/* 6519 */    MCD::OPC_Decode, 210, 4, 59, // Opcode: MOV16ek
/* 6523 */    MCD::OPC_FilterValue, 1, 182, 23, 0, // Skip to: 12598
/* 6528 */    MCD::OPC_CheckField, 24, 4, 8, 175, 23, 0, // Skip to: 12598
/* 6535 */    MCD::OPC_Decode, 147, 5, 67, // Opcode: MOV16pk
/* 6539 */    MCD::OPC_FilterValue, 4, 166, 23, 0, // Skip to: 12598
/* 6544 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6547 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 6556
/* 6552 */    MCD::OPC_Decode, 208, 4, 58, // Opcode: MOV16ei
/* 6556 */    MCD::OPC_FilterValue, 1, 149, 23, 0, // Skip to: 12598
/* 6561 */    MCD::OPC_Decode, 145, 5, 66, // Opcode: MOV16pi
/* 6565 */    MCD::OPC_FilterValue, 3, 140, 23, 0, // Skip to: 12598
/* 6570 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 6573 */    MCD::OPC_FilterValue, 0, 89, 0, 0, // Skip to: 6667
/* 6578 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6581 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6604
/* 6586 */    MCD::OPC_CheckField, 40, 4, 8, 117, 23, 0, // Skip to: 12598
/* 6593 */    MCD::OPC_CheckField, 24, 4, 8, 110, 23, 0, // Skip to: 12598
/* 6600 */    MCD::OPC_Decode, 220, 4, 72, // Opcode: MOV16ff
/* 6604 */    MCD::OPC_FilterValue, 1, 101, 23, 0, // Skip to: 12598
/* 6609 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6612 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 6628
/* 6617 */    MCD::OPC_CheckField, 24, 4, 8, 86, 23, 0, // Skip to: 12598
/* 6624 */    MCD::OPC_Decode, 174, 4, 84, // Opcode: MOV16bf
/* 6628 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 6644
/* 6633 */    MCD::OPC_CheckField, 24, 4, 8, 70, 23, 0, // Skip to: 12598
/* 6640 */    MCD::OPC_Decode, 157, 5, 85, // Opcode: MOV16qf
/* 6644 */    MCD::OPC_FilterValue, 3, 61, 23, 0, // Skip to: 12598
/* 6649 */    MCD::OPC_CheckField, 40, 4, 8, 54, 23, 0, // Skip to: 12598
/* 6656 */    MCD::OPC_CheckField, 24, 4, 8, 47, 23, 0, // Skip to: 12598
/* 6663 */    MCD::OPC_Decode, 246, 4, 86, // Opcode: MOV16kf
/* 6667 */    MCD::OPC_FilterValue, 1, 38, 23, 0, // Skip to: 12598
/* 6672 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 6675 */    MCD::OPC_FilterValue, 1, 61, 0, 0, // Skip to: 6741
/* 6680 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6683 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6699
/* 6688 */    MCD::OPC_CheckField, 56, 4, 8, 15, 23, 0, // Skip to: 12598
/* 6695 */    MCD::OPC_Decode, 216, 4, 73, // Opcode: MOV16fb
/* 6699 */    MCD::OPC_FilterValue, 1, 6, 23, 0, // Skip to: 12598
/* 6704 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6707 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6716
/* 6712 */    MCD::OPC_Decode, 170, 4, 87, // Opcode: MOV16bb
/* 6716 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6725
/* 6721 */    MCD::OPC_Decode, 153, 5, 88, // Opcode: MOV16qb
/* 6725 */    MCD::OPC_FilterValue, 3, 236, 22, 0, // Skip to: 12598
/* 6730 */    MCD::OPC_CheckField, 56, 4, 8, 229, 22, 0, // Skip to: 12598
/* 6737 */    MCD::OPC_Decode, 242, 4, 89, // Opcode: MOV16kb
/* 6741 */    MCD::OPC_FilterValue, 2, 61, 0, 0, // Skip to: 6807
/* 6746 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6749 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6765
/* 6754 */    MCD::OPC_CheckField, 40, 4, 8, 205, 22, 0, // Skip to: 12598
/* 6761 */    MCD::OPC_Decode, 226, 4, 74, // Opcode: MOV16fq
/* 6765 */    MCD::OPC_FilterValue, 1, 196, 22, 0, // Skip to: 12598
/* 6770 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6773 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6782
/* 6778 */    MCD::OPC_Decode, 180, 4, 90, // Opcode: MOV16bq
/* 6782 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6791
/* 6787 */    MCD::OPC_Decode, 163, 5, 91, // Opcode: MOV16qq
/* 6791 */    MCD::OPC_FilterValue, 3, 170, 22, 0, // Skip to: 12598
/* 6796 */    MCD::OPC_CheckField, 40, 4, 8, 163, 22, 0, // Skip to: 12598
/* 6803 */    MCD::OPC_Decode, 252, 4, 92, // Opcode: MOV16kq
/* 6807 */    MCD::OPC_FilterValue, 3, 89, 0, 0, // Skip to: 6901
/* 6812 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6815 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6838
/* 6820 */    MCD::OPC_CheckField, 40, 4, 8, 139, 22, 0, // Skip to: 12598
/* 6827 */    MCD::OPC_CheckField, 24, 4, 8, 132, 22, 0, // Skip to: 12598
/* 6834 */    MCD::OPC_Decode, 223, 4, 75, // Opcode: MOV16fk
/* 6838 */    MCD::OPC_FilterValue, 1, 123, 22, 0, // Skip to: 12598
/* 6843 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6846 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 6862
/* 6851 */    MCD::OPC_CheckField, 24, 4, 8, 108, 22, 0, // Skip to: 12598
/* 6858 */    MCD::OPC_Decode, 177, 4, 93, // Opcode: MOV16bk
/* 6862 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 6878
/* 6867 */    MCD::OPC_CheckField, 24, 4, 8, 92, 22, 0, // Skip to: 12598
/* 6874 */    MCD::OPC_Decode, 160, 5, 94, // Opcode: MOV16qk
/* 6878 */    MCD::OPC_FilterValue, 3, 83, 22, 0, // Skip to: 12598
/* 6883 */    MCD::OPC_CheckField, 40, 4, 8, 76, 22, 0, // Skip to: 12598
/* 6890 */    MCD::OPC_CheckField, 24, 4, 8, 69, 22, 0, // Skip to: 12598
/* 6897 */    MCD::OPC_Decode, 249, 4, 95, // Opcode: MOV16kk
/* 6901 */    MCD::OPC_FilterValue, 4, 60, 22, 0, // Skip to: 12598
/* 6906 */    MCD::OPC_ExtractField, 6, 1,  // Inst{6} ...
/* 6909 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6925
/* 6914 */    MCD::OPC_CheckField, 40, 4, 8, 45, 22, 0, // Skip to: 12598
/* 6921 */    MCD::OPC_Decode, 221, 4, 74, // Opcode: MOV16fi
/* 6925 */    MCD::OPC_FilterValue, 1, 36, 22, 0, // Skip to: 12598
/* 6930 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6933 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 6942
/* 6938 */    MCD::OPC_Decode, 175, 4, 90, // Opcode: MOV16bi
/* 6942 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 6951
/* 6947 */    MCD::OPC_Decode, 158, 5, 91, // Opcode: MOV16qi
/* 6951 */    MCD::OPC_FilterValue, 3, 10, 22, 0, // Skip to: 12598
/* 6956 */    MCD::OPC_CheckField, 40, 4, 8, 3, 22, 0, // Skip to: 12598
/* 6963 */    MCD::OPC_Decode, 247, 4, 92, // Opcode: MOV16ki
/* 6967 */    MCD::OPC_FilterValue, 4, 173, 4, 0, // Skip to: 8169
/* 6972 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 6975 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 7020
/* 6980 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 6983 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 6993
/* 6988 */    MCD::OPC_Decode, 199, 7, 162, 1, // Opcode: NEGX8d
/* 6993 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7003
/* 6998 */    MCD::OPC_Decode, 196, 7, 162, 1, // Opcode: NEG8d
/* 7003 */    MCD::OPC_FilterValue, 4, 214, 21, 0, // Skip to: 12598
/* 7008 */    MCD::OPC_CheckField, 3, 1, 1, 207, 21, 0, // Skip to: 12598
/* 7015 */    MCD::OPC_Decode, 143, 4, 163, 1, // Opcode: LINK32
/* 7020 */    MCD::OPC_FilterValue, 4, 23, 0, 0, // Skip to: 7048
/* 7025 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7028 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7038
/* 7033 */    MCD::OPC_Decode, 197, 7, 164, 1, // Opcode: NEGX16d
/* 7038 */    MCD::OPC_FilterValue, 2, 179, 21, 0, // Skip to: 12598
/* 7043 */    MCD::OPC_Decode, 194, 7, 164, 1, // Opcode: NEG16d
/* 7048 */    MCD::OPC_FilterValue, 5, 37, 0, 0, // Skip to: 7090
/* 7053 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7056 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7073
/* 7061 */    MCD::OPC_CheckField, 9, 3, 7, 154, 21, 0, // Skip to: 12598
/* 7068 */    MCD::OPC_Decode, 142, 4, 165, 1, // Opcode: LINK16
/* 7073 */    MCD::OPC_FilterValue, 1, 144, 21, 0, // Skip to: 12598
/* 7078 */    MCD::OPC_CheckField, 9, 3, 7, 137, 21, 0, // Skip to: 12598
/* 7085 */    MCD::OPC_Decode, 240, 8, 166, 1, // Opcode: UNLK
/* 7090 */    MCD::OPC_FilterValue, 7, 37, 0, 0, // Skip to: 7132
/* 7095 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7098 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 7115
/* 7103 */    MCD::OPC_CheckField, 9, 3, 7, 112, 21, 0, // Skip to: 12598
/* 7110 */    MCD::OPC_Decode, 200, 7, 167, 1, // Opcode: NOP
/* 7115 */    MCD::OPC_FilterValue, 5, 102, 21, 0, // Skip to: 12598
/* 7120 */    MCD::OPC_CheckField, 9, 3, 7, 95, 21, 0, // Skip to: 12598
/* 7127 */    MCD::OPC_Decode, 254, 7, 167, 1, // Opcode: RTS
/* 7132 */    MCD::OPC_FilterValue, 8, 40, 0, 0, // Skip to: 7177
/* 7137 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7140 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7150
/* 7145 */    MCD::OPC_Decode, 198, 7, 168, 1, // Opcode: NEGX32d
/* 7150 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7160
/* 7155 */    MCD::OPC_Decode, 195, 7, 168, 1, // Opcode: NEG32d
/* 7160 */    MCD::OPC_FilterValue, 4, 57, 21, 0, // Skip to: 12598
/* 7165 */    MCD::OPC_CheckField, 3, 1, 0, 50, 21, 0, // Skip to: 12598
/* 7172 */    MCD::OPC_Decode, 134, 4, 169, 1, // Opcode: EXT16
/* 7177 */    MCD::OPC_FilterValue, 9, 72, 0, 0, // Skip to: 7254
/* 7182 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7185 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7211
/* 7190 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7193 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7202
/* 7198 */    MCD::OPC_Decode, 165, 7, 16, // Opcode: MOVM16jm
/* 7202 */    MCD::OPC_FilterValue, 1, 15, 21, 0, // Skip to: 12598
/* 7207 */    MCD::OPC_Decode, 175, 7, 16, // Opcode: MOVM16om
/* 7211 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 7237
/* 7216 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7219 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7228
/* 7224 */    MCD::OPC_Decode, 170, 7, 17, // Opcode: MOVM16mj
/* 7228 */    MCD::OPC_FilterValue, 1, 245, 20, 0, // Skip to: 12598
/* 7233 */    MCD::OPC_Decode, 172, 7, 17, // Opcode: MOVM16mo
/* 7237 */    MCD::OPC_FilterValue, 7, 236, 20, 0, // Skip to: 12598
/* 7242 */    MCD::OPC_CheckField, 3, 1, 0, 229, 20, 0, // Skip to: 12598
/* 7249 */    MCD::OPC_Decode, 217, 3, 166, 1, // Opcode: CALLj
/* 7254 */    MCD::OPC_FilterValue, 10, 55, 0, 0, // Skip to: 7314
/* 7259 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7262 */    MCD::OPC_FilterValue, 0, 21, 0, 0, // Skip to: 7288
/* 7267 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7270 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7279
/* 7275 */    MCD::OPC_Decode, 163, 7, 16, // Opcode: MOVM16em
/* 7279 */    MCD::OPC_FilterValue, 6, 194, 20, 0, // Skip to: 12598
/* 7284 */    MCD::OPC_Decode, 168, 7, 17, // Opcode: MOVM16me
/* 7288 */    MCD::OPC_FilterValue, 1, 185, 20, 0, // Skip to: 12598
/* 7293 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7296 */    MCD::OPC_FilterValue, 4, 4, 0, 0, // Skip to: 7305
/* 7301 */    MCD::OPC_Decode, 176, 7, 18, // Opcode: MOVM16pm
/* 7305 */    MCD::OPC_FilterValue, 6, 168, 20, 0, // Skip to: 12598
/* 7310 */    MCD::OPC_Decode, 173, 7, 19, // Opcode: MOVM16mp
/* 7314 */    MCD::OPC_FilterValue, 11, 180, 0, 0, // Skip to: 7499
/* 7319 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7322 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 7388
/* 7327 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7330 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7346
/* 7335 */    MCD::OPC_CheckField, 40, 4, 8, 136, 20, 0, // Skip to: 12598
/* 7342 */    MCD::OPC_Decode, 164, 7, 20, // Opcode: MOVM16fm
/* 7346 */    MCD::OPC_FilterValue, 1, 127, 20, 0, // Skip to: 12598
/* 7351 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7354 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7363
/* 7359 */    MCD::OPC_Decode, 162, 7, 90, // Opcode: MOVM16bm
/* 7363 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7372
/* 7368 */    MCD::OPC_Decode, 177, 7, 91, // Opcode: MOVM16qm
/* 7372 */    MCD::OPC_FilterValue, 3, 101, 20, 0, // Skip to: 12598
/* 7377 */    MCD::OPC_CheckField, 40, 4, 8, 94, 20, 0, // Skip to: 12598
/* 7384 */    MCD::OPC_Decode, 166, 7, 92, // Opcode: MOVM16km
/* 7388 */    MCD::OPC_FilterValue, 6, 61, 0, 0, // Skip to: 7454
/* 7393 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7396 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7412
/* 7401 */    MCD::OPC_CheckField, 40, 4, 8, 70, 20, 0, // Skip to: 12598
/* 7408 */    MCD::OPC_Decode, 169, 7, 21, // Opcode: MOVM16mf
/* 7412 */    MCD::OPC_FilterValue, 1, 61, 20, 0, // Skip to: 12598
/* 7417 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7420 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7429
/* 7425 */    MCD::OPC_Decode, 167, 7, 22, // Opcode: MOVM16mb
/* 7429 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 7438
/* 7434 */    MCD::OPC_Decode, 174, 7, 23, // Opcode: MOVM16mq
/* 7438 */    MCD::OPC_FilterValue, 3, 35, 20, 0, // Skip to: 12598
/* 7443 */    MCD::OPC_CheckField, 40, 4, 8, 28, 20, 0, // Skip to: 12598
/* 7450 */    MCD::OPC_Decode, 171, 7, 24, // Opcode: MOVM16mk
/* 7454 */    MCD::OPC_FilterValue, 7, 19, 20, 0, // Skip to: 12598
/* 7459 */    MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 7462 */    MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 7472
/* 7467 */    MCD::OPC_Decode, 216, 3, 170, 1, // Opcode: CALLb
/* 7472 */    MCD::OPC_FilterValue, 10, 5, 0, 0, // Skip to: 7482
/* 7477 */    MCD::OPC_Decode, 219, 3, 171, 1, // Opcode: CALLq
/* 7482 */    MCD::OPC_FilterValue, 11, 247, 19, 0, // Skip to: 12598
/* 7487 */    MCD::OPC_CheckField, 24, 4, 8, 240, 19, 0, // Skip to: 12598
/* 7494 */    MCD::OPC_Decode, 218, 3, 172, 1, // Opcode: CALLk
/* 7499 */    MCD::OPC_FilterValue, 12, 54, 0, 0, // Skip to: 7558
/* 7504 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7507 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 7524
/* 7512 */    MCD::OPC_CheckField, 3, 1, 0, 215, 19, 0, // Skip to: 12598
/* 7519 */    MCD::OPC_Decode, 192, 4, 173, 1, // Opcode: MOV16dc
/* 7524 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 7541
/* 7529 */    MCD::OPC_CheckField, 3, 1, 0, 198, 19, 0, // Skip to: 12598
/* 7536 */    MCD::OPC_Decode, 183, 4, 174, 1, // Opcode: MOV16cd
/* 7541 */    MCD::OPC_FilterValue, 4, 188, 19, 0, // Skip to: 12598
/* 7546 */    MCD::OPC_CheckField, 3, 1, 0, 181, 19, 0, // Skip to: 12598
/* 7553 */    MCD::OPC_Decode, 135, 4, 175, 1, // Opcode: EXT32
/* 7558 */    MCD::OPC_FilterValue, 13, 128, 0, 0, // Skip to: 7691
/* 7563 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7566 */    MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 7594
/* 7571 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7574 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7584
/* 7579 */    MCD::OPC_Decode, 230, 4, 176, 1, // Opcode: MOV16jc
/* 7584 */    MCD::OPC_FilterValue, 1, 145, 19, 0, // Skip to: 12598
/* 7589 */    MCD::OPC_Decode, 128, 5, 176, 1, // Opcode: MOV16oc
/* 7594 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 7622
/* 7599 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7602 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7612
/* 7607 */    MCD::OPC_Decode, 186, 4, 174, 1, // Opcode: MOV16cj
/* 7612 */    MCD::OPC_FilterValue, 1, 117, 19, 0, // Skip to: 12598
/* 7617 */    MCD::OPC_Decode, 188, 4, 174, 1, // Opcode: MOV16co
/* 7622 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7648
/* 7627 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7630 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7639
/* 7635 */    MCD::OPC_Decode, 181, 7, 16, // Opcode: MOVM32jm
/* 7639 */    MCD::OPC_FilterValue, 1, 90, 19, 0, // Skip to: 12598
/* 7644 */    MCD::OPC_Decode, 191, 7, 16, // Opcode: MOVM32om
/* 7648 */    MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 7674
/* 7653 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7656 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7665
/* 7661 */    MCD::OPC_Decode, 186, 7, 17, // Opcode: MOVM32mj
/* 7665 */    MCD::OPC_FilterValue, 1, 64, 19, 0, // Skip to: 12598
/* 7670 */    MCD::OPC_Decode, 188, 7, 17, // Opcode: MOVM32mo
/* 7674 */    MCD::OPC_FilterValue, 7, 55, 19, 0, // Skip to: 12598
/* 7679 */    MCD::OPC_CheckField, 3, 1, 0, 48, 19, 0, // Skip to: 12598
/* 7686 */    MCD::OPC_Decode, 136, 4, 166, 1, // Opcode: JMP32j
/* 7691 */    MCD::OPC_FilterValue, 14, 111, 0, 0, // Skip to: 7807
/* 7696 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7699 */    MCD::OPC_FilterValue, 1, 23, 0, 0, // Skip to: 7727
/* 7704 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7707 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7717
/* 7712 */    MCD::OPC_Decode, 204, 4, 176, 1, // Opcode: MOV16ec
/* 7717 */    MCD::OPC_FilterValue, 1, 12, 19, 0, // Skip to: 12598
/* 7722 */    MCD::OPC_Decode, 141, 5, 177, 1, // Opcode: MOV16pc
/* 7727 */    MCD::OPC_FilterValue, 2, 23, 0, 0, // Skip to: 7755
/* 7732 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7735 */    MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 7745
/* 7740 */    MCD::OPC_Decode, 184, 4, 174, 1, // Opcode: MOV16ce
/* 7745 */    MCD::OPC_FilterValue, 1, 240, 18, 0, // Skip to: 12598
/* 7750 */    MCD::OPC_Decode, 189, 4, 174, 1, // Opcode: MOV16cp
/* 7755 */    MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 7781
/* 7760 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7763 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7772
/* 7768 */    MCD::OPC_Decode, 179, 7, 16, // Opcode: MOVM32em
/* 7772 */    MCD::OPC_FilterValue, 1, 213, 18, 0, // Skip to: 12598
/* 7777 */    MCD::OPC_Decode, 192, 7, 18, // Opcode: MOVM32pm
/* 7781 */    MCD::OPC_FilterValue, 6, 204, 18, 0, // Skip to: 12598
/* 7786 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7789 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7798
/* 7794 */    MCD::OPC_Decode, 184, 7, 17, // Opcode: MOVM32me
/* 7798 */    MCD::OPC_FilterValue, 1, 187, 18, 0, // Skip to: 12598
/* 7803 */    MCD::OPC_Decode, 189, 7, 19, // Opcode: MOVM32mp
/* 7807 */    MCD::OPC_FilterValue, 15, 19, 1, 0, // Skip to: 8087
/* 7812 */    MCD::OPC_ExtractField, 9, 3,  // Inst{11-9} ...
/* 7815 */    MCD::OPC_FilterValue, 1, 65, 0, 0, // Skip to: 7885
/* 7820 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7823 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7840
/* 7828 */    MCD::OPC_CheckField, 24, 4, 8, 155, 18, 0, // Skip to: 12598
/* 7835 */    MCD::OPC_Decode, 217, 4, 178, 1, // Opcode: MOV16fc
/* 7840 */    MCD::OPC_FilterValue, 1, 145, 18, 0, // Skip to: 12598
/* 7845 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7848 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7858
/* 7853 */    MCD::OPC_Decode, 171, 4, 179, 1, // Opcode: MOV16bc
/* 7858 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7868
/* 7863 */    MCD::OPC_Decode, 154, 5, 180, 1, // Opcode: MOV16qc
/* 7868 */    MCD::OPC_FilterValue, 3, 117, 18, 0, // Skip to: 12598
/* 7873 */    MCD::OPC_CheckField, 24, 4, 8, 110, 18, 0, // Skip to: 12598
/* 7880 */    MCD::OPC_Decode, 243, 4, 181, 1, // Opcode: MOV16kc
/* 7885 */    MCD::OPC_FilterValue, 2, 65, 0, 0, // Skip to: 7955
/* 7890 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7893 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 7910
/* 7898 */    MCD::OPC_CheckField, 24, 4, 8, 85, 18, 0, // Skip to: 12598
/* 7905 */    MCD::OPC_Decode, 185, 4, 174, 1, // Opcode: MOV16cf
/* 7910 */    MCD::OPC_FilterValue, 1, 75, 18, 0, // Skip to: 12598
/* 7915 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7918 */    MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 7928
/* 7923 */    MCD::OPC_Decode, 182, 4, 174, 1, // Opcode: MOV16cb
/* 7928 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 7938
/* 7933 */    MCD::OPC_Decode, 190, 4, 174, 1, // Opcode: MOV16cq
/* 7938 */    MCD::OPC_FilterValue, 3, 47, 18, 0, // Skip to: 12598
/* 7943 */    MCD::OPC_CheckField, 24, 4, 8, 40, 18, 0, // Skip to: 12598
/* 7950 */    MCD::OPC_Decode, 187, 4, 174, 1, // Opcode: MOV16ck
/* 7955 */    MCD::OPC_FilterValue, 4, 61, 0, 0, // Skip to: 8021
/* 7960 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 7963 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7979
/* 7968 */    MCD::OPC_CheckField, 40, 4, 8, 15, 18, 0, // Skip to: 12598
/* 7975 */    MCD::OPC_Decode, 180, 7, 20, // Opcode: MOVM32fm
/* 7979 */    MCD::OPC_FilterValue, 1, 6, 18, 0, // Skip to: 12598
/* 7984 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 7987 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 7996
/* 7992 */    MCD::OPC_Decode, 178, 7, 90, // Opcode: MOVM32bm
/* 7996 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8005
/* 8001 */    MCD::OPC_Decode, 193, 7, 91, // Opcode: MOVM32qm
/* 8005 */    MCD::OPC_FilterValue, 3, 236, 17, 0, // Skip to: 12598
/* 8010 */    MCD::OPC_CheckField, 40, 4, 8, 229, 17, 0, // Skip to: 12598
/* 8017 */    MCD::OPC_Decode, 182, 7, 92, // Opcode: MOVM32km
/* 8021 */    MCD::OPC_FilterValue, 6, 220, 17, 0, // Skip to: 12598
/* 8026 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8029 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8045
/* 8034 */    MCD::OPC_CheckField, 40, 4, 8, 205, 17, 0, // Skip to: 12598
/* 8041 */    MCD::OPC_Decode, 185, 7, 21, // Opcode: MOVM32mf
/* 8045 */    MCD::OPC_FilterValue, 1, 196, 17, 0, // Skip to: 12598
/* 8050 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8053 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8062
/* 8058 */    MCD::OPC_Decode, 183, 7, 22, // Opcode: MOVM32mb
/* 8062 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8071
/* 8067 */    MCD::OPC_Decode, 190, 7, 23, // Opcode: MOVM32mq
/* 8071 */    MCD::OPC_FilterValue, 3, 170, 17, 0, // Skip to: 12598
/* 8076 */    MCD::OPC_CheckField, 40, 4, 8, 163, 17, 0, // Skip to: 12598
/* 8083 */    MCD::OPC_Decode, 187, 7, 24, // Opcode: MOVM32mk
/* 8087 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 8103
/* 8092 */    MCD::OPC_CheckField, 3, 1, 1, 147, 17, 0, // Skip to: 12598
/* 8099 */    MCD::OPC_Decode, 140, 4, 55, // Opcode: LEA32p
/* 8103 */    MCD::OPC_FilterValue, 31, 138, 17, 0, // Skip to: 12598
/* 8108 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 8111 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 8127
/* 8116 */    MCD::OPC_CheckField, 24, 4, 8, 123, 17, 0, // Skip to: 12598
/* 8123 */    MCD::OPC_Decode, 138, 4, 56, // Opcode: LEA32f
/* 8127 */    MCD::OPC_FilterValue, 1, 114, 17, 0, // Skip to: 12598
/* 8132 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 8135 */    MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 8144
/* 8140 */    MCD::OPC_Decode, 137, 4, 57, // Opcode: LEA32b
/* 8144 */    MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 8153
/* 8149 */    MCD::OPC_Decode, 141, 4, 58, // Opcode: LEA32q
/* 8153 */    MCD::OPC_FilterValue, 3, 88, 17, 0, // Skip to: 12598
/* 8158 */    MCD::OPC_CheckField, 24, 4, 8, 81, 17, 0, // Skip to: 12598
/* 8165 */    MCD::OPC_Decode, 139, 4, 59, // Opcode: LEA32k
/* 8169 */    MCD::OPC_FilterValue, 5, 203, 2, 0, // Skip to: 8889
/* 8174 */    MCD::OPC_ExtractField, 4, 8,  // Inst{11-4} ...
/* 8177 */    MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 8187
/* 8182 */    MCD::OPC_Decode, 142, 8, 182, 1, // Opcode: SETd8t
/* 8187 */    MCD::OPC_FilterValue, 13, 12, 0, 0, // Skip to: 8204
/* 8192 */    MCD::OPC_CheckField, 3, 1, 0, 47, 17, 0, // Skip to: 12598
/* 8199 */    MCD::OPC_Decode, 158, 8, 166, 1, // Opcode: SETj8t
/* 8204 */    MCD::OPC_FilterValue, 14, 11, 0, 0, // Skip to: 8220
/* 8209 */    MCD::OPC_CheckField, 3, 1, 1, 30, 17, 0, // Skip to: 12598
/* 8216 */    MCD::OPC_Decode, 174, 8, 17, // Opcode: SETp8t
/* 8220 */    MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 8230
/* 8225 */    MCD::OPC_Decode, 132, 8, 182, 1, // Opcode: SETd8f
/* 8230 */    MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 8247
/* 8235 */    MCD::OPC_CheckField, 3, 1, 0, 4, 17, 0, // Skip to: 12598
/* 8242 */    MCD::OPC_Decode, 148, 8, 166, 1, // Opcode: SETj8f
/* 8247 */    MCD::OPC_FilterValue, 30, 11, 0, 0, // Skip to: 8263
/* 8252 */    MCD::OPC_CheckField, 3, 1, 1, 243, 16, 0, // Skip to: 12598
/* 8259 */    MCD::OPC_Decode, 164, 8, 17, // Opcode: SETp8f
/* 8263 */    MCD::OPC_FilterValue, 44, 5, 0, 0, // Skip to: 8273
/* 8268 */    MCD::OPC_Decode, 135, 8, 182, 1, // Opcode: SETd8hi
/* 8273 */    MCD::OPC_FilterValue, 45, 12, 0, 0, // Skip to: 8290
/* 8278 */    MCD::OPC_CheckField, 3, 1, 0, 217, 16, 0, // Skip to: 12598
/* 8285 */    MCD::OPC_Decode, 151, 8, 166, 1, // Opcode: SETj8hi
/* 8290 */    MCD::OPC_FilterValue, 46, 11, 0, 0, // Skip to: 8306
/* 8295 */    MCD::OPC_CheckField, 3, 1, 1, 200, 16, 0, // Skip to: 12598
/* 8302 */    MCD::OPC_Decode, 167, 8, 17, // Opcode: SETp8hi
/* 8306 */    MCD::OPC_FilterValue, 60, 5, 0, 0, // Skip to: 8316
/* 8311 */    MCD::OPC_Decode, 137, 8, 182, 1, // Opcode: SETd8ls
/* 8316 */    MCD::OPC_FilterValue, 61, 12, 0, 0, // Skip to: 8333
/* 8321 */    MCD::OPC_CheckField, 3, 1, 0, 174, 16, 0, // Skip to: 12598
/* 8328 */    MCD::OPC_Decode, 153, 8, 166, 1, // Opcode: SETj8ls
/* 8333 */    MCD::OPC_FilterValue, 62, 11, 0, 0, // Skip to: 8349
/* 8338 */    MCD::OPC_CheckField, 3, 1, 1, 157, 16, 0, // Skip to: 12598
/* 8345 */    MCD::OPC_Decode, 169, 8, 17, // Opcode: SETp8ls
/* 8349 */    MCD::OPC_FilterValue, 76, 5, 0, 0, // Skip to: 8359
/* 8354 */    MCD::OPC_Decode, 129, 8, 182, 1, // Opcode: SETd8cc
/* 8359 */    MCD::OPC_FilterValue, 77, 12, 0, 0, // Skip to: 8376
/* 8364 */    MCD::OPC_CheckField, 3, 1, 0, 131, 16, 0, // Skip to: 12598
/* 8371 */    MCD::OPC_Decode, 145, 8, 166, 1, // Opcode: SETj8cc
/* 8376 */    MCD::OPC_FilterValue, 78, 11, 0, 0, // Skip to: 8392
/* 8381 */    MCD::OPC_CheckField, 3, 1, 1, 114, 16, 0, // Skip to: 12598
/* 8388 */    MCD::OPC_Decode, 161, 8, 17, // Opcode: SETp8cc
/* 8392 */    MCD::OPC_FilterValue, 92, 5, 0, 0, // Skip to: 8402
/* 8397 */    MCD::OPC_Decode, 130, 8, 182, 1, // Opcode: SETd8cs
/* 8402 */    MCD::OPC_FilterValue, 93, 12, 0, 0, // Skip to: 8419
/* 8407 */    MCD::OPC_CheckField, 3, 1, 0, 88, 16, 0, // Skip to: 12598
/* 8414 */    MCD::OPC_Decode, 146, 8, 166, 1, // Opcode: SETj8cs
/* 8419 */    MCD::OPC_FilterValue, 94, 11, 0, 0, // Skip to: 8435
/* 8424 */    MCD::OPC_CheckField, 3, 1, 1, 71, 16, 0, // Skip to: 12598
/* 8431 */    MCD::OPC_Decode, 162, 8, 17, // Opcode: SETp8cs
/* 8435 */    MCD::OPC_FilterValue, 108, 5, 0, 0, // Skip to: 8445
/* 8440 */    MCD::OPC_Decode, 140, 8, 182, 1, // Opcode: SETd8ne
/* 8445 */    MCD::OPC_FilterValue, 109, 12, 0, 0, // Skip to: 8462
/* 8450 */    MCD::OPC_CheckField, 3, 1, 0, 45, 16, 0, // Skip to: 12598
/* 8457 */    MCD::OPC_Decode, 156, 8, 166, 1, // Opcode: SETj8ne
/* 8462 */    MCD::OPC_FilterValue, 110, 11, 0, 0, // Skip to: 8478
/* 8467 */    MCD::OPC_CheckField, 3, 1, 1, 28, 16, 0, // Skip to: 12598
/* 8474 */    MCD::OPC_Decode, 172, 8, 17, // Opcode: SETp8ne
/* 8478 */    MCD::OPC_FilterValue, 124, 5, 0, 0, // Skip to: 8488
/* 8483 */    MCD::OPC_Decode, 131, 8, 182, 1, // Opcode: SETd8eq
/* 8488 */    MCD::OPC_FilterValue, 125, 12, 0, 0, // Skip to: 8505
/* 8493 */    MCD::OPC_CheckField, 3, 1, 0, 2, 16, 0, // Skip to: 12598
/* 8500 */    MCD::OPC_Decode, 147, 8, 166, 1, // Opcode: SETj8eq
/* 8505 */    MCD::OPC_FilterValue, 126, 11, 0, 0, // Skip to: 8521
/* 8510 */    MCD::OPC_CheckField, 3, 1, 1, 241, 15, 0, // Skip to: 12598
/* 8517 */    MCD::OPC_Decode, 163, 8, 17, // Opcode: SETp8eq
/* 8521 */    MCD::OPC_FilterValue, 140, 1, 5, 0, 0, // Skip to: 8532
/* 8527 */    MCD::OPC_Decode, 143, 8, 182, 1, // Opcode: SETd8vc
/* 8532 */    MCD::OPC_FilterValue, 141, 1, 12, 0, 0, // Skip to: 8550
/* 8538 */    MCD::OPC_CheckField, 3, 1, 0, 213, 15, 0, // Skip to: 12598
/* 8545 */    MCD::OPC_Decode, 159, 8, 166, 1, // Opcode: SETj8vc
/* 8550 */    MCD::OPC_FilterValue, 142, 1, 11, 0, 0, // Skip to: 8567
/* 8556 */    MCD::OPC_CheckField, 3, 1, 1, 195, 15, 0, // Skip to: 12598
/* 8563 */    MCD::OPC_Decode, 175, 8, 17, // Opcode: SETp8vc
/* 8567 */    MCD::OPC_FilterValue, 156, 1, 5, 0, 0, // Skip to: 8578
/* 8573 */    MCD::OPC_Decode, 144, 8, 182, 1, // Opcode: SETd8vs
/* 8578 */    MCD::OPC_FilterValue, 157, 1, 12, 0, 0, // Skip to: 8596
/* 8584 */    MCD::OPC_CheckField, 3, 1, 0, 167, 15, 0, // Skip to: 12598
/* 8591 */    MCD::OPC_Decode, 160, 8, 166, 1, // Opcode: SETj8vs
/* 8596 */    MCD::OPC_FilterValue, 158, 1, 11, 0, 0, // Skip to: 8613
/* 8602 */    MCD::OPC_CheckField, 3, 1, 1, 149, 15, 0, // Skip to: 12598
/* 8609 */    MCD::OPC_Decode, 176, 8, 17, // Opcode: SETp8vs
/* 8613 */    MCD::OPC_FilterValue, 172, 1, 5, 0, 0, // Skip to: 8624
/* 8619 */    MCD::OPC_Decode, 141, 8, 182, 1, // Opcode: SETd8pl
/* 8624 */    MCD::OPC_FilterValue, 173, 1, 12, 0, 0, // Skip to: 8642
/* 8630 */    MCD::OPC_CheckField, 3, 1, 0, 121, 15, 0, // Skip to: 12598
/* 8637 */    MCD::OPC_Decode, 157, 8, 166, 1, // Opcode: SETj8pl
/* 8642 */    MCD::OPC_FilterValue, 174, 1, 11, 0, 0, // Skip to: 8659
/* 8648 */    MCD::OPC_CheckField, 3, 1, 1, 103, 15, 0, // Skip to: 12598
/* 8655 */    MCD::OPC_Decode, 173, 8, 17, // Opcode: SETp8pl
/* 8659 */    MCD::OPC_FilterValue, 188, 1, 5, 0, 0, // Skip to: 8670
/* 8665 */    MCD::OPC_Decode, 139, 8, 182, 1, // Opcode: SETd8mi
/* 8670 */    MCD::OPC_FilterValue, 189, 1, 12, 0, 0, // Skip to: 8688
/* 8676 */    MCD::OPC_CheckField, 3, 1, 0, 75, 15, 0, // Skip to: 12598
/* 8683 */    MCD::OPC_Decode, 155, 8, 166, 1, // Opcode: SETj8mi
/* 8688 */    MCD::OPC_FilterValue, 190, 1, 11, 0, 0, // Skip to: 8705
/* 8694 */    MCD::OPC_CheckField, 3, 1, 1, 57, 15, 0, // Skip to: 12598
/* 8701 */    MCD::OPC_Decode, 171, 8, 17, // Opcode: SETp8mi
/* 8705 */    MCD::OPC_FilterValue, 204, 1, 5, 0, 0, // Skip to: 8716
/* 8711 */    MCD::OPC_Decode, 133, 8, 182, 1, // Opcode: SETd8ge
/* 8716 */    MCD::OPC_FilterValue, 205, 1, 12, 0, 0, // Skip to: 8734
/* 8722 */    MCD::OPC_CheckField, 3, 1, 0, 29, 15, 0, // Skip to: 12598
/* 8729 */    MCD::OPC_Decode, 149, 8, 166, 1, // Opcode: SETj8ge
/* 8734 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 8751
/* 8740 */    MCD::OPC_CheckField, 3, 1, 1, 11, 15, 0, // Skip to: 12598
/* 8747 */    MCD::OPC_Decode, 165, 8, 17, // Opcode: SETp8ge
/* 8751 */    MCD::OPC_FilterValue, 220, 1, 5, 0, 0, // Skip to: 8762
/* 8757 */    MCD::OPC_Decode, 138, 8, 182, 1, // Opcode: SETd8lt
/* 8762 */    MCD::OPC_FilterValue, 221, 1, 12, 0, 0, // Skip to: 8780
/* 8768 */    MCD::OPC_CheckField, 3, 1, 0, 239, 14, 0, // Skip to: 12598
/* 8775 */    MCD::OPC_Decode, 154, 8, 166, 1, // Opcode: SETj8lt
/* 8780 */    MCD::OPC_FilterValue, 222, 1, 11, 0, 0, // Skip to: 8797
/* 8786 */    MCD::OPC_CheckField, 3, 1, 1, 221, 14, 0, // Skip to: 12598
/* 8793 */    MCD::OPC_Decode, 170, 8, 17, // Opcode: SETp8lt
/* 8797 */    MCD::OPC_FilterValue, 236, 1, 5, 0, 0, // Skip to: 8808
/* 8803 */    MCD::OPC_Decode, 134, 8, 182, 1, // Opcode: SETd8gt
/* 8808 */    MCD::OPC_FilterValue, 237, 1, 12, 0, 0, // Skip to: 8826
/* 8814 */    MCD::OPC_CheckField, 3, 1, 0, 193, 14, 0, // Skip to: 12598
/* 8821 */    MCD::OPC_Decode, 150, 8, 166, 1, // Opcode: SETj8gt
/* 8826 */    MCD::OPC_FilterValue, 238, 1, 11, 0, 0, // Skip to: 8843
/* 8832 */    MCD::OPC_CheckField, 3, 1, 1, 175, 14, 0, // Skip to: 12598
/* 8839 */    MCD::OPC_Decode, 166, 8, 17, // Opcode: SETp8gt
/* 8843 */    MCD::OPC_FilterValue, 252, 1, 5, 0, 0, // Skip to: 8854
/* 8849 */    MCD::OPC_Decode, 136, 8, 182, 1, // Opcode: SETd8le
/* 8854 */    MCD::OPC_FilterValue, 253, 1, 12, 0, 0, // Skip to: 8872
/* 8860 */    MCD::OPC_CheckField, 3, 1, 0, 147, 14, 0, // Skip to: 12598
/* 8867 */    MCD::OPC_Decode, 152, 8, 166, 1, // Opcode: SETj8le
/* 8872 */    MCD::OPC_FilterValue, 254, 1, 136, 14, 0, // Skip to: 12598
/* 8878 */    MCD::OPC_CheckField, 3, 1, 1, 129, 14, 0, // Skip to: 12598
/* 8885 */    MCD::OPC_Decode, 168, 8, 17, // Opcode: SETp8le
/* 8889 */    MCD::OPC_FilterValue, 6, 77, 1, 0, // Skip to: 9227
/* 8894 */    MCD::OPC_ExtractField, 8, 4,  // Inst{11-8} ...
/* 8897 */    MCD::OPC_FilterValue, 0, 17, 0, 0, // Skip to: 8919
/* 8902 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8914
/* 8909 */    MCD::OPC_Decode, 170, 3, 171, 1, // Opcode: BRA16
/* 8914 */    MCD::OPC_Decode, 171, 3, 183, 1, // Opcode: BRA8
/* 8919 */    MCD::OPC_FilterValue, 2, 17, 0, 0, // Skip to: 8941
/* 8924 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8936
/* 8931 */    MCD::OPC_Decode, 198, 3, 171, 1, // Opcode: Bhi16
/* 8936 */    MCD::OPC_Decode, 199, 3, 183, 1, // Opcode: Bhi8
/* 8941 */    MCD::OPC_FilterValue, 3, 17, 0, 0, // Skip to: 8963
/* 8946 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8958
/* 8953 */    MCD::OPC_Decode, 202, 3, 171, 1, // Opcode: Bls16
/* 8958 */    MCD::OPC_Decode, 203, 3, 183, 1, // Opcode: Bls8
/* 8963 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 8985
/* 8968 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 8980
/* 8975 */    MCD::OPC_Decode, 188, 3, 171, 1, // Opcode: Bcc16
/* 8980 */    MCD::OPC_Decode, 189, 3, 183, 1, // Opcode: Bcc8
/* 8985 */    MCD::OPC_FilterValue, 5, 17, 0, 0, // Skip to: 9007
/* 8990 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9002
/* 8997 */    MCD::OPC_Decode, 190, 3, 171, 1, // Opcode: Bcs16
/* 9002 */    MCD::OPC_Decode, 191, 3, 183, 1, // Opcode: Bcs8
/* 9007 */    MCD::OPC_FilterValue, 6, 17, 0, 0, // Skip to: 9029
/* 9012 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9024
/* 9019 */    MCD::OPC_Decode, 208, 3, 171, 1, // Opcode: Bne16
/* 9024 */    MCD::OPC_Decode, 209, 3, 183, 1, // Opcode: Bne8
/* 9029 */    MCD::OPC_FilterValue, 7, 17, 0, 0, // Skip to: 9051
/* 9034 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9046
/* 9041 */    MCD::OPC_Decode, 192, 3, 171, 1, // Opcode: Beq16
/* 9046 */    MCD::OPC_Decode, 193, 3, 183, 1, // Opcode: Beq8
/* 9051 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 9073
/* 9056 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9068
/* 9063 */    MCD::OPC_Decode, 212, 3, 171, 1, // Opcode: Bvc16
/* 9068 */    MCD::OPC_Decode, 213, 3, 183, 1, // Opcode: Bvc8
/* 9073 */    MCD::OPC_FilterValue, 9, 17, 0, 0, // Skip to: 9095
/* 9078 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9090
/* 9085 */    MCD::OPC_Decode, 214, 3, 171, 1, // Opcode: Bvs16
/* 9090 */    MCD::OPC_Decode, 215, 3, 183, 1, // Opcode: Bvs8
/* 9095 */    MCD::OPC_FilterValue, 10, 17, 0, 0, // Skip to: 9117
/* 9100 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9112
/* 9107 */    MCD::OPC_Decode, 210, 3, 171, 1, // Opcode: Bpl16
/* 9112 */    MCD::OPC_Decode, 211, 3, 183, 1, // Opcode: Bpl8
/* 9117 */    MCD::OPC_FilterValue, 11, 17, 0, 0, // Skip to: 9139
/* 9122 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9134
/* 9129 */    MCD::OPC_Decode, 206, 3, 171, 1, // Opcode: Bmi16
/* 9134 */    MCD::OPC_Decode, 207, 3, 183, 1, // Opcode: Bmi8
/* 9139 */    MCD::OPC_FilterValue, 12, 17, 0, 0, // Skip to: 9161
/* 9144 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9156
/* 9151 */    MCD::OPC_Decode, 194, 3, 171, 1, // Opcode: Bge16
/* 9156 */    MCD::OPC_Decode, 195, 3, 183, 1, // Opcode: Bge8
/* 9161 */    MCD::OPC_FilterValue, 13, 17, 0, 0, // Skip to: 9183
/* 9166 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9178
/* 9173 */    MCD::OPC_Decode, 204, 3, 171, 1, // Opcode: Blt16
/* 9178 */    MCD::OPC_Decode, 205, 3, 183, 1, // Opcode: Blt8
/* 9183 */    MCD::OPC_FilterValue, 14, 17, 0, 0, // Skip to: 9205
/* 9188 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9200
/* 9195 */    MCD::OPC_Decode, 196, 3, 171, 1, // Opcode: Bgt16
/* 9200 */    MCD::OPC_Decode, 197, 3, 183, 1, // Opcode: Bgt8
/* 9205 */    MCD::OPC_FilterValue, 15, 60, 13, 0, // Skip to: 12598
/* 9210 */    MCD::OPC_CheckField, 0, 8, 0, 5, 0, 0, // Skip to: 9222
/* 9217 */    MCD::OPC_Decode, 200, 3, 171, 1, // Opcode: Ble16
/* 9222 */    MCD::OPC_Decode, 201, 3, 183, 1, // Opcode: Ble8
/* 9227 */    MCD::OPC_FilterValue, 8, 110, 2, 0, // Skip to: 9854
/* 9232 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 9235 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9252
/* 9240 */    MCD::OPC_CheckField, 3, 1, 0, 23, 13, 0, // Skip to: 12598
/* 9247 */    MCD::OPC_Decode, 229, 7, 184, 1, // Opcode: OR8dd
/* 9252 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 9269
/* 9257 */    MCD::OPC_CheckField, 3, 1, 0, 6, 13, 0, // Skip to: 12598
/* 9264 */    MCD::OPC_Decode, 232, 7, 185, 1, // Opcode: OR8dj
/* 9269 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 9286
/* 9274 */    MCD::OPC_CheckField, 3, 1, 1, 245, 12, 0, // Skip to: 12598
/* 9281 */    MCD::OPC_Decode, 234, 7, 186, 1, // Opcode: OR8dp
/* 9286 */    MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 9363
/* 9291 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9294 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9311
/* 9299 */    MCD::OPC_CheckField, 24, 4, 8, 220, 12, 0, // Skip to: 12598
/* 9306 */    MCD::OPC_Decode, 230, 7, 187, 1, // Opcode: OR8df
/* 9311 */    MCD::OPC_FilterValue, 1, 210, 12, 0, // Skip to: 12598
/* 9316 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9319 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9329
/* 9324 */    MCD::OPC_Decode, 235, 7, 188, 1, // Opcode: OR8dq
/* 9329 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9346
/* 9334 */    MCD::OPC_CheckField, 24, 4, 8, 185, 12, 0, // Skip to: 12598
/* 9341 */    MCD::OPC_Decode, 233, 7, 189, 1, // Opcode: OR8dk
/* 9346 */    MCD::OPC_FilterValue, 4, 175, 12, 0, // Skip to: 12598
/* 9351 */    MCD::OPC_CheckField, 24, 8, 0, 168, 12, 0, // Skip to: 12598
/* 9358 */    MCD::OPC_Decode, 231, 7, 190, 1, // Opcode: OR8di
/* 9363 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 9385
/* 9368 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9380
/* 9375 */    MCD::OPC_Decode, 201, 7, 191, 1, // Opcode: OR16dd
/* 9380 */    MCD::OPC_Decode, 208, 7, 192, 1, // Opcode: OR16dr
/* 9385 */    MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 9402
/* 9390 */    MCD::OPC_CheckField, 3, 1, 0, 129, 12, 0, // Skip to: 12598
/* 9397 */    MCD::OPC_Decode, 204, 7, 193, 1, // Opcode: OR16dj
/* 9402 */    MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 9419
/* 9407 */    MCD::OPC_CheckField, 3, 1, 1, 112, 12, 0, // Skip to: 12598
/* 9414 */    MCD::OPC_Decode, 206, 7, 194, 1, // Opcode: OR16dp
/* 9419 */    MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 9489
/* 9424 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9427 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9444
/* 9432 */    MCD::OPC_CheckField, 24, 4, 8, 87, 12, 0, // Skip to: 12598
/* 9439 */    MCD::OPC_Decode, 202, 7, 195, 1, // Opcode: OR16df
/* 9444 */    MCD::OPC_FilterValue, 1, 77, 12, 0, // Skip to: 12598
/* 9449 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9452 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9462
/* 9457 */    MCD::OPC_Decode, 207, 7, 196, 1, // Opcode: OR16dq
/* 9462 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9479
/* 9467 */    MCD::OPC_CheckField, 24, 4, 8, 52, 12, 0, // Skip to: 12598
/* 9474 */    MCD::OPC_Decode, 205, 7, 197, 1, // Opcode: OR16dk
/* 9479 */    MCD::OPC_FilterValue, 4, 42, 12, 0, // Skip to: 12598
/* 9484 */    MCD::OPC_Decode, 203, 7, 196, 1, // Opcode: OR16di
/* 9489 */    MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 9511
/* 9494 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 9506
/* 9501 */    MCD::OPC_Decode, 215, 7, 198, 1, // Opcode: OR32dd
/* 9506 */    MCD::OPC_Decode, 222, 7, 199, 1, // Opcode: OR32dr
/* 9511 */    MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 9528
/* 9516 */    MCD::OPC_CheckField, 3, 1, 0, 3, 12, 0, // Skip to: 12598
/* 9523 */    MCD::OPC_Decode, 218, 7, 200, 1, // Opcode: OR32dj
/* 9528 */    MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 9545
/* 9533 */    MCD::OPC_CheckField, 3, 1, 1, 242, 11, 0, // Skip to: 12598
/* 9540 */    MCD::OPC_Decode, 220, 7, 201, 1, // Opcode: OR32dp
/* 9545 */    MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 9615
/* 9550 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9553 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9570
/* 9558 */    MCD::OPC_CheckField, 24, 4, 8, 217, 11, 0, // Skip to: 12598
/* 9565 */    MCD::OPC_Decode, 216, 7, 202, 1, // Opcode: OR32df
/* 9570 */    MCD::OPC_FilterValue, 1, 207, 11, 0, // Skip to: 12598
/* 9575 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9578 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9588
/* 9583 */    MCD::OPC_Decode, 221, 7, 203, 1, // Opcode: OR32dq
/* 9588 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9605
/* 9593 */    MCD::OPC_CheckField, 24, 4, 8, 182, 11, 0, // Skip to: 12598
/* 9600 */    MCD::OPC_Decode, 219, 7, 204, 1, // Opcode: OR32dk
/* 9605 */    MCD::OPC_FilterValue, 4, 172, 11, 0, // Skip to: 12598
/* 9610 */    MCD::OPC_Decode, 217, 7, 205, 1, // Opcode: OR32di
/* 9615 */    MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 9632
/* 9620 */    MCD::OPC_CheckField, 3, 1, 0, 155, 11, 0, // Skip to: 12598
/* 9627 */    MCD::OPC_Decode, 236, 8, 206, 1, // Opcode: UDIVd32d16
/* 9632 */    MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 9649
/* 9637 */    MCD::OPC_CheckField, 0, 4, 12, 138, 11, 0, // Skip to: 12598
/* 9644 */    MCD::OPC_Decode, 237, 8, 203, 1, // Opcode: UDIVd32i16
/* 9649 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 9665
/* 9654 */    MCD::OPC_CheckField, 3, 1, 0, 121, 11, 0, // Skip to: 12598
/* 9661 */    MCD::OPC_Decode, 238, 7, 40, // Opcode: OR8jd
/* 9665 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 9681
/* 9670 */    MCD::OPC_CheckField, 3, 1, 1, 105, 11, 0, // Skip to: 12598
/* 9677 */    MCD::OPC_Decode, 240, 7, 41, // Opcode: OR8pd
/* 9681 */    MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 9704
/* 9686 */    MCD::OPC_CheckField, 24, 4, 8, 89, 11, 0, // Skip to: 12598
/* 9693 */    MCD::OPC_CheckField, 3, 1, 0, 82, 11, 0, // Skip to: 12598
/* 9700 */    MCD::OPC_Decode, 236, 7, 42, // Opcode: OR8fd
/* 9704 */    MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 9721
/* 9709 */    MCD::OPC_CheckField, 3, 1, 0, 66, 11, 0, // Skip to: 12598
/* 9716 */    MCD::OPC_Decode, 211, 7, 207, 1, // Opcode: OR16jd
/* 9721 */    MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 9738
/* 9726 */    MCD::OPC_CheckField, 3, 1, 1, 49, 11, 0, // Skip to: 12598
/* 9733 */    MCD::OPC_Decode, 213, 7, 208, 1, // Opcode: OR16pd
/* 9738 */    MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 9762
/* 9743 */    MCD::OPC_CheckField, 24, 4, 8, 32, 11, 0, // Skip to: 12598
/* 9750 */    MCD::OPC_CheckField, 3, 1, 0, 25, 11, 0, // Skip to: 12598
/* 9757 */    MCD::OPC_Decode, 209, 7, 209, 1, // Opcode: OR16fd
/* 9762 */    MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 9779
/* 9767 */    MCD::OPC_CheckField, 3, 1, 0, 8, 11, 0, // Skip to: 12598
/* 9774 */    MCD::OPC_Decode, 225, 7, 210, 1, // Opcode: OR32jd
/* 9779 */    MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 9796
/* 9784 */    MCD::OPC_CheckField, 3, 1, 1, 247, 10, 0, // Skip to: 12598
/* 9791 */    MCD::OPC_Decode, 227, 7, 211, 1, // Opcode: OR32pd
/* 9796 */    MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 9820
/* 9801 */    MCD::OPC_CheckField, 24, 4, 8, 230, 10, 0, // Skip to: 12598
/* 9808 */    MCD::OPC_CheckField, 3, 1, 0, 223, 10, 0, // Skip to: 12598
/* 9815 */    MCD::OPC_Decode, 223, 7, 212, 1, // Opcode: OR32fd
/* 9820 */    MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 9837
/* 9825 */    MCD::OPC_CheckField, 3, 1, 0, 206, 10, 0, // Skip to: 12598
/* 9832 */    MCD::OPC_Decode, 255, 7, 206, 1, // Opcode: SDIVd32d16
/* 9837 */    MCD::OPC_FilterValue, 31, 196, 10, 0, // Skip to: 12598
/* 9842 */    MCD::OPC_CheckField, 0, 4, 12, 189, 10, 0, // Skip to: 12598
/* 9849 */    MCD::OPC_Decode, 128, 8, 203, 1, // Opcode: SDIVd32i16
/* 9854 */    MCD::OPC_FilterValue, 9, 207, 2, 0, // Skip to: 10578
/* 9859 */    MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 9862 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9879
/* 9867 */    MCD::OPC_CheckField, 3, 1, 0, 164, 10, 0, // Skip to: 12598
/* 9874 */    MCD::OPC_Decode, 220, 8, 184, 1, // Opcode: SUB8dd
/* 9879 */    MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 9896
/* 9884 */    MCD::OPC_CheckField, 3, 1, 0, 147, 10, 0, // Skip to: 12598
/* 9891 */    MCD::OPC_Decode, 223, 8, 185, 1, // Opcode: SUB8dj
/* 9896 */    MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 9913
/* 9901 */    MCD::OPC_CheckField, 3, 1, 1, 130, 10, 0, // Skip to: 12598
/* 9908 */    MCD::OPC_Decode, 225, 8, 186, 1, // Opcode: SUB8dp
/* 9913 */    MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 9990
/* 9918 */    MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 9921 */    MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 9938
/* 9926 */    MCD::OPC_CheckField, 24, 4, 8, 105, 10, 0, // Skip to: 12598
/* 9933 */    MCD::OPC_Decode, 221, 8, 187, 1, // Opcode: SUB8df
/* 9938 */    MCD::OPC_FilterValue, 1, 95, 10, 0, // Skip to: 12598
/* 9943 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 9946 */    MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 9956
/* 9951 */    MCD::OPC_Decode, 226, 8, 188, 1, // Opcode: SUB8dq
/* 9956 */    MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 9973
/* 9961 */    MCD::OPC_CheckField, 24, 4, 8, 70, 10, 0, // Skip to: 12598
/* 9968 */    MCD::OPC_Decode, 224, 8, 189, 1, // Opcode: SUB8dk
/* 9973 */    MCD::OPC_FilterValue, 4, 60, 10, 0, // Skip to: 12598
/* 9978 */    MCD::OPC_CheckField, 24, 8, 0, 53, 10, 0, // Skip to: 12598
/* 9985 */    MCD::OPC_Decode, 222, 8, 190, 1, // Opcode: SUB8di
/* 9990 */    MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 10012
/* 9995 */    MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10007
/* 10002 */   MCD::OPC_Decode, 185, 8, 191, 1, // Opcode: SUB16dd
/* 10007 */   MCD::OPC_Decode, 192, 8, 192, 1, // Opcode: SUB16dr
/* 10012 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10029
/* 10017 */   MCD::OPC_CheckField, 3, 1, 0, 14, 10, 0, // Skip to: 12598
/* 10024 */   MCD::OPC_Decode, 188, 8, 193, 1, // Opcode: SUB16dj
/* 10029 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10046
/* 10034 */   MCD::OPC_CheckField, 3, 1, 1, 253, 9, 0, // Skip to: 12598
/* 10041 */   MCD::OPC_Decode, 190, 8, 194, 1, // Opcode: SUB16dp
/* 10046 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 10116
/* 10051 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10054 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10071
/* 10059 */   MCD::OPC_CheckField, 24, 4, 8, 228, 9, 0, // Skip to: 12598
/* 10066 */   MCD::OPC_Decode, 186, 8, 195, 1, // Opcode: SUB16df
/* 10071 */   MCD::OPC_FilterValue, 1, 218, 9, 0, // Skip to: 12598
/* 10076 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10079 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10089
/* 10084 */   MCD::OPC_Decode, 191, 8, 196, 1, // Opcode: SUB16dq
/* 10089 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10106
/* 10094 */   MCD::OPC_CheckField, 24, 4, 8, 193, 9, 0, // Skip to: 12598
/* 10101 */   MCD::OPC_Decode, 189, 8, 197, 1, // Opcode: SUB16dk
/* 10106 */   MCD::OPC_FilterValue, 4, 183, 9, 0, // Skip to: 12598
/* 10111 */   MCD::OPC_Decode, 187, 8, 196, 1, // Opcode: SUB16di
/* 10116 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 10138
/* 10121 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 10133
/* 10128 */   MCD::OPC_Decode, 206, 8, 198, 1, // Opcode: SUB32dd
/* 10133 */   MCD::OPC_Decode, 213, 8, 199, 1, // Opcode: SUB32dr
/* 10138 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 10155
/* 10143 */   MCD::OPC_CheckField, 3, 1, 0, 144, 9, 0, // Skip to: 12598
/* 10150 */   MCD::OPC_Decode, 209, 8, 200, 1, // Opcode: SUB32dj
/* 10155 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 10172
/* 10160 */   MCD::OPC_CheckField, 3, 1, 1, 127, 9, 0, // Skip to: 12598
/* 10167 */   MCD::OPC_Decode, 211, 8, 201, 1, // Opcode: SUB32dp
/* 10172 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 10242
/* 10177 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10180 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10197
/* 10185 */   MCD::OPC_CheckField, 24, 4, 8, 102, 9, 0, // Skip to: 12598
/* 10192 */   MCD::OPC_Decode, 207, 8, 202, 1, // Opcode: SUB32df
/* 10197 */   MCD::OPC_FilterValue, 1, 92, 9, 0, // Skip to: 12598
/* 10202 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10205 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10215
/* 10210 */   MCD::OPC_Decode, 212, 8, 203, 1, // Opcode: SUB32dq
/* 10215 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10232
/* 10220 */   MCD::OPC_CheckField, 24, 4, 8, 67, 9, 0, // Skip to: 12598
/* 10227 */   MCD::OPC_Decode, 210, 8, 204, 1, // Opcode: SUB32dk
/* 10232 */   MCD::OPC_FilterValue, 4, 57, 9, 0, // Skip to: 12598
/* 10237 */   MCD::OPC_Decode, 208, 8, 205, 1, // Opcode: SUB32di
/* 10242 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 10259
/* 10247 */   MCD::OPC_CheckField, 3, 1, 0, 40, 9, 0, // Skip to: 12598
/* 10254 */   MCD::OPC_Decode, 235, 8, 184, 1, // Opcode: SUBX8dd
/* 10259 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 10275
/* 10264 */   MCD::OPC_CheckField, 3, 1, 0, 23, 9, 0, // Skip to: 12598
/* 10271 */   MCD::OPC_Decode, 229, 8, 40, // Opcode: SUB8jd
/* 10275 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 10291
/* 10280 */   MCD::OPC_CheckField, 3, 1, 1, 7, 9, 0, // Skip to: 12598
/* 10287 */   MCD::OPC_Decode, 231, 8, 41, // Opcode: SUB8pd
/* 10291 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 10314
/* 10296 */   MCD::OPC_CheckField, 24, 4, 8, 247, 8, 0, // Skip to: 12598
/* 10303 */   MCD::OPC_CheckField, 3, 1, 0, 240, 8, 0, // Skip to: 12598
/* 10310 */   MCD::OPC_Decode, 227, 8, 42, // Opcode: SUB8fd
/* 10314 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 10331
/* 10319 */   MCD::OPC_CheckField, 3, 1, 0, 224, 8, 0, // Skip to: 12598
/* 10326 */   MCD::OPC_Decode, 233, 8, 191, 1, // Opcode: SUBX16dd
/* 10331 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 10348
/* 10336 */   MCD::OPC_CheckField, 3, 1, 0, 207, 8, 0, // Skip to: 12598
/* 10343 */   MCD::OPC_Decode, 195, 8, 207, 1, // Opcode: SUB16jd
/* 10348 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 10365
/* 10353 */   MCD::OPC_CheckField, 3, 1, 1, 190, 8, 0, // Skip to: 12598
/* 10360 */   MCD::OPC_Decode, 197, 8, 208, 1, // Opcode: SUB16pd
/* 10365 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 10389
/* 10370 */   MCD::OPC_CheckField, 24, 4, 8, 173, 8, 0, // Skip to: 12598
/* 10377 */   MCD::OPC_CheckField, 3, 1, 0, 166, 8, 0, // Skip to: 12598
/* 10384 */   MCD::OPC_Decode, 193, 8, 209, 1, // Opcode: SUB16fd
/* 10389 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 10406
/* 10394 */   MCD::OPC_CheckField, 3, 1, 0, 149, 8, 0, // Skip to: 12598
/* 10401 */   MCD::OPC_Decode, 234, 8, 198, 1, // Opcode: SUBX32dd
/* 10406 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 10423
/* 10411 */   MCD::OPC_CheckField, 3, 1, 0, 132, 8, 0, // Skip to: 12598
/* 10418 */   MCD::OPC_Decode, 216, 8, 210, 1, // Opcode: SUB32jd
/* 10423 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 10440
/* 10428 */   MCD::OPC_CheckField, 3, 1, 1, 115, 8, 0, // Skip to: 12598
/* 10435 */   MCD::OPC_Decode, 218, 8, 211, 1, // Opcode: SUB32pd
/* 10440 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 10464
/* 10445 */   MCD::OPC_CheckField, 24, 4, 8, 98, 8, 0, // Skip to: 12598
/* 10452 */   MCD::OPC_CheckField, 3, 1, 0, 91, 8, 0, // Skip to: 12598
/* 10459 */   MCD::OPC_Decode, 214, 8, 212, 1, // Opcode: SUB32fd
/* 10464 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 10474
/* 10469 */   MCD::OPC_Decode, 205, 8, 213, 1, // Opcode: SUB32ar
/* 10474 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 10491
/* 10479 */   MCD::OPC_CheckField, 3, 1, 0, 64, 8, 0, // Skip to: 12598
/* 10486 */   MCD::OPC_Decode, 201, 8, 214, 1, // Opcode: SUB32aj
/* 10491 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 10508
/* 10496 */   MCD::OPC_CheckField, 3, 1, 1, 47, 8, 0, // Skip to: 12598
/* 10503 */   MCD::OPC_Decode, 203, 8, 215, 1, // Opcode: SUB32ap
/* 10508 */   MCD::OPC_FilterValue, 31, 37, 8, 0, // Skip to: 12598
/* 10513 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10516 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10533
/* 10521 */   MCD::OPC_CheckField, 24, 4, 8, 22, 8, 0, // Skip to: 12598
/* 10528 */   MCD::OPC_Decode, 199, 8, 216, 1, // Opcode: SUB32af
/* 10533 */   MCD::OPC_FilterValue, 1, 12, 8, 0, // Skip to: 12598
/* 10538 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10541 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10551
/* 10546 */   MCD::OPC_Decode, 204, 8, 217, 1, // Opcode: SUB32aq
/* 10551 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 10568
/* 10556 */   MCD::OPC_CheckField, 24, 4, 8, 243, 7, 0, // Skip to: 12598
/* 10563 */   MCD::OPC_Decode, 202, 8, 218, 1, // Opcode: SUB32ak
/* 10568 */   MCD::OPC_FilterValue, 4, 233, 7, 0, // Skip to: 12598
/* 10573 */   MCD::OPC_Decode, 200, 8, 219, 1, // Opcode: SUB32ai
/* 10578 */   MCD::OPC_FilterValue, 11, 100, 1, 0, // Skip to: 10939
/* 10583 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10586 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 10596
/* 10591 */   MCD::OPC_Decode, 250, 3, 220, 1, // Opcode: CMP8dd
/* 10596 */   MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 10612
/* 10601 */   MCD::OPC_CheckField, 3, 1, 0, 198, 7, 0, // Skip to: 12598
/* 10608 */   MCD::OPC_Decode, 253, 3, 46, // Opcode: CMP8dj
/* 10612 */   MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 10628
/* 10617 */   MCD::OPC_CheckField, 3, 1, 1, 182, 7, 0, // Skip to: 12598
/* 10624 */   MCD::OPC_Decode, 255, 3, 47, // Opcode: CMP8dp
/* 10628 */   MCD::OPC_FilterValue, 3, 52, 0, 0, // Skip to: 10685
/* 10633 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10636 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10652
/* 10641 */   MCD::OPC_CheckField, 24, 4, 8, 158, 7, 0, // Skip to: 12598
/* 10648 */   MCD::OPC_Decode, 251, 3, 48, // Opcode: CMP8df
/* 10652 */   MCD::OPC_FilterValue, 1, 149, 7, 0, // Skip to: 12598
/* 10657 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10660 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 10669
/* 10665 */   MCD::OPC_Decode, 128, 4, 50, // Opcode: CMP8dq
/* 10669 */   MCD::OPC_FilterValue, 3, 132, 7, 0, // Skip to: 12598
/* 10674 */   MCD::OPC_CheckField, 24, 4, 8, 125, 7, 0, // Skip to: 12598
/* 10681 */   MCD::OPC_Decode, 254, 3, 51, // Opcode: CMP8dk
/* 10685 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 10695
/* 10690 */   MCD::OPC_Decode, 230, 3, 221, 1, // Opcode: CMP16dr
/* 10695 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 10712
/* 10700 */   MCD::OPC_CheckField, 3, 1, 0, 99, 7, 0, // Skip to: 12598
/* 10707 */   MCD::OPC_Decode, 226, 3, 144, 1, // Opcode: CMP16dj
/* 10712 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 10729
/* 10717 */   MCD::OPC_CheckField, 3, 1, 1, 82, 7, 0, // Skip to: 12598
/* 10724 */   MCD::OPC_Decode, 228, 3, 147, 1, // Opcode: CMP16dp
/* 10729 */   MCD::OPC_FilterValue, 7, 55, 0, 0, // Skip to: 10789
/* 10734 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10737 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10754
/* 10742 */   MCD::OPC_CheckField, 24, 4, 8, 57, 7, 0, // Skip to: 12598
/* 10749 */   MCD::OPC_Decode, 224, 3, 150, 1, // Opcode: CMP16df
/* 10754 */   MCD::OPC_FilterValue, 1, 47, 7, 0, // Skip to: 12598
/* 10759 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10762 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 10772
/* 10767 */   MCD::OPC_Decode, 229, 3, 156, 1, // Opcode: CMP16dq
/* 10772 */   MCD::OPC_FilterValue, 3, 29, 7, 0, // Skip to: 12598
/* 10777 */   MCD::OPC_CheckField, 24, 4, 8, 22, 7, 0, // Skip to: 12598
/* 10784 */   MCD::OPC_Decode, 227, 3, 159, 1, // Opcode: CMP16dk
/* 10789 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 10799
/* 10794 */   MCD::OPC_Decode, 243, 3, 222, 1, // Opcode: CMP32dr
/* 10799 */   MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 10815
/* 10804 */   MCD::OPC_CheckField, 3, 1, 0, 251, 6, 0, // Skip to: 12598
/* 10811 */   MCD::OPC_Decode, 239, 3, 111, // Opcode: CMP32dj
/* 10815 */   MCD::OPC_FilterValue, 10, 11, 0, 0, // Skip to: 10831
/* 10820 */   MCD::OPC_CheckField, 3, 1, 1, 235, 6, 0, // Skip to: 12598
/* 10827 */   MCD::OPC_Decode, 241, 3, 112, // Opcode: CMP32dp
/* 10831 */   MCD::OPC_FilterValue, 11, 52, 0, 0, // Skip to: 10888
/* 10836 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 10839 */   MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 10855
/* 10844 */   MCD::OPC_CheckField, 24, 4, 8, 211, 6, 0, // Skip to: 12598
/* 10851 */   MCD::OPC_Decode, 237, 3, 114, // Opcode: CMP32df
/* 10855 */   MCD::OPC_FilterValue, 1, 202, 6, 0, // Skip to: 12598
/* 10860 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 10863 */   MCD::OPC_FilterValue, 2, 4, 0, 0, // Skip to: 10872
/* 10868 */   MCD::OPC_Decode, 242, 3, 118, // Opcode: CMP32dq
/* 10872 */   MCD::OPC_FilterValue, 3, 185, 6, 0, // Skip to: 12598
/* 10877 */   MCD::OPC_CheckField, 24, 4, 8, 178, 6, 0, // Skip to: 12598
/* 10884 */   MCD::OPC_Decode, 240, 3, 120, // Opcode: CMP32dk
/* 10888 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 10905
/* 10893 */   MCD::OPC_CheckField, 3, 1, 0, 162, 6, 0, // Skip to: 12598
/* 10900 */   MCD::OPC_Decode, 245, 8, 223, 1, // Opcode: XOR8dd
/* 10905 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 10922
/* 10910 */   MCD::OPC_CheckField, 3, 1, 0, 145, 6, 0, // Skip to: 12598
/* 10917 */   MCD::OPC_Decode, 241, 8, 224, 1, // Opcode: XOR16dd
/* 10922 */   MCD::OPC_FilterValue, 24, 135, 6, 0, // Skip to: 12598
/* 10927 */   MCD::OPC_CheckField, 3, 1, 0, 128, 6, 0, // Skip to: 12598
/* 10934 */   MCD::OPC_Decode, 243, 8, 225, 1, // Opcode: XOR32dd
/* 10939 */   MCD::OPC_FilterValue, 12, 110, 2, 0, // Skip to: 11566
/* 10944 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 10947 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 10964
/* 10952 */   MCD::OPC_CheckField, 3, 1, 0, 103, 6, 0, // Skip to: 12598
/* 10959 */   MCD::OPC_Decode, 151, 3, 184, 1, // Opcode: AND8dd
/* 10964 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 10981
/* 10969 */   MCD::OPC_CheckField, 3, 1, 0, 86, 6, 0, // Skip to: 12598
/* 10976 */   MCD::OPC_Decode, 154, 3, 185, 1, // Opcode: AND8dj
/* 10981 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 10998
/* 10986 */   MCD::OPC_CheckField, 3, 1, 1, 69, 6, 0, // Skip to: 12598
/* 10993 */   MCD::OPC_Decode, 156, 3, 186, 1, // Opcode: AND8dp
/* 10998 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11075
/* 11003 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11006 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11023
/* 11011 */   MCD::OPC_CheckField, 24, 4, 8, 44, 6, 0, // Skip to: 12598
/* 11018 */   MCD::OPC_Decode, 152, 3, 187, 1, // Opcode: AND8df
/* 11023 */   MCD::OPC_FilterValue, 1, 34, 6, 0, // Skip to: 12598
/* 11028 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11031 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11041
/* 11036 */   MCD::OPC_Decode, 157, 3, 188, 1, // Opcode: AND8dq
/* 11041 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11058
/* 11046 */   MCD::OPC_CheckField, 24, 4, 8, 9, 6, 0, // Skip to: 12598
/* 11053 */   MCD::OPC_Decode, 155, 3, 189, 1, // Opcode: AND8dk
/* 11058 */   MCD::OPC_FilterValue, 4, 255, 5, 0, // Skip to: 12598
/* 11063 */   MCD::OPC_CheckField, 24, 8, 0, 248, 5, 0, // Skip to: 12598
/* 11070 */   MCD::OPC_Decode, 153, 3, 190, 1, // Opcode: AND8di
/* 11075 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11097
/* 11080 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11092
/* 11087 */   MCD::OPC_Decode, 251, 2, 191, 1, // Opcode: AND16dd
/* 11092 */   MCD::OPC_Decode, 130, 3, 192, 1, // Opcode: AND16dr
/* 11097 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11114
/* 11102 */   MCD::OPC_CheckField, 3, 1, 0, 209, 5, 0, // Skip to: 12598
/* 11109 */   MCD::OPC_Decode, 254, 2, 193, 1, // Opcode: AND16dj
/* 11114 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11131
/* 11119 */   MCD::OPC_CheckField, 3, 1, 1, 192, 5, 0, // Skip to: 12598
/* 11126 */   MCD::OPC_Decode, 128, 3, 194, 1, // Opcode: AND16dp
/* 11131 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11201
/* 11136 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11139 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11156
/* 11144 */   MCD::OPC_CheckField, 24, 4, 8, 167, 5, 0, // Skip to: 12598
/* 11151 */   MCD::OPC_Decode, 252, 2, 195, 1, // Opcode: AND16df
/* 11156 */   MCD::OPC_FilterValue, 1, 157, 5, 0, // Skip to: 12598
/* 11161 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11164 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11174
/* 11169 */   MCD::OPC_Decode, 129, 3, 196, 1, // Opcode: AND16dq
/* 11174 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11191
/* 11179 */   MCD::OPC_CheckField, 24, 4, 8, 132, 5, 0, // Skip to: 12598
/* 11186 */   MCD::OPC_Decode, 255, 2, 197, 1, // Opcode: AND16dk
/* 11191 */   MCD::OPC_FilterValue, 4, 122, 5, 0, // Skip to: 12598
/* 11196 */   MCD::OPC_Decode, 253, 2, 196, 1, // Opcode: AND16di
/* 11201 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11223
/* 11206 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11218
/* 11213 */   MCD::OPC_Decode, 137, 3, 198, 1, // Opcode: AND32dd
/* 11218 */   MCD::OPC_Decode, 144, 3, 199, 1, // Opcode: AND32dr
/* 11223 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11240
/* 11228 */   MCD::OPC_CheckField, 3, 1, 0, 83, 5, 0, // Skip to: 12598
/* 11235 */   MCD::OPC_Decode, 140, 3, 200, 1, // Opcode: AND32dj
/* 11240 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11257
/* 11245 */   MCD::OPC_CheckField, 3, 1, 1, 66, 5, 0, // Skip to: 12598
/* 11252 */   MCD::OPC_Decode, 142, 3, 201, 1, // Opcode: AND32dp
/* 11257 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11327
/* 11262 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11265 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11282
/* 11270 */   MCD::OPC_CheckField, 24, 4, 8, 41, 5, 0, // Skip to: 12598
/* 11277 */   MCD::OPC_Decode, 138, 3, 202, 1, // Opcode: AND32df
/* 11282 */   MCD::OPC_FilterValue, 1, 31, 5, 0, // Skip to: 12598
/* 11287 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11290 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11300
/* 11295 */   MCD::OPC_Decode, 143, 3, 203, 1, // Opcode: AND32dq
/* 11300 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11317
/* 11305 */   MCD::OPC_CheckField, 24, 4, 8, 6, 5, 0, // Skip to: 12598
/* 11312 */   MCD::OPC_Decode, 141, 3, 204, 1, // Opcode: AND32dk
/* 11317 */   MCD::OPC_FilterValue, 4, 252, 4, 0, // Skip to: 12598
/* 11322 */   MCD::OPC_Decode, 139, 3, 205, 1, // Opcode: AND32di
/* 11327 */   MCD::OPC_FilterValue, 12, 12, 0, 0, // Skip to: 11344
/* 11332 */   MCD::OPC_CheckField, 3, 1, 0, 235, 4, 0, // Skip to: 12598
/* 11339 */   MCD::OPC_Decode, 238, 8, 206, 1, // Opcode: UMULd32d16
/* 11344 */   MCD::OPC_FilterValue, 15, 12, 0, 0, // Skip to: 11361
/* 11349 */   MCD::OPC_CheckField, 0, 4, 12, 218, 4, 0, // Skip to: 12598
/* 11356 */   MCD::OPC_Decode, 239, 8, 203, 1, // Opcode: UMULd32i16
/* 11361 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11377
/* 11366 */   MCD::OPC_CheckField, 3, 1, 0, 201, 4, 0, // Skip to: 12598
/* 11373 */   MCD::OPC_Decode, 160, 3, 40, // Opcode: AND8jd
/* 11377 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 11393
/* 11382 */   MCD::OPC_CheckField, 3, 1, 1, 185, 4, 0, // Skip to: 12598
/* 11389 */   MCD::OPC_Decode, 162, 3, 41, // Opcode: AND8pd
/* 11393 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 11416
/* 11398 */   MCD::OPC_CheckField, 24, 4, 8, 169, 4, 0, // Skip to: 12598
/* 11405 */   MCD::OPC_CheckField, 3, 1, 0, 162, 4, 0, // Skip to: 12598
/* 11412 */   MCD::OPC_Decode, 158, 3, 42, // Opcode: AND8fd
/* 11416 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 11433
/* 11421 */   MCD::OPC_CheckField, 3, 1, 0, 146, 4, 0, // Skip to: 12598
/* 11428 */   MCD::OPC_Decode, 133, 3, 207, 1, // Opcode: AND16jd
/* 11433 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 11450
/* 11438 */   MCD::OPC_CheckField, 3, 1, 1, 129, 4, 0, // Skip to: 12598
/* 11445 */   MCD::OPC_Decode, 135, 3, 208, 1, // Opcode: AND16pd
/* 11450 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 11474
/* 11455 */   MCD::OPC_CheckField, 24, 4, 8, 112, 4, 0, // Skip to: 12598
/* 11462 */   MCD::OPC_CheckField, 3, 1, 0, 105, 4, 0, // Skip to: 12598
/* 11469 */   MCD::OPC_Decode, 131, 3, 209, 1, // Opcode: AND16fd
/* 11474 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 11491
/* 11479 */   MCD::OPC_CheckField, 3, 1, 0, 88, 4, 0, // Skip to: 12598
/* 11486 */   MCD::OPC_Decode, 147, 3, 210, 1, // Opcode: AND32jd
/* 11491 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 11508
/* 11496 */   MCD::OPC_CheckField, 3, 1, 1, 71, 4, 0, // Skip to: 12598
/* 11503 */   MCD::OPC_Decode, 149, 3, 211, 1, // Opcode: AND32pd
/* 11508 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 11532
/* 11513 */   MCD::OPC_CheckField, 24, 4, 8, 54, 4, 0, // Skip to: 12598
/* 11520 */   MCD::OPC_CheckField, 3, 1, 0, 47, 4, 0, // Skip to: 12598
/* 11527 */   MCD::OPC_Decode, 145, 3, 212, 1, // Opcode: AND32fd
/* 11532 */   MCD::OPC_FilterValue, 28, 12, 0, 0, // Skip to: 11549
/* 11537 */   MCD::OPC_CheckField, 3, 1, 0, 30, 4, 0, // Skip to: 12598
/* 11544 */   MCD::OPC_Decode, 183, 8, 206, 1, // Opcode: SMULd32d16
/* 11549 */   MCD::OPC_FilterValue, 31, 20, 4, 0, // Skip to: 12598
/* 11554 */   MCD::OPC_CheckField, 0, 4, 12, 13, 4, 0, // Skip to: 12598
/* 11561 */   MCD::OPC_Decode, 184, 8, 203, 1, // Opcode: SMULd32i16
/* 11566 */   MCD::OPC_FilterValue, 13, 207, 2, 0, // Skip to: 12290
/* 11571 */   MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 11574 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11591
/* 11579 */   MCD::OPC_CheckField, 3, 1, 0, 244, 3, 0, // Skip to: 12598
/* 11586 */   MCD::OPC_Decode, 235, 2, 184, 1, // Opcode: ADD8dd
/* 11591 */   MCD::OPC_FilterValue, 1, 12, 0, 0, // Skip to: 11608
/* 11596 */   MCD::OPC_CheckField, 3, 1, 0, 227, 3, 0, // Skip to: 12598
/* 11603 */   MCD::OPC_Decode, 238, 2, 185, 1, // Opcode: ADD8dj
/* 11608 */   MCD::OPC_FilterValue, 2, 12, 0, 0, // Skip to: 11625
/* 11613 */   MCD::OPC_CheckField, 3, 1, 1, 210, 3, 0, // Skip to: 12598
/* 11620 */   MCD::OPC_Decode, 240, 2, 186, 1, // Opcode: ADD8dp
/* 11625 */   MCD::OPC_FilterValue, 3, 72, 0, 0, // Skip to: 11702
/* 11630 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11633 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11650
/* 11638 */   MCD::OPC_CheckField, 24, 4, 8, 185, 3, 0, // Skip to: 12598
/* 11645 */   MCD::OPC_Decode, 236, 2, 187, 1, // Opcode: ADD8df
/* 11650 */   MCD::OPC_FilterValue, 1, 175, 3, 0, // Skip to: 12598
/* 11655 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11658 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11668
/* 11663 */   MCD::OPC_Decode, 241, 2, 188, 1, // Opcode: ADD8dq
/* 11668 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11685
/* 11673 */   MCD::OPC_CheckField, 24, 4, 8, 150, 3, 0, // Skip to: 12598
/* 11680 */   MCD::OPC_Decode, 239, 2, 189, 1, // Opcode: ADD8dk
/* 11685 */   MCD::OPC_FilterValue, 4, 140, 3, 0, // Skip to: 12598
/* 11690 */   MCD::OPC_CheckField, 24, 8, 0, 133, 3, 0, // Skip to: 12598
/* 11697 */   MCD::OPC_Decode, 237, 2, 190, 1, // Opcode: ADD8di
/* 11702 */   MCD::OPC_FilterValue, 4, 17, 0, 0, // Skip to: 11724
/* 11707 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11719
/* 11714 */   MCD::OPC_Decode, 200, 2, 191, 1, // Opcode: ADD16dd
/* 11719 */   MCD::OPC_Decode, 207, 2, 192, 1, // Opcode: ADD16dr
/* 11724 */   MCD::OPC_FilterValue, 5, 12, 0, 0, // Skip to: 11741
/* 11729 */   MCD::OPC_CheckField, 3, 1, 0, 94, 3, 0, // Skip to: 12598
/* 11736 */   MCD::OPC_Decode, 203, 2, 193, 1, // Opcode: ADD16dj
/* 11741 */   MCD::OPC_FilterValue, 6, 12, 0, 0, // Skip to: 11758
/* 11746 */   MCD::OPC_CheckField, 3, 1, 1, 77, 3, 0, // Skip to: 12598
/* 11753 */   MCD::OPC_Decode, 205, 2, 194, 1, // Opcode: ADD16dp
/* 11758 */   MCD::OPC_FilterValue, 7, 65, 0, 0, // Skip to: 11828
/* 11763 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11766 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11783
/* 11771 */   MCD::OPC_CheckField, 24, 4, 8, 52, 3, 0, // Skip to: 12598
/* 11778 */   MCD::OPC_Decode, 201, 2, 195, 1, // Opcode: ADD16df
/* 11783 */   MCD::OPC_FilterValue, 1, 42, 3, 0, // Skip to: 12598
/* 11788 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11791 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11801
/* 11796 */   MCD::OPC_Decode, 206, 2, 196, 1, // Opcode: ADD16dq
/* 11801 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11818
/* 11806 */   MCD::OPC_CheckField, 24, 4, 8, 17, 3, 0, // Skip to: 12598
/* 11813 */   MCD::OPC_Decode, 204, 2, 197, 1, // Opcode: ADD16dk
/* 11818 */   MCD::OPC_FilterValue, 4, 7, 3, 0, // Skip to: 12598
/* 11823 */   MCD::OPC_Decode, 202, 2, 196, 1, // Opcode: ADD16di
/* 11828 */   MCD::OPC_FilterValue, 8, 17, 0, 0, // Skip to: 11850
/* 11833 */   MCD::OPC_CheckField, 3, 1, 0, 5, 0, 0, // Skip to: 11845
/* 11840 */   MCD::OPC_Decode, 221, 2, 198, 1, // Opcode: ADD32dd
/* 11845 */   MCD::OPC_Decode, 228, 2, 199, 1, // Opcode: ADD32dr
/* 11850 */   MCD::OPC_FilterValue, 9, 12, 0, 0, // Skip to: 11867
/* 11855 */   MCD::OPC_CheckField, 3, 1, 0, 224, 2, 0, // Skip to: 12598
/* 11862 */   MCD::OPC_Decode, 224, 2, 200, 1, // Opcode: ADD32dj
/* 11867 */   MCD::OPC_FilterValue, 10, 12, 0, 0, // Skip to: 11884
/* 11872 */   MCD::OPC_CheckField, 3, 1, 1, 207, 2, 0, // Skip to: 12598
/* 11879 */   MCD::OPC_Decode, 226, 2, 201, 1, // Opcode: ADD32dp
/* 11884 */   MCD::OPC_FilterValue, 11, 65, 0, 0, // Skip to: 11954
/* 11889 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 11892 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 11909
/* 11897 */   MCD::OPC_CheckField, 24, 4, 8, 182, 2, 0, // Skip to: 12598
/* 11904 */   MCD::OPC_Decode, 222, 2, 202, 1, // Opcode: ADD32df
/* 11909 */   MCD::OPC_FilterValue, 1, 172, 2, 0, // Skip to: 12598
/* 11914 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 11917 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 11927
/* 11922 */   MCD::OPC_Decode, 227, 2, 203, 1, // Opcode: ADD32dq
/* 11927 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 11944
/* 11932 */   MCD::OPC_CheckField, 24, 4, 8, 147, 2, 0, // Skip to: 12598
/* 11939 */   MCD::OPC_Decode, 225, 2, 204, 1, // Opcode: ADD32dk
/* 11944 */   MCD::OPC_FilterValue, 4, 137, 2, 0, // Skip to: 12598
/* 11949 */   MCD::OPC_Decode, 223, 2, 205, 1, // Opcode: ADD32di
/* 11954 */   MCD::OPC_FilterValue, 16, 12, 0, 0, // Skip to: 11971
/* 11959 */   MCD::OPC_CheckField, 3, 1, 0, 120, 2, 0, // Skip to: 12598
/* 11966 */   MCD::OPC_Decode, 250, 2, 184, 1, // Opcode: ADDX8dd
/* 11971 */   MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 11987
/* 11976 */   MCD::OPC_CheckField, 3, 1, 0, 103, 2, 0, // Skip to: 12598
/* 11983 */   MCD::OPC_Decode, 244, 2, 40, // Opcode: ADD8jd
/* 11987 */   MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 12003
/* 11992 */   MCD::OPC_CheckField, 3, 1, 1, 87, 2, 0, // Skip to: 12598
/* 11999 */   MCD::OPC_Decode, 246, 2, 41, // Opcode: ADD8pd
/* 12003 */   MCD::OPC_FilterValue, 19, 18, 0, 0, // Skip to: 12026
/* 12008 */   MCD::OPC_CheckField, 24, 4, 8, 71, 2, 0, // Skip to: 12598
/* 12015 */   MCD::OPC_CheckField, 3, 1, 0, 64, 2, 0, // Skip to: 12598
/* 12022 */   MCD::OPC_Decode, 242, 2, 42, // Opcode: ADD8fd
/* 12026 */   MCD::OPC_FilterValue, 20, 12, 0, 0, // Skip to: 12043
/* 12031 */   MCD::OPC_CheckField, 3, 1, 0, 48, 2, 0, // Skip to: 12598
/* 12038 */   MCD::OPC_Decode, 248, 2, 191, 1, // Opcode: ADDX16dd
/* 12043 */   MCD::OPC_FilterValue, 21, 12, 0, 0, // Skip to: 12060
/* 12048 */   MCD::OPC_CheckField, 3, 1, 0, 31, 2, 0, // Skip to: 12598
/* 12055 */   MCD::OPC_Decode, 210, 2, 207, 1, // Opcode: ADD16jd
/* 12060 */   MCD::OPC_FilterValue, 22, 12, 0, 0, // Skip to: 12077
/* 12065 */   MCD::OPC_CheckField, 3, 1, 1, 14, 2, 0, // Skip to: 12598
/* 12072 */   MCD::OPC_Decode, 212, 2, 208, 1, // Opcode: ADD16pd
/* 12077 */   MCD::OPC_FilterValue, 23, 19, 0, 0, // Skip to: 12101
/* 12082 */   MCD::OPC_CheckField, 24, 4, 8, 253, 1, 0, // Skip to: 12598
/* 12089 */   MCD::OPC_CheckField, 3, 1, 0, 246, 1, 0, // Skip to: 12598
/* 12096 */   MCD::OPC_Decode, 208, 2, 209, 1, // Opcode: ADD16fd
/* 12101 */   MCD::OPC_FilterValue, 24, 12, 0, 0, // Skip to: 12118
/* 12106 */   MCD::OPC_CheckField, 3, 1, 0, 229, 1, 0, // Skip to: 12598
/* 12113 */   MCD::OPC_Decode, 249, 2, 198, 1, // Opcode: ADDX32dd
/* 12118 */   MCD::OPC_FilterValue, 25, 12, 0, 0, // Skip to: 12135
/* 12123 */   MCD::OPC_CheckField, 3, 1, 0, 212, 1, 0, // Skip to: 12598
/* 12130 */   MCD::OPC_Decode, 231, 2, 210, 1, // Opcode: ADD32jd
/* 12135 */   MCD::OPC_FilterValue, 26, 12, 0, 0, // Skip to: 12152
/* 12140 */   MCD::OPC_CheckField, 3, 1, 1, 195, 1, 0, // Skip to: 12598
/* 12147 */   MCD::OPC_Decode, 233, 2, 211, 1, // Opcode: ADD32pd
/* 12152 */   MCD::OPC_FilterValue, 27, 19, 0, 0, // Skip to: 12176
/* 12157 */   MCD::OPC_CheckField, 24, 4, 8, 178, 1, 0, // Skip to: 12598
/* 12164 */   MCD::OPC_CheckField, 3, 1, 0, 171, 1, 0, // Skip to: 12598
/* 12171 */   MCD::OPC_Decode, 229, 2, 212, 1, // Opcode: ADD32fd
/* 12176 */   MCD::OPC_FilterValue, 28, 5, 0, 0, // Skip to: 12186
/* 12181 */   MCD::OPC_Decode, 220, 2, 213, 1, // Opcode: ADD32ar
/* 12186 */   MCD::OPC_FilterValue, 29, 12, 0, 0, // Skip to: 12203
/* 12191 */   MCD::OPC_CheckField, 3, 1, 0, 144, 1, 0, // Skip to: 12598
/* 12198 */   MCD::OPC_Decode, 216, 2, 214, 1, // Opcode: ADD32aj
/* 12203 */   MCD::OPC_FilterValue, 30, 12, 0, 0, // Skip to: 12220
/* 12208 */   MCD::OPC_CheckField, 3, 1, 1, 127, 1, 0, // Skip to: 12598
/* 12215 */   MCD::OPC_Decode, 218, 2, 215, 1, // Opcode: ADD32ap
/* 12220 */   MCD::OPC_FilterValue, 31, 117, 1, 0, // Skip to: 12598
/* 12225 */   MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 12228 */   MCD::OPC_FilterValue, 0, 12, 0, 0, // Skip to: 12245
/* 12233 */   MCD::OPC_CheckField, 24, 4, 8, 102, 1, 0, // Skip to: 12598
/* 12240 */   MCD::OPC_Decode, 214, 2, 216, 1, // Opcode: ADD32af
/* 12245 */   MCD::OPC_FilterValue, 1, 92, 1, 0, // Skip to: 12598
/* 12250 */   MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 12253 */   MCD::OPC_FilterValue, 2, 5, 0, 0, // Skip to: 12263
/* 12258 */   MCD::OPC_Decode, 219, 2, 217, 1, // Opcode: ADD32aq
/* 12263 */   MCD::OPC_FilterValue, 3, 12, 0, 0, // Skip to: 12280
/* 12268 */   MCD::OPC_CheckField, 24, 4, 8, 67, 1, 0, // Skip to: 12598
/* 12275 */   MCD::OPC_Decode, 217, 2, 218, 1, // Opcode: ADD32ak
/* 12280 */   MCD::OPC_FilterValue, 4, 57, 1, 0, // Skip to: 12598
/* 12285 */   MCD::OPC_Decode, 215, 2, 219, 1, // Opcode: ADD32ai
/* 12290 */   MCD::OPC_FilterValue, 14, 47, 1, 0, // Skip to: 12598
/* 12295 */   MCD::OPC_ExtractField, 3, 6,  // Inst{8-3} ...
/* 12298 */   MCD::OPC_FilterValue, 0, 5, 0, 0, // Skip to: 12308
/* 12303 */   MCD::OPC_Decode, 169, 3, 226, 1, // Opcode: ASR8di
/* 12308 */   MCD::OPC_FilterValue, 1, 5, 0, 0, // Skip to: 12318
/* 12313 */   MCD::OPC_Decode, 149, 4, 226, 1, // Opcode: LSR8di
/* 12318 */   MCD::OPC_FilterValue, 3, 5, 0, 0, // Skip to: 12328
/* 12323 */   MCD::OPC_Decode, 253, 7, 226, 1, // Opcode: ROR8di
/* 12328 */   MCD::OPC_FilterValue, 4, 5, 0, 0, // Skip to: 12338
/* 12333 */   MCD::OPC_Decode, 168, 3, 223, 1, // Opcode: ASR8dd
/* 12338 */   MCD::OPC_FilterValue, 5, 5, 0, 0, // Skip to: 12348
/* 12343 */   MCD::OPC_Decode, 148, 4, 223, 1, // Opcode: LSR8dd
/* 12348 */   MCD::OPC_FilterValue, 7, 5, 0, 0, // Skip to: 12358
/* 12353 */   MCD::OPC_Decode, 252, 7, 223, 1, // Opcode: ROR8dd
/* 12358 */   MCD::OPC_FilterValue, 8, 5, 0, 0, // Skip to: 12368
/* 12363 */   MCD::OPC_Decode, 165, 3, 227, 1, // Opcode: ASR16di
/* 12368 */   MCD::OPC_FilterValue, 9, 5, 0, 0, // Skip to: 12378
/* 12373 */   MCD::OPC_Decode, 145, 4, 227, 1, // Opcode: LSR16di
/* 12378 */   MCD::OPC_FilterValue, 11, 5, 0, 0, // Skip to: 12388
/* 12383 */   MCD::OPC_Decode, 249, 7, 227, 1, // Opcode: ROR16di
/* 12388 */   MCD::OPC_FilterValue, 12, 5, 0, 0, // Skip to: 12398
/* 12393 */   MCD::OPC_Decode, 164, 3, 224, 1, // Opcode: ASR16dd
/* 12398 */   MCD::OPC_FilterValue, 13, 5, 0, 0, // Skip to: 12408
/* 12403 */   MCD::OPC_Decode, 144, 4, 224, 1, // Opcode: LSR16dd
/* 12408 */   MCD::OPC_FilterValue, 15, 5, 0, 0, // Skip to: 12418
/* 12413 */   MCD::OPC_Decode, 248, 7, 224, 1, // Opcode: ROR16dd
/* 12418 */   MCD::OPC_FilterValue, 16, 5, 0, 0, // Skip to: 12428
/* 12423 */   MCD::OPC_Decode, 167, 3, 228, 1, // Opcode: ASR32di
/* 12428 */   MCD::OPC_FilterValue, 17, 5, 0, 0, // Skip to: 12438
/* 12433 */   MCD::OPC_Decode, 147, 4, 228, 1, // Opcode: LSR32di
/* 12438 */   MCD::OPC_FilterValue, 19, 5, 0, 0, // Skip to: 12448
/* 12443 */   MCD::OPC_Decode, 251, 7, 228, 1, // Opcode: ROR32di
/* 12448 */   MCD::OPC_FilterValue, 20, 5, 0, 0, // Skip to: 12458
/* 12453 */   MCD::OPC_Decode, 166, 3, 225, 1, // Opcode: ASR32dd
/* 12458 */   MCD::OPC_FilterValue, 21, 5, 0, 0, // Skip to: 12468
/* 12463 */   MCD::OPC_Decode, 146, 4, 225, 1, // Opcode: LSR32dd
/* 12468 */   MCD::OPC_FilterValue, 23, 5, 0, 0, // Skip to: 12478
/* 12473 */   MCD::OPC_Decode, 250, 7, 225, 1, // Opcode: ROR32dd
/* 12478 */   MCD::OPC_FilterValue, 33, 5, 0, 0, // Skip to: 12488
/* 12483 */   MCD::OPC_Decode, 182, 8, 226, 1, // Opcode: SHL8di
/* 12488 */   MCD::OPC_FilterValue, 35, 5, 0, 0, // Skip to: 12498
/* 12493 */   MCD::OPC_Decode, 247, 7, 226, 1, // Opcode: ROL8di
/* 12498 */   MCD::OPC_FilterValue, 37, 5, 0, 0, // Skip to: 12508
/* 12503 */   MCD::OPC_Decode, 181, 8, 223, 1, // Opcode: SHL8dd
/* 12508 */   MCD::OPC_FilterValue, 39, 5, 0, 0, // Skip to: 12518
/* 12513 */   MCD::OPC_Decode, 246, 7, 223, 1, // Opcode: ROL8dd
/* 12518 */   MCD::OPC_FilterValue, 41, 5, 0, 0, // Skip to: 12528
/* 12523 */   MCD::OPC_Decode, 178, 8, 227, 1, // Opcode: SHL16di
/* 12528 */   MCD::OPC_FilterValue, 43, 5, 0, 0, // Skip to: 12538
/* 12533 */   MCD::OPC_Decode, 243, 7, 227, 1, // Opcode: ROL16di
/* 12538 */   MCD::OPC_FilterValue, 45, 5, 0, 0, // Skip to: 12548
/* 12543 */   MCD::OPC_Decode, 177, 8, 224, 1, // Opcode: SHL16dd
/* 12548 */   MCD::OPC_FilterValue, 47, 5, 0, 0, // Skip to: 12558
/* 12553 */   MCD::OPC_Decode, 242, 7, 224, 1, // Opcode: ROL16dd
/* 12558 */   MCD::OPC_FilterValue, 49, 5, 0, 0, // Skip to: 12568
/* 12563 */   MCD::OPC_Decode, 180, 8, 228, 1, // Opcode: SHL32di
/* 12568 */   MCD::OPC_FilterValue, 51, 5, 0, 0, // Skip to: 12578
/* 12573 */   MCD::OPC_Decode, 245, 7, 228, 1, // Opcode: ROL32di
/* 12578 */   MCD::OPC_FilterValue, 53, 5, 0, 0, // Skip to: 12588
/* 12583 */   MCD::OPC_Decode, 179, 8, 225, 1, // Opcode: SHL32dd
/* 12588 */   MCD::OPC_FilterValue, 55, 5, 0, 0, // Skip to: 12598
/* 12593 */   MCD::OPC_Decode, 244, 7, 225, 1, // Opcode: ROL32dd
/* 12598 */   MCD::OPC_Fail,
  0
};

static const uint8_t InstrLenTable[] = {
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
0,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
32,
16,
16,
32,
16,
32,
32,
48,
16,
32,
32,
48,
16,
32,
32,
48,
32,
48,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
32,
16,
48,
16,
32,
32,
32,
32,
32,
64,
32,
32,
16,
32,
32,
32,
16,
48,
32,
48,
48,
48,
80,
32,
48,
16,
32,
32,
32,
16,
64,
48,
64,
64,
64,
64,
16,
32,
32,
16,
32,
32,
32,
48,
32,
48,
48,
48,
16,
16,
16,
48,
32,
32,
32,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
16,
32,
16,
32,
32,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
16,
32,
32,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
32,
48,
48,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
32,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
48,
80,
48,
48,
64,
80,
48,
64,
48,
64,
64,
48,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
16,
16,
32,
48,
16,
32,
16,
32,
32,
16,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
32,
64,
32,
32,
48,
64,
32,
48,
32,
48,
48,
32,
16,
48,
0,
16,
0,
32,
0,
48,
16,
0,
32,
0,
16,
0,
32,
0,
32,
0,
16,
80,
48,
48,
64,
64,
48,
64,
48,
64,
64,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
48,
16,
16,
32,
32,
16,
32,
16,
32,
32,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
32,
48,
48,
32,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
64,
32,
48,
32,
48,
64,
32,
48,
32,
48,
32,
48,
48,
32,
48,
48,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
16,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
32,
16,
16,
16,
16,
16,
16,
16,
32,
16,
32,
32,
16,
32,
32,
32,
16,
32,
48,
16,
32,
32,
48,
32,
48,
16,
32,
32,
32,
16,
16,
32,
48,
16,
32,
32,
32,
16,
32,
64,
16,
48,
32,
64,
16,
32,
32,
16,
32,
32,
32,
32,
48,
16,
32,
32,
48,
16,
16,
16,
16,
32,
16,
32,
16,
16,
32,
16,
48,
16,
32,
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  llvm_unreachable("Invalid index!");
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 22, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 48, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 48, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 48, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 60, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 32, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 32, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 44, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 32, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 98:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 100:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 113:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 115:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 119:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 135:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 136:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 137:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 138:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 139:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 140:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 141:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 142:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 143:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 3, 1);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 144:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 145:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 146:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 147:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 148:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 149:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 150:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 151:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 152:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 153:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 154:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 155:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 156:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 157:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 158:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 159:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 160:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 161:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 6, 1), 3, 1);
    insertBits(tmp, fieldFromInstruction(insn, 9, 3), 0, 3);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 162:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 163:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 16, 16), 16, 16);
    insertBits(tmp, fieldFromInstruction(insn, 32, 16), 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 164:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 165:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 166:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 167:
    return S;
  case 168:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 169:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 170:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 171:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 172:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 173:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 174:
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 175:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 176:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 177:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 178:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 179:
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 180:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 181:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    if (!Check(S, DecodeCCRCRegisterClass(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 182:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 183:
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 184:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 185:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 186:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 187:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 188:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 189:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 190:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 191:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 192:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 193:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 194:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 195:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 196:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 197:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 198:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 199:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 200:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 201:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 202:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 203:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 204:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 205:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 206:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 207:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 208:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 209:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 210:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 211:
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 212:
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 213:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 214:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 215:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 216:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 217:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 218:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 28, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 219:
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeAR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 16, 32);
    if (!Check(S, DecodeImm32(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 220:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 221:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 222:
    tmp = fieldFromInstruction(insn, 0, 4);
    if (!Check(S, DecodeXR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 223:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 224:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 225:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 226:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 227:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR16RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 228:
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    if (!Check(S, DecodeDR32RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI,
                                      llvm::function_ref<void(APInt &, uint64_t)> makeUp) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      makeUp(insn, Start + Len);
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      uint64_t Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      makeUp(insn, Start + Len);
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      Len = InstrLenTable[Opc];
      makeUp(insn, Len);
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      uint64_t PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      uint64_t NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // end namespace llvm
